package net.sf.JRecord.Details.schema;

import net.sf.JRecord.Details.AbstractLayoutDetails;
import net.sf.JRecord.External.ExternalRecord;
import net.sf.JRecord.External.ToExternalRecord;

public class MultiFormatSchema  implements IMultiFormatSchema{
	private ExternalRecord rec;
	private AbstractLayoutDetails schema;
	private final boolean isXRecord, isDerivedTypes;
	
	public static final MultiFormatSchema ENPTY_SCHEMA = new MultiFormatSchema(false, null, null);
	
	public MultiFormatSchema(ExternalRecord rec) { 
		this(false, rec, null);
	}
	public MultiFormatSchema(boolean derivedTypes, AbstractLayoutDetails schema) { 
		this(derivedTypes, null, schema);
	}

	
	private MultiFormatSchema(boolean derivedTypes, ExternalRecord rec, AbstractLayoutDetails schema) {
		super();
		this.rec = rec;
		this.schema = schema;
		this.isXRecord = rec != null;
		this.isDerivedTypes = derivedTypes;
	}
	
	@Override
	public ExternalRecord asExternalRecord() {
		if (rec == null && schema != null) {
			rec = ToExternalRecord.getInstance().getExternalRecord(schema, schema.getLayoutName(), 0);
		}
		return rec;
	}

	@Override
	public AbstractLayoutDetails asAbstractLayoutDetails() {
		if (schema == null && rec != null) {
			schema = rec.asLayoutDetail() ;
		}
		return schema;
	}

	@Override
	public boolean isExternalRecord() {
		return isXRecord;
	}
	
	@Override
	public boolean isTypesDerived() {
		return isDerivedTypes;
	}
}
