/**
 *
 */
package net.sf.RecordEditor.copy;


import java.io.FileOutputStream;

import net.sf.RecordEditor.re.layoutSelection.def.IUserLayoutSelection;
import net.sf.RecordEditor.re.util.wizard.TwoLayoutsWizard;
import net.sf.RecordEditor.xml.classes.CopyDefinition;
import net.sf.RecordEditor.xml.classes.WriteXml;

/**
 * @author Bruce Martin
 *
 */
public class CopyTwoLayouts extends TwoLayoutsWizard<CopyDefinition> {

	private CopyWizardFinalPnl finalScreen;


	/**
	 * Create Single layout
	 * @param selection record layout selection class
	 */
	public CopyTwoLayouts(IUserLayoutSelection selection1, IUserLayoutSelection selection2,
			String recentFiles) {
		this(selection1,
			 selection2,
			 new net.sf.RecordEditor.xml.classes.CopyDefinition(),
			 recentFiles);
	}


	/**
	 * Create Single layout
	 * @param selection1 record layout selection class
	 * @param definition record filter definition
	 */
	public CopyTwoLayouts(IUserLayoutSelection selection1, IUserLayoutSelection selection2,
			CopyDefinition definition, String recentFiles) {
		super("Standard Copy", definition);

		finalScreen = new CopyWizardFinalPnl(selection1, selection2);

		definition.type = CopyDefinition.STANDARD_COPY;

		super.setUpPanels(selection1, selection2, recentFiles, finalScreen, "", false, true, null);
	}



	/**
	 * @see net.sf.RecordEditor.utils.wizards.AbstractWizard#finished(java.lang.Object)
	 */
	@Override
	public void finished(CopyDefinition details) {

		if (finalScreen.isToRun()) {
			finalScreen.run();
		}
	}
	
	@Override
	protected void saveAsXml(CopyDefinition save) throws Exception {
		
		new WriteXml(new FileOutputStream(save.saveFile))
				.writeCopyDefinition(save);
				
		
	}

}