package net.sf.RecordEditor.copy;

import java.util.List;

import net.sf.JRecord.Details.AbstractLayoutDetails;
import net.sf.RecordEditor.edit.util.WriteLinesAsXml;
import net.sf.RecordEditor.re.layoutSelection.def.IUserLayoutSelection;
import net.sf.RecordEditor.re.tree.TreeParserRecord;
import net.sf.RecordEditor.re.tree.TreeToXml;
import net.sf.RecordEditor.xml.classes.CopyDefinition;
import net.sf.RecordEditor.xml.classes.RecordParent;

public class DoCopy2Xml {

	public void copyFile(IUserLayoutSelection layoutReader1, CopyDefinition copy) throws Exception {

		AbstractLayoutDetails layout = layoutReader1.getRecordLayout(
				copy.getOldfile().getLayoutDetails().name, copy.getOldfile().name);
		
		System.out.println(" Copy Xml:  " + layout.getRecordCount()  );
		if (layout.getRecordCount() > 1 && copy.getOldfile().getLayoutDetails() != null) {
			layout = layout.getFilteredLayout(copy.getOldfile().getLayoutDetails().getFilteredRecords());
		}
		
		net.sf.RecordEditor.re.file.FileView view = new net.sf.RecordEditor.re.file.FileView(
					copy.getOldfile().name, layout, true);
		
		if (layout.hasChildren()) {
			new net.sf.RecordEditor.re.tree.ChildTreeToXml(copy.getNewfile().name,  view.getLines());
		} else if (layout.getRecordCount() == 1) {
			new WriteLinesAsXml(copy.getNewfile().name, view.getLines());
		} else {
			int idx;
	    	List<RecordParent> parentRelationship = copy.getTreeDefinition().getParentRelationship();
	    	int[] parentIdxs = new int[layout.getRecordCount()];
	    	
	    	for (int i = 0; i < parentIdxs.length; i++) {
	    		parentIdxs[i] =  net.sf.JRecord.Common.Constants.NULL_INTEGER;
	    	}
	    	for (RecordParent p : parentRelationship) {
				idx = layout.getRecordIndex(p.recordName);
				if (idx >= 0) {
					parentIdxs[idx] = layout.getRecordIndex(p.parentName);
				}
	    	}

	    	TreeParserRecord parser = new TreeParserRecord(parentIdxs);
	
			new TreeToXml(copy.getNewfile().name, parser.parse(view));
		}
	}
	
	public static DoCopy2Xml newCopy() {
		return new DoCopy2Xml();
	}
}
