/**
 *
 */
package net.sf.RecordEditor.copy;

import javax.swing.JComponent;

import net.sf.JRecord.Details.AbstractLayoutDetails;
import net.sf.RecordEditor.re.file.filter.BaseFieldSelection;
import net.sf.RecordEditor.re.layoutSelection.def.IFormatFileName;
import net.sf.RecordEditor.re.layoutSelection.def.IUserLayoutSelection;
import net.sf.RecordEditor.utils.common.Common;
import net.sf.RecordEditor.utils.wizards.AbstractWizardPanel;
import net.sf.RecordEditor.xml.classes.CopyDefinition;
import net.sf.recordEditor.ui.xEnvironment.SwingUtils;

/**
 * @author Bruce Martin
 *
 */
@SuppressWarnings("serial")
public class FieldSelection extends BaseFieldSelection implements AbstractWizardPanel<CopyDefinition> {

	private CopyDefinition values;
	private String lastLayoutName1 = "";

	private IUserLayoutSelection selection1;


	private static final AbstractLayoutDetails layout2 = null;

	/**
	 * @param layoutSelection
	 */
	public FieldSelection(IUserLayoutSelection layoutSelection1,
			IFormatFileName layoutSelection2,
			String helpName) {
		super();

		selection1 = layoutSelection1;

		if (helpName != null & ! "".equals(helpName)) {
			setHelpURLre(Common.formatHelpURL(helpName));
		}
	}


	/**
	 * @see net.sf.RecordEditor.utils.wizards.AbstractWizardPanel#getValues()
	 */
	@Override
	public CopyDefinition getValues() throws Exception {
		String sold = values.getOldfile().getLayoutDetails().name;

		values.getOldfile().layoutDetails = super.getFilter().getExternalLayout();
		values.getOldfile().getLayoutDetails().name = sold;

		return values;
	}

	/**
	 * @see net.sf.RecordEditor.utils.wizards.AbstractWizardPanel#setValues(net.sf.RecordEditor.xml.classes.DiffDefinition)
	 */
	@Override
	public void setValues(CopyDefinition detail) throws Exception {

		values = detail;

		if (! lastLayoutName1.equalsIgnoreCase(values.getOldfile().getLayoutDetails().name)) {
			super.setRecordLayout(selection1.getRecordLayout(values.getOldfile().getLayoutDetails().name),
					layout2, false, SwingUtils.values().COMBO_TABLE_ROW_HEIGHT * 4);
			super.getFilter().updateFromExternalLayout(detail.getOldfile().getLayoutDetails());

			lastLayoutName1 = values.getOldfile().getLayoutDetails().name;
		}
	}


	/**
	 * @see net.sf.RecordEditor.utils.wizards.AbstractWizardPanel#getComponent()
	 */
	@Override
	public JComponent getComponent() {
		return this;
	}


	/**
	 * @see net.sf.RecordEditor.utils.wizards.AbstractWizardPanel#isMore()
	 */
	@Override
	public boolean skip() {
		return false;
	}
}
