/**
 *
 */
package net.sf.RecordEditor.diff;

import javax.swing.JComponent;

import net.sf.RecordEditor.re.file.filter.BaseFieldSelection;
import net.sf.RecordEditor.re.layoutSelection.def.IUserLayoutSelection;
import net.sf.RecordEditor.utils.common.Common;
import net.sf.RecordEditor.utils.wizards.AbstractWizardPanel;
import net.sf.RecordEditor.xml.classes.DiffDefinition;
import net.sf.recordEditor.ui.xEnvironment.SwingUtils;

/**
 * @author Bruce Martin
 *
 */
@SuppressWarnings("serial")
public class CmpFieldSelection extends BaseFieldSelection implements AbstractWizardPanel<DiffDefinition> {

	private DiffDefinition values;
	private IUserLayoutSelection selection;
	private String lastLayoutName = "";
	private boolean toInit = true;

	/**
	 * @param layout
	 * @param addExecute
	 */
	public CmpFieldSelection(IUserLayoutSelection layoutSelection) {
		super();

		selection = layoutSelection;
		//super.done();
		setHelpURLre(Common.formatHelpURL(Common.HELP_DIFF_SL));
	}

	/**
	 * @see net.sf.RecordEditor.utils.wizards.AbstractWizardPanel#getComponent()
	 */
	@Override
	public JComponent getComponent() {
		return this;
	}

	/**
	 * @see net.sf.RecordEditor.utils.wizards.AbstractWizardPanel#getValues()
	 */
	@Override
	public DiffDefinition getValues() throws Exception {
		String sold = values.getLayoutDetails().name;

		values.setLayoutDetails(super.getFilter().getExternalLayout());
		values.getLayoutDetails().name = sold;
		return values;
	}



	/**
	 * @see net.sf.RecordEditor.utils.wizards.AbstractWizardPanel#setValues(java.lang.Object)
	 */
	@Override
	public void setValues(DiffDefinition detail) throws Exception {
		values = detail;

		if (! lastLayoutName.equalsIgnoreCase(values.getLayoutDetails().name)) {
			super.setRecordLayout(
					selection.getRecordLayout(values.getLayoutDetails().name),
					null, false,
					SwingUtils.values().NORMAL_FIELD_HEIGHT * 4);
			lastLayoutName = values.getLayoutDetails().name;
			toInit = true;
		}

		if (toInit) {
			super.getFilter().updateFromExternalLayout(values.getLayoutDetails());
			toInit = false;
		}
	}

	/**
	 * @see net.sf.RecordEditor.utils.wizards.AbstractWizardPanel#isMore()
	 */
	@Override
	public boolean skip() {
		return false;
	}
}
