package net.sf.RecordEditor.diff.result;

public class CompareBlockResult {

	final LineCompareResult compareResult;
	final int lines, compareLineNumber, skip, oldLineNumber, newLineNumber;
	
	public CompareBlockResult(
			int compareLineNumber, int skip, int oldLineNumber, int newLineNumber, int lines, 
			LineCompareResult compareResult) {
		super();
		
		this.compareResult = compareResult;
		this.skip = skip;
		this.lines = lines;
		this.compareLineNumber = compareLineNumber;
		this.oldLineNumber = oldLineNumber;
		this.newLineNumber = newLineNumber;
	}
	
	public int nextCompareLineNumber() {
		return compareLineNumber + lines;
	}
	public int nextOldLineNumber() {
		return compareResult.oldPresent ? oldLineNumber+lines : oldLineNumber;
	}
	
	public int nextNewLineNumber() {
		return compareResult.newPresent ? newLineNumber+lines : newLineNumber;
	}

	public boolean contains(int row) {
		return compareLineNumber <= row && row < compareLineNumber+lines;
	}
}
