package net.sf.RecordEditor.diff.result;

import java.io.IOException;

import jlibdiff.Diff;
import net.sf.JRecord.Details.AbstractLayoutDetails;
import net.sf.RecordEditor.diff.LineBufferedReader;

public class CompareFiles implements ICompareFiles {
	private Diff diff = new Diff();
	private VisitorBlockResult vis;

	public CompareFiles(LineBufferedReader oldReader, LineBufferedReader newReader) throws IOException {
		vis = new VisitorBlockResult(oldReader, newReader);
		diff.diffBuffer(oldReader, newReader);
		diff.accept(vis);
	}
	
	@Override
	public ICompareSummary toCompareSummary() {
		return new CompareSummary(vis);
	}

	@Override
	public boolean isDifferent() {
		return vis.isDifferent();
	}

	@Override
	public AbstractLayoutDetails getLayout() {
		return vis.getLayout();
	}
}
