package net.sf.RecordEditor.diff.result;

import net.sf.JRecord.Details.AbstractLine;
import net.sf.RecordEditor.utils.fileStorage.LineChunk;

public class LineCompare implements IResultCodes, ILineCompare {

	private static final LineCompareResult[] RESULTS = LineCompareResult.values();
	
	protected final AbstractLine line;
		
	public final int lineNo;
	public int code;
	
	public LineCompare(int lineCode, int lineNumber, AbstractLine actualLine) {
		line   = actualLine instanceof LineChunk ? actualLine.getNewDataLine() : actualLine;
		lineNo = lineNumber;
		code   = lineCode;
	}

	@Override
	public int getLineNumber() {
		return lineNo;
	}

	@Override
	public LineCompareResult getCompareResult() {
		return code < 0 || code > RESULTS.length ? null : RESULTS[code] ;
	}

	@Override
	public AbstractLine getLine() {
		return line;
	}
	
	
}
