package net.sf.RecordEditor.diff.result;

import java.util.ArrayList;
import java.util.List;

import jlibdiff.HunkAdd;
import jlibdiff.HunkChange;
import jlibdiff.HunkDel;
import jlibdiff.HunkVisitor;
import net.sf.JRecord.Details.AbstractLayoutDetails;
import net.sf.JRecord.Details.AbstractLine;
import net.sf.RecordEditor.diff.LineBufferedReader;

public class VisitorBlockResult extends HunkVisitor {

	
	private LineBufferedReader oldR, newR;
//	private ArrayList<LineCompare> oldList, newList, oldChanged, newChanged;
	private ArrayList<CompareBlockResult> compareList = new ArrayList<CompareBlockResult>();
//	private CompareBlockResult current = new CompareBlockResult(0, 0, 0, 0, LineCompareResult.UNCHANGED);
	private int cmpPos = 0;
	private int leftOverCount=0;
//	private int lastOldPos = 1;
	private int oldPos = 1;
	private int newPos = 1;
	
	private boolean fin = false;
	private boolean different = false;
	
	
	public VisitorBlockResult(LineBufferedReader oldReader, LineBufferedReader newReader) {
		oldR = oldReader;
		newR = newReader;
	}
	
	@Override
	public void visitHunkAdd(HunkAdd arg0) {

//		System.out.print("Insert  ... " + arg0.lowLine(0) + " " + arg0.highLine(0)
//				+ " ~ " + + arg0.lowLine(1) + " " + arg0.highLine(1)
//				+ " / " + arg0.numLines(0) + " / " + arg0.numLines(1)
//				+ " ! " + oldPos + " ~ " + newPos );

		addCmpBlock(
				//arg0.lowLine(0), arg0.lowLine(1), 
				arg0.lowLine(1) - newPos,
				arg0.highLine(1) - arg0.lowLine(1)+1, LineCompareResult.INSERT);
//		System.out.println( " >> " + oldPos + " ~ " + newPos);
	}

	@Override
	public void visitHunkChange(HunkChange arg0) {
		
		int oldDiff = arg0.highLine(0) - arg0.lowLine(0);
		int newDiff = arg0.highLine(1) - arg0.lowLine(1);

		int minDiff = Math.min(oldDiff, newDiff);
//
//		System.out.print("Change  ... " + arg0.lowLine(0) + " " + arg0.highLine(0)
//				+ " ~ " + + arg0.lowLine(1) + " " + arg0.highLine(1)
//				+ " / " + arg0.numLines(0) + " / " + arg0.numLines(1)
//				+ " ! " + oldPos + " ~ " + newPos );
		
		addCmpBlock(
				//arg0.lowLine(0), arg0.lowLine(1), 
				arg0.lowLine(1) - newPos,
				minDiff+1, LineCompareResult.CHANGED);
		
	
		if (oldDiff > newDiff) {
			addCmpBlock(
					//arg0.lowLine(0) + minDiff, 
					//arg0.lowLine(1) + minDiff,
					0,
					oldDiff - newDiff, LineCompareResult.DELETED);
		} else if (oldDiff < newDiff) {
			addCmpBlock(
					//arg0.lowLine(0) + minDiff,
					//arg0.lowLine(1) + minDiff, 
					0,
					newDiff - oldDiff , LineCompareResult.INSERT);
		}
//		System.out.println( " >> " + oldPos + " ~ " + newPos);

//		System.out.println();
//		System.out.println();


//		int oldDiff = arg0.highLine(0) - arg0.lowLine(0);
//		int newDiff = arg0.highLine(1) - arg0.lowLine(1);
//		//arg0.getNewContents().
//		//arg0.get
//		
//		copySkipped(arg0);
//		copyOld(arg0.lowLine(0), arg0.highLine(0), LineCompare.CHANGED);
//		copyNew(arg0.lowLine(1), arg0.highLine(1), LineCompare.CHANGED);
//		
//		copy(oldChanged, oldR, arg0.lowLine(0), arg0.highLine(0), LineCompare.CHANGED);
//		//System.out.println("~~~> " + oldChanged.size() + " " + arg0.lowLine(0) + " " + arg0.highLine(0));
//		copy(newChanged, newR, arg0.lowLine(1), arg0.highLine(1), LineCompare.CHANGED);
//		
//		//System.out.print(" ==> " + oldDiff + " " + newDiff);
//		if (oldDiff > newDiff) {
//			int count = oldDiff - newDiff;
//			for (int i = 1; i <= count; i++) {
//				oldChanged.get(oldChanged.size() - i).code = LineCompare.DELETED;
//				oldList.get(oldList.size() - i).code = LineCompare.DELETED;
//			}
//			addNull(newChanged, 1, count, LineCompare.DELETED);			
//			addNull(newList, 1, count, LineCompare.DELETED);			
//		} else if (oldDiff < newDiff) {
//			int count = newDiff - oldDiff;
//			for (int i = 1; i <= count; i++) {
//				newChanged.get(newChanged.size() - i).code = LineCompare.INSERT;
//				newList.get(newList.size() - i).code = LineCompare.INSERT;
//			}
//			addNull(oldChanged, 1, count, LineCompare.INSERT);			
//			addNull(oldList, 1, count, LineCompare.INSERT);			
//		}
//		different = true;
//		System.out.println(">>>> " + oldList.size() + " " + newList.size());
	}

	@Override
	public void visitHunkDel(HunkDel arg0) {
//		System.out.println("Delete   ... " + arg0.lowLine(0) + " " + arg0.highLine(0)
//				+ " ~ " + + arg0.lowLine(1) + " " + arg0.highLine(1)
//				+ " / " + arg0.numLines(0) + " / " + arg0.numLines(1));
		
//		copySkipped(arg0);
//		int low = arg0.lowLine(0);
//		int high = arg0.highLine(0);
//		copyOld(low, high, LineCompare.DELETED);
//		copyNew(arg0.highLine(1), arg0.highLine(1), LineCompare.UNCHANGED);
//		addNull(newList, low, high, LineCompare.DELETED);
//
//		
//		copy(   oldChanged, oldR, low, high, LineCompare.DELETED);
////		System.out.println("Delete Add Null " + (arg0.highLine(0) - arg0.lowLine(0) + 1 )
////				+ " " + arg0.highLine(0) + " " + arg0.lowLine(0));
//		addNull(newChanged, low, high, LineCompare.DELETED);
//		System.out.print("Delete  ... " + arg0.lowLine(0) + " " + arg0.highLine(0)
//				+ " ~ " + + arg0.lowLine(1) + " " + arg0.highLine(1)
//				+ " / " + arg0.numLines(0) + " / " + arg0.numLines(1)
//				+ " ! " + oldPos + " ~ " + newPos);
		
		addCmpBlock(
				//arg0.lowLine(0), arg0.lowLine(1), 
				arg0.lowLine(0) - oldPos,
				arg0.highLine(0) - arg0.lowLine(0) + 1, LineCompareResult.DELETED);

//		System.out.println( " >> " + oldPos + " ~ " + newPos);

//		System.out.println();
//		System.out.println();

//		different = true;
	}
	
	private void addCmpBlock( int skip, int count, LineCompareResult cmmpResult) {
		int oldPosAdj = cmmpResult == LineCompareResult.INSERT   ? 0 :  count;
		int newPosAdj = cmmpResult == LineCompareResult.DELETED  ? 0 :  count;
//		int diff = oldBlockPos - lastOldPos;
		
		oldPos += skip;
		newPos += skip;
		
//		lastOldPos = oldBlockPos;
		
		if (count > 0) {
			compareList.add(new CompareBlockResult(
					cmpPos, skip, oldPos, newPos, count, cmmpResult));
			
			oldPos += oldPosAdj;
			newPos += newPosAdj;
			
			cmpPos += count;
			different = true;
		}
	}
	

	public ICompareSummary toCompareSummary() {
		return new CompareSummary(this);
	}

	ArrayList<CompareBlockResult> getChangeList() {
		check();
		return compareList;
	}

	private ArrayList<CompareBlockResult> fullList;
	ArrayList<CompareBlockResult> getFullList() {
		if (fullList == null) {
			check();
			fullList = new ArrayList<CompareBlockResult>();
			
			int //pos=0,
				oldLineNumber = 1,
				newLineNumber = 1,
				lineNumber = 0;
			
			for (int i =0; i < compareList.size(); i++) {
				CompareBlockResult cmpResult = compareList.get(i);
	//			int unchangedLines = cmpResult.compareResult == LineCompareResult.INSERT
	//					? cmpResult.newLineNumber - newLineNumber
	//					: cmpResult.oldLineNumber - oldLineNumber;
				lineNumber = addUnchangedLines(
						fullList, lineNumber, 
						oldLineNumber, newLineNumber, 
						cmpResult.skip); 			
				CompareBlockResult compareResult = 
						lineNumber == cmpResult.compareLineNumber
							? cmpResult
							: new CompareBlockResult(
									lineNumber, 0, cmpResult.oldLineNumber, cmpResult.newLineNumber, cmpResult.lines, 
									cmpResult.compareResult);
				fullList.add(compareResult);
				
				//pos += cmpResult.nextOldLineNumber() - 1;
				lineNumber = compareResult.nextCompareLineNumber();
				oldLineNumber = compareResult.nextOldLineNumber();
				newLineNumber = compareResult.nextNewLineNumber();
			}
//			System.out.println();
//			System.out.println("UnChanged . " + lineNumber + ", "
//						+ oldLineNumber + ", " + newLineNumber + " ~ " + leftOverCount);
//			System.out.println();

			addUnchangedLines(fullList, lineNumber, oldLineNumber, newLineNumber, leftOverCount);
		}
		return fullList;
	}

	/**
	 * @param fullList
	 * @param pos
	 * @param oldLineNumber
	 * @param newLineNumber
	 * @param unchangedLines
	 */
	private int addUnchangedLines(ArrayList<CompareBlockResult> fullList, int pos, int oldLineNumber,
			int newLineNumber, int unchangedLines) {
		if (unchangedLines > 0) {
			fullList.add(new CompareBlockResult(
					pos, 0, oldLineNumber, newLineNumber, unchangedLines, 
					LineCompareResult.UNCHANGED));
			pos += unchangedLines;
		}
		return pos;
	}

	
	private void check() {
		
		if (! fin) {
			int oldPos = 0;
			int newPos = 0;
			if (compareList.size() > 0) {
				CompareBlockResult lastResult = compareList.get(compareList.size() -1);
				oldPos = lastResult.nextOldLineNumber();
				newPos = lastResult.nextNewLineNumber();
			}


			int oldCount = oldR.getCount();
			int newCount = newR.getCount();
			
			int oldRemaining = oldCount - oldPos+1;
			int newRemaining = newCount - newPos+1;
//			int commonCount = Math.min(oldRemaining, newRemaining);
//			addCmpBlock(
//					oldPos, newPos, commonCount, LineCompareResult.UNCHANGED);

			if (oldRemaining < newRemaining) {
				addCmpBlock(
						0,
						//oldPos+commonCount, newPos+commonCount, 
						newRemaining - oldRemaining, LineCompareResult.INSERT);
			} else if (oldRemaining > newRemaining){
				addCmpBlock(
						0,
						//oldPos+commonCount, newPos+commonCount, 
						oldRemaining - newRemaining, LineCompareResult.DELETED);
			} else {
				leftOverCount = oldRemaining;
			}
		}
		fin = true;
	}

	public boolean isDifferent() {
		return different || oldR.getCount() != newR.getCount();
	}
	
	List<AbstractLine> getOldLines() {
		return oldR.getLines();
	}
	
	List<AbstractLine> getNewLines() {
		return newR.getLines();
	}

	public AbstractLayoutDetails getLayout() {
		return oldR.getLayout();
	}
}
