package net.sf.RecordEditor.edit.display.Action;

import java.awt.event.ActionEvent;

import net.sf.RecordEditor.re.display.AbstractFileDisplay;
import net.sf.RecordEditor.re.layoutSelection.def.ILayoutSelectCreator;
import net.sf.RecordEditor.utils.lang.ReSpecificScreenAction;
import net.sf.RecordEditor.utils.screenManager.IActiveCheckActive;

@SuppressWarnings("serial")
public class ChangeLayoutAction extends ReSpecificScreenAction implements IActiveCheckActive {

	private ILayoutSelectCreator<?> creator;


	/**
	 * @param creator
	 */
	public ChangeLayoutAction(ILayoutSelectCreator<?> layoutSelectionCreator) {
		super("Change Layout");
		this.creator = layoutSelectionCreator;
		checkActionEnabled();
	}

	/**
	 * @see net.sf.RecordEditor.utils.screenManager.IActiveCheckActive#checkActionEnabled()
	 */
	@Override
	public void checkActionEnabled() {
		AbstractFileDisplay display = getDisplay(AbstractFileDisplay.class);
		super.setEnabled(display != null && display.getFileView() != null && ! display.getFileView().isBrowse());
	}

	@Override
	public void actionPerformed(ActionEvent arg0) {
		AbstractFileDisplay sourcePnl = getDisplay(AbstractFileDisplay.class);
		if (sourcePnl != null) {
			new net.sf.RecordEditor.edit.display.util.ChangeLayout(creator.create(), sourcePnl.getFileView());
		}
	}
}
