package net.sf.RecordEditor.edit.display.Action;

import java.awt.Font;
import java.awt.Frame;
import java.awt.event.ActionEvent;

import javax.swing.WindowConstants;

import io.github.dheid.fontchooser.FontDialog;
import net.sf.RecordEditor.edit.display.interfaces.IGetSetTableFont;
import net.sf.RecordEditor.utils.lang.ReAbstractAction;
import net.sf.RecordEditor.utils.lang.ReSpecificScreenAction;
import net.sf.RecordEditor.utils.screenManager.IActiveCheckActive;


/**
 * Update the font in JTable
 * @author Bruce Martin
 *
 */
@SuppressWarnings("serial")
public class FontChooseCurrentScreen extends ReAbstractAction implements IActiveCheckActive {


	public FontChooseCurrentScreen() {
		super("Table Font Chooser (Current Screen)");
	}

	/* (non-Javadoc)
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	@Override
	public void actionPerformed(ActionEvent e) {
		
		IGetSetTableFont display = ReSpecificScreenAction.getDisplay(IGetSetTableFont.class);
		if (display != null) {
			Font font = display.getTableFont();
			FontDialog dialog = new FontDialog((Frame) null, "Select Font", true);
			
			dialog.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
	        dialog.setSelectedFont(font);
	        dialog.setVisible(true);
	        if (!dialog.isCancelSelected()) {
	        	display.setTableFont(dialog.getSelectedFont());
	        }
			
		}
	}

	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.utils.screenManager.AbstractActiveScreenAction#checkActionEnabled()
	 */
	@Override
	public void checkActionEnabled() {
		super.setEnabled(ReSpecificScreenAction.getDisplay(IGetSetTableFont.class) != null);
	}

	
	
}
