package net.sf.RecordEditor.edit.display.Action;

import java.awt.Font;
import java.awt.Frame;
import java.awt.event.ActionEvent;

import javax.swing.WindowConstants;

import io.github.dheid.fontchooser.FontDialog;
import net.sf.RecordEditor.edit.display.common.UserSelectedFontManager;
import net.sf.RecordEditor.edit.display.interfaces.ISetTableFont;
import net.sf.RecordEditor.utils.lang.ReAbstractAction;
import net.sf.RecordEditor.utils.screenManager.ReFrame;


/**
 * Update the font in JTable
 * 
 * @author Bruce Martin
 *
 */
@SuppressWarnings("serial")
public class FontChooseSetDefaultFont extends ReAbstractAction {


	public FontChooseSetDefaultFont() {
		super("Table Font Chooser (Permanent)");
		
//		super.setEnabled(true);
	}

	/* (non-Javadoc)
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	@Override
	public void actionPerformed(ActionEvent e) {

		FontDialog dialog = new FontDialog((Frame) null, "Select Table Font (permanent change)", true);
		
		dialog.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
        dialog.setSelectedFont(UserSelectedFontManager.TABLE_FONT_MGR.getFont());
        dialog.setVisible(true);
        if (!dialog.isCancelSelected()) {
        	Font font = dialog.getSelectedFont();
        	UserSelectedFontManager.TABLE_FONT_MGR.setFont(font);
        	ReFrame[] frames = ReFrame.getAllFrames();
    		for (ReFrame frame : frames) {
    			if (frame instanceof ISetTableFont) {
    				((ISetTableFont) frame).setTableFont(font);
    			}
    		}
        }
	
	}
	
}
