package net.sf.RecordEditor.edit.display.Action;

import java.awt.event.ActionEvent;

import javax.swing.Icon;

import net.sf.RecordEditor.re.layoutSelection.def.ILayoutSelectCreator;
import net.sf.RecordEditor.utils.common.ReActionHandler;
import net.sf.RecordEditor.utils.lang.ReAbstractAction;
import net.sf.RecordEditor.utils.screenManager.ReFrame;
import net.sf.recordEditor.ui.icons.IconManager;

@SuppressWarnings("serial")
public class NewFileAction extends ReAbstractAction {
	private ILayoutSelectCreator<?> create;
	
	public static NewFileAction toolBar(ILayoutSelectCreator<?> layoutSelectCreate) {
		return new NewFileAction(layoutSelectCreate, IconManager.ICONS.documentNew.toolbarIcon());
	}
	
	public static NewFileAction normal(ILayoutSelectCreator<?> layoutSelectCreate) {
		return new NewFileAction(layoutSelectCreate, IconManager.ICONS.documentNew.icon());
	}

	public NewFileAction(ILayoutSelectCreator<?> layoutSelectCreate, Icon icon) {
		super("New File", icon);//Common.ID_NEW_ICON);
		create = layoutSelectCreate;
	}

	public void actionPerformed(ActionEvent e) {
		ReActionHandler actionHandler = ReFrame.getActionHandler();
		int newActionId = net.sf.RecordEditor.utils.common.ReActionHandler.NEW;
		if (actionHandler != null && actionHandler.isActionAvailable(newActionId)) {
			actionHandler.executeAction(newActionId);
		} else {
			new net.sf.RecordEditor.edit.display.util.NewFile(create.create());
		}
    }

}
