package net.sf.RecordEditor.edit.display.Action;

import java.awt.Toolkit;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.event.ActionEvent;

import net.sf.RecordEditor.edit.util.NewCsvFilePasteTable;
import net.sf.RecordEditor.utils.common.Common;
import net.sf.RecordEditor.utils.lang.ReAbstractAction;
import net.sf.RecordEditor.utils.screenManager.IActiveCheckActive;


/**
 * 
 * @author bruce
 *
 */
@SuppressWarnings("serial")
public class PasteAsCsvFile extends ReAbstractAction implements IActiveCheckActive {

	public PasteAsCsvFile() {
		super("Paste as New Csv File");
	}
	
	@Override
	public void actionPerformed(ActionEvent e) {
		Clipboard system = Toolkit.getDefaultToolkit().getSystemClipboard();
		
		try {
			Transferable contents = system.getContents(this);
			if (contents.isDataFlavorSupported(DataFlavor.stringFlavor)) {
				new NewCsvFilePasteTable((String) (contents.getTransferData(DataFlavor.stringFlavor)));
			} else {
				Common.logMsg("Nothing to paste", null);
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			Common.logMsg("Error: " + ex, ex);
		}
	}

	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.utils.screenManager.IActiveCheckActive#checkActionEnabled()
	 */
	@Override
	public void checkActionEnabled() {
		// TODO Auto-generated method stub
		
	}

	
	
}
