package net.sf.RecordEditor.edit.display.common;

import java.awt.Font;

import net.sf.RecordEditor.utils.params.Parameters;
import net.sf.recordEditor.ui.xEnvironment.SwingUtils;

public class UserSelectedFontManager {

    
    private static final String FONT_NAME  = "Name";
    private static final String FONT_STYLE = "Style";
	private static final String FONT_SIZE  = "Size";
    
    public static final UserSelectedFontManager TABLE_FONT_MGR = new UserSelectedFontManager("tblFont");

	private Font font;
	private String id;
	private int fontSize = -1;
	private UserSelectedFontManager(String id) {
		try {
			String s = Parameters.getString(id + FONT_SIZE);
			
			this.id = id;
			if (s != null && s.length() > 0) {
				fontSize = Integer.parseInt(s);
				font = new Font(
								Parameters.getString(id + FONT_NAME),
								Integer.parseInt(Parameters.getString(id + FONT_STYLE)),
								fontSize
						);
						
			}
		} catch (Exception e) {
		}
	}

	
	/**
	 * @return the tblFont
	 */
	public Font getFont() {
		return font;
	}

	/**
	 * @param tblFont the tblFont to set
	 */
	public void setFont(Font tblFont) {
		Parameters.setSavePropertyChanges(false);
		if (tblFont == null || tblFont.equals(SwingUtils.values().DEFAULT_TABLE_FONT)) {
			Parameters.setProperty(id + FONT_NAME, null);
			Parameters.setProperty(id + FONT_STYLE, null);
			Parameters.setProperty(id + FONT_SIZE, null);
		} else {
			Parameters.setProperty(id + FONT_NAME,  tblFont.getFamily());
			Parameters.setProperty(id + FONT_STYLE, tblFont.getStyle());
			Parameters.setProperty(id + FONT_SIZE,  tblFont.getSize());
		}
		Parameters.setSavePropertyChanges(true);
		this.font = tblFont;
	}


	public int getFontSize() {
		return fontSize;
	}

}
