package net.sf.RecordEditor.edit.open;

import java.awt.Dimension;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.io.File;
import java.net.URL;
import java.util.Iterator;

import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JMenu;
import javax.swing.JSplitPane;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;
import javax.swing.SwingUtilities;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import net.sf.JRecord.Details.AbstractLayoutDetails;
import net.sf.JRecord.Details.IGetSchema;
import net.sf.JRecord.Details.schema.IMultiFormatSchema;
import net.sf.JRecord.Details.schema.MultiFormatSchema;
import net.sf.JRecord.IO.AbstractLineIOProvider;
import net.sf.JRecord.Log.AbsSSLogger;
import net.sf.RecordEditor.layoutWizard.WizardFileLayoutCsv;
import net.sf.RecordEditor.re.file.FileView;
import net.sf.RecordEditor.re.layoutSelection.def.IFormatFileName;
import net.sf.RecordEditor.re.openFile.IOpenFileInterface;
import net.sf.RecordEditor.re.openFile.RecentFiles;
import net.sf.RecordEditor.re.openFile.RecentFilesList;
import net.sf.RecordEditor.re.schema.IGetSchemaAndFields;
import net.sf.RecordEditor.re.util.csv.CsvSelectionPanel;
import net.sf.RecordEditor.re.util.csv.CsvTabPane;
import net.sf.RecordEditor.re.util.csv.SchemaSelection;
import net.sf.RecordEditor.re.util.fw.FixedWidthSelectionPane;
import net.sf.RecordEditor.re.util.openTabPane.IFilePreview;
import net.sf.RecordEditor.utils.common.Common;
import net.sf.RecordEditor.utils.interfaces.IGetFileName;
import net.sf.RecordEditor.utils.lang.LangConversion;
import net.sf.RecordEditor.utils.lang.ReAbstractAction;
import net.sf.RecordEditor.utils.params.BoolOpt;
import net.sf.RecordEditor.utils.params.IBooleanOption;
import net.sf.RecordEditor.utils.params.Parameters;
import net.sf.RecordEditor.utils.screenManager.ReFrame;
import net.sf.RecordEditor.utils.screenManager.ReMainFrame;
import net.sf.RecordEditor.utils.swing.BaseHelpPanel;
import net.sf.RecordEditor.utils.swing.BasePanel;
import net.sf.RecordEditor.utils.swing.favourite.UpdatableParameterList;
import net.sf.RecordEditor.utils.swing.filechooser.IFileChanged;
import net.sf.RecordEditor.utils.swing.filechooser.IFileChooserWrapper;
import net.sf.RecordEditor.utils.swing.filechooser.JrFileChooserBldr;
import net.sf.recordEditor.ui.def.FileChooserDefs;
import net.sf.recordEditor.ui.fileFields.params.FileFieldParamBldr;
import net.sf.recordEditor.ui.icons.IconManager;
import net.sf.recordEditor.ui.xEnvironment.SwingUtils;

@SuppressWarnings("serial")
public class OpenCsvFilePnl
extends BaseHelpPanel 
implements IOpenFileInterface, IFormatFileName, IGetSchemaAndFields, IGetFileName {


    private static final String CSV_FILE_DESCRIPTION = "CSV file";

	private final static int NORMAL_CSV  = 0,
                             UNICODE_CSV = 1;

	private final IBooleanOption showCsvFChooserOptions = new BoolOpt(
			Parameters.CSV_SHOW_FILECHOOSER_OPTIONS,
			Parameters.isWindowsLAF());

//    private JFileChooser chooser = new JFileChooser();
    private final IFileChooserWrapper chooser;
    protected RecentFiles recent;
    private RecentFilesList recentList;
//    private	ByteTextReader reader = new ByteTextReader();

    private JTextArea msgTxt = new JTextArea();
    private AbstractLineIOProvider ioProvider;
    private final CsvTabPane csvTabDtls; // = new CsvTabPane(msgTxt, true, true);
//    private FileFilter csvFilter;



    //private File file;
    private boolean execEnter = true;

    public final KeyAdapter keyListner = new KeyAdapter() {
        /**
         * @see java.awt.event.KeyAdapter#keyReleased
         */
        public final void keyReleased(KeyEvent event) {

            if (execEnter && event.getKeyCode() == KeyEvent.VK_ENTER) {
                //System.out.println("Key Listner");
                openFile(false);
             }
        }
    };

    private IFileChanged chgListner = new IFileChanged() {
        private String lastFileName = "";
		
		@Override
		public void fileChanged(File selectedFile) {
            if ((selectedFile.isFile()) &&  (! lastFileName.equals(selectedFile.getPath()))) {
                lastFileName = selectedFile.getPath();
                readFilePreview(selectedFile, true);
            }
		}
	};
//    private PropertyChangeListener chgListner = new PropertyChangeListener() {
//        private String lastFileName = "";
//
//        @Override
//        public void propertyChange(PropertyChangeEvent e) {
//            String pname = e.getPropertyName();
//            //System.out.println("\nProperty Change " + pname
//            //		+ " " + JFileChooser.SELECTED_FILE_CHANGED_PROPERTY.equals(pname));
//            if (JFileChooser.SELECTED_FILE_CHANGED_PROPERTY.equals(pname)) {
//              File f = (File) e.getNewValue();
//
//              if ((f != null) && (f.isFile()) &&  (! lastFileName.equals(f.getPath()))) {
//                  lastFileName = f.getPath();
//                  readFilePreview(f, true);
//              }
//            }
//        }
//    };

    private ActionListener goAction = new ActionListener() {
        @Override
        public void actionPerformed(ActionEvent arg0) {
            openFile(true);
        }
    };

    private ActionListener chooserListner = new ActionListener() {

        /* (non-Javadoc)
         * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
         */
        @Override
        public void actionPerformed(ActionEvent evt) {

            if (JFileChooser.CANCEL_SELECTION.equals(evt.getActionCommand())) {

            } else {
            	openFile(false);
            }
        }
    };

    private ChangeListener tabListner = new ChangeListener() {

            @Override
            public void stateChanged(ChangeEvent e) {
            //chooser.dispatchEvent(null);

                JTabbedPane tabPane = csvTabDtls.getTabPane();
				tabPane.removeChangeListener(this);
                try {
	                //int idx = csvTabDtls.tab.getSelectedIndex();
	                //System.out.println("\nTab changed ");
	
	                //execEnter = false;
	                //execEnter();
	
	                //csvTabDtls.tab.setSelectedIndex(idx);
	                readFilePreview(chooser.getSelectedFile(), false);
	                ReMainFrame.getMasterFrame().checkIfActionsAvailable();
                } finally {
                	tabPane.addChangeListener(this);
                }
            }
    };

    public OpenCsvFilePnl(
            final String fileName,
            final String propertiesFiles,
            AbstractLineIOProvider pIoProvider,
            boolean fixedXmlTabs,
            boolean edit,
            boolean mainScreen) {
        String defaultDirectory = Common.OPTIONS.DEFAULT_FILE_DIRECTORY.get();

        ioProvider = pIoProvider;
 		recent = RecentFiles.getMainRecentFiles(propertiesFiles, this, true, true, true, defaultDirectory);
 		
 		if (mainScreen) {
 			recentList = recent.recentFilesList(this, true);
 		} else {
 			recentList = recent.getRecentFileList();
 		}
        csvTabDtls = new CsvTabPane(msgTxt, fixedXmlTabs, fixedXmlTabs, true, true, new CsvWizardAction());

        //boolean filePresent = true;
        //File file;
        String fname = fileName;
        URL helpname = Common.formatHelpURL(Common.HELP_CSV_EDITOR);
//        if (fname == null && Common.OPTIONS.useLastDir.isSelected()) {
//        	fname = recent.getLastDirectory();
//        }
//        if (fname == null || "".equals(fname)) {
//            fname = defaultDirectory;
//            filePresent = false;
//        }

        File file = OpenCommon.getOpenDirectory(recent, fname, defaultDirectory);
        if (file != null) {
	        fname = file.getPath();
        }

        UpdatableParameterList favFileList = UpdatableParameterList.newFileList(Parameters.CSV_EDIT_FAV + "." + UpdatableParameterList.FILES, 25, false);
		UpdatableParameterList favDirectoryList = UpdatableParameterList.newDirectoryList(Parameters.CSV_EDIT_FAV + "." + UpdatableParameterList.DIRECTORIES, 25, false);
		FileFieldParamBldr opts = recent.fileFieldParam()
			.favouriteFiles(favFileList)
			.favouriteDirectory(favDirectoryList);
		
        if (showCsvFChooserOptions.isSelected()) {
        	opts.chooserType(FileChooserDefs.FileChooserType.open);
        	//chooser.setDialogType(JFileChooser.OPEN_DIALOG);
        } else {
        	opts.showControlButtons(FileChooserDefs.ControlButtonDisplay.FILTERS);
        }

		
		chooser = JrFileChooserBldr.newChooserCsvEditor(ReFrame.getDesktopWidth(), fname, opts);
        		//recent, Parameters.CSV_EDIT_FAV);
		
		chooser.setApproveButtonText("Edit");


        setHelpURLre(helpname);
        setTab(csvTabDtls.csvDetails,        helpname);
        setTab(csvTabDtls.unicodeCsvDetails, helpname);

        if (fixedXmlTabs) {
            setTab(csvTabDtls.fixedWidthPanel,      helpname);
            setTab(csvTabDtls.schemaSelectionPanel, helpname);
            setTab(csvTabDtls.xmlSelectionPanel,    helpname);
            setTab(csvTabDtls.otherSelectionPanel,  helpname);
            setTab(csvTabDtls.regExpPreview,        helpname);
       }

        registerComponentRE(chooser.getDisplayItem());
        registerComponentRE(csvTabDtls.getTabPane());


    	//JFileChooser fc = chooser.getFileChooser();
        chooser.addActionListener(chooserListner);
        csvTabDtls.addEditAction(goAction);

        try {
//            FileFilter filter = chooser.getFileFilter();
//
//            csvFilter = new javax.swing.filechooser.FileNameExtensionFilter("CSV file", "csv", "tsv");
            
            chooser.addFileExtension("Text file", "txt");
            chooser.addFileExtension(CSV_FILE_DESCRIPTION, "csv", "tsv");
            chooser.addFileExtension("CSV/Text file", "csv", "tsv", "txt");
//            chooser.addChoosableFileFilter(new javax.swing.filechooser.FileNameExtensionFilter("Text file", "txt"));
//            chooser.addChoosableFileFilter(csvFilter);
//            chooser.addChoosableFileFilter(new javax.swing.filechooser.FileNameExtensionFilter("CSV/Text file", "csv", "tsv", "txt"));

            if (fixedXmlTabs) {
                chooser.addFileExtension("CSV/XML file", "csv", "tsv", "xml");
                chooser.addFileExtension("CSV/XML file", "csv", "tsv", "xml");
//                chooser.addChoosableFileFilter(new javax.swing.filechooser.FileNameExtensionFilter("CSV/XML file", "csv", "tsv", "xml"));
//            	chooser.addChoosableFileFilter(new javax.swing.filechooser.FileNameExtensionFilter("Xml file", "xml"));
            }
            //chooser.setFileFilter(filter);
        } catch (NoClassDefFoundError e) {

        }


        SwingUtils.addKeyListnerToContainer(chooser.getDisplayItem(), keyListner);
        SwingUtils.addKeyListnerToContainer(csvTabDtls.getTabPane(), keyListner);

        chooser.addFileChangedListner(chgListner);
//        if (showCsvFChooserOptions.isSelected()) {
//        	chooser.setDialogType(JFileChooser.OPEN_DIALOG);
//        } else {
//            chooser.setControlButtonsAreShown(false);
//        }
        csvTabDtls.getTabPane().addChangeListener(tabListner);

        if (file != null && file.isFile()) {
            readFilePreview(file, true);
            if (edit || "Y".equalsIgnoreCase(Parameters.getString(Parameters.BYPASS_RECSVEDIT_PREVIEW))) {
            	IFilePreview selectedCsvDetails = csvTabDtls.getSelectedCsvDetails();
            	if (selectedCsvDetails instanceof FixedWidthSelectionPane || selectedCsvDetails instanceof SchemaSelection) {
            		
            	} else {
            		SwingUtilities.invokeLater(new Runnable() {
						@Override public void run() {
							openFile(false);
						}
					});
            	}
            }
        }
    }

    private void setTab(IFilePreview pnl, URL helpname) {
        JButton go = pnl.getGoButton();

        pnl.setHelpURL(helpname);

        go.setIcon(IconManager.ICONS.documentEdit.icon());

        go.setText(LangConversion.convert(LangConversion.ST_BUTTON, "Edit"));
        //go.addActionListener(goAction);
    }


    private void openFile(boolean executeEnter) {
    	//JFileChooser fc = chooser.getFileChooser();
        File f = chooser.getSelectedFile();
        try {
            //System.out.println("openFile " + executeEnter);
            if (executeEnter) {
                execEnter();
            }
            File f1 = chooser.getSelectedFile();
            if (! f1.equals(f)) {
                f = f1;
                readFilePreview(f, true);
            }
        } catch (Exception ex) {
            //ex.printStackTrace();
        }

 		IFilePreview csvpnl = csvTabDtls.getSelectedCsvDetails();
        if (f != null && f.getPath() != null) {
            try {
                AbstractLayoutDetails l = getSchema(csvpnl, IGetSchema.SCHEMA_DEFAULT);

                if (l != null) {
                    FileView file
                        = new FileView(
                                    l,
                                    ioProvider,
                                    false);
                    StartEditor startEditor = new StartEditor(file, f.getPath(), l.isReadOnly(), msgTxt, 0);

                    recent.putFileLayout(f.getPath(), csvpnl.getFileDescription());
                    chooser.updateRecentDirectories(recent.getDirectoryList());

                    startEditor.doEdit();
                }
            } catch (Exception e) {
                Common.logMsg(AbsSSLogger.ERROR, "Error Loading File:", e.getMessage(), null);
                e.printStackTrace();
            }

        }
	}

	@Override
	public Iterator<String> getFieldIterator(int recordIdx, int fieldIdx) {
		IFilePreview csvpnl = csvTabDtls.getSelectedCsvDetails();
		return csvpnl== null ? null : csvpnl.getFieldIterator(recordIdx, fieldIdx);
	}

	/* (non-Javadoc)
	 * @see net.sf.JRecord.Details.IGetSchema#getSchema()
	 */
	@Override
	public final IMultiFormatSchema getSchema(int schemaType) {
		IFilePreview selectedCsvDetails = csvTabDtls.getSelectedCsvDetails();
		if (schemaType == IGetSchema.SCHEMA_DERIVE_TYPE && selectedCsvDetails instanceof CsvSelectionPanel) {
			return new MultiFormatSchema(
							true,
							((CsvSelectionPanel) selectedCsvDetails).getLayout(true, selectedCsvDetails.getFontName(), null));
		}
		return new MultiFormatSchema(false, getSchema(selectedCsvDetails, schemaType));
	}
	

	/* (non-Javadoc)
	 * @see net.sf.JRecord.Details.IGetSchema#schemaAvailable4checking()
	 */
	@Override
	public int schemaChecking() {
		IFilePreview selectedCsvDetails = csvTabDtls.getSelectedCsvDetails();
		return selectedCsvDetails == null 
				? IGetSchema.ST_NO_CHECK_ON_SCHEMA 
				: selectedCsvDetails.getSchemaCheckType();
	}


	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.utils.interfaces.IGetFileName#getFileName()
	 */
	@Override
	public String getFileName() {
    	//JFileChooser fc = chooser.getFileChooser();
        File f = chooser.getSelectedFile();

		return f == null ? null : f.getPath();
	}

	/**
	 * @param csvpnl
	 * @return
	 */
	private AbstractLayoutDetails getSchema(IFilePreview csvpnl, int schemaType) {
		return csvpnl.getLayout(csvpnl.getFontName(), null, schemaType);
	}

    private void execEnter() {

    	try {
            execEnter = false;
            //JFileChooser fc = chooser.getFileChooser();

            chooser.removeActionListener(chooserListner);
            chooser.clickOpenBtn(true);

    	} finally {
            execEnter = true;

    		chooser.addActionListener(chooserListner);
    	}
    }

    @Override
    public void done() {
        JSplitPane splitPane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, 
				chooser.getDisplayItem(), 
				csvTabDtls.getTabPane());
        splitPane.setResizeWeight(0.5);
		addComponentRE(0, 5, BasePanel.FILL, BasePanel.GAP,
                BasePanel.FULL, BasePanel.FULL,
                splitPane);
        addMessage(msgTxt);
        setHeightRE(BasePanel.NORMAL_HEIGHT * 3);

        this.addMouseListener(csvTabDtls.getPopAction());
        super.done();
    }



    @Override
    public int getCurrentDbIdentifier() {
        return 0;
    }



    @Override
    public String getCurrentDbName() {
        return null;
    }



    @Override
    public String getCurrentFileName() {
        return chooser.getSelectedFile().getPath();
    }

    @Override
	public void setCurrentFileName(String filename) {
		File file = OpenCommon.adjustForDirectory(filename);
        File f = chooser.getSelectedFile();
        if (file != null && ! file.equals(f)) {
			chooser.setSelectedFile(file);

            readFilePreview(file, true);
            //selectDisplayPanel(file);
        }

	}


    /* (non-Javadoc)
	 * @see net.sf.RecordEditor.re.openFile.IOpenFileInterface#getCurrentDirectoryName()
	 */
	@Override
	public String getCurrentDirectoryName() {
		return chooser.getCurrentDirectory().getPath();
	}

	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.re.openFile.IOpenFileInterface#setCurrentDirectoryName(java.lang.String)
	 */
	@Override
	public void setCurrentDirectoryName(String fileName) {
		File directory = new File(fileName);
		
		if (directory.exists() && directory.isDirectory()) {
			chooser.setCurrentDirectory(directory);
		}
	}

	@Override
    public void setRecordLayout(int layoutId, String layoutName, String filename) {
    	//JFileChooser fc = chooser.getFileChooser();
    	JTabbedPane tabPane = csvTabDtls.getTabPane();
		try {
    		chooser.removeActionListener(chooserListner);
    		chooser.removeFileChangedListner(chgListner);
			tabPane.removeChangeListener(tabListner);

			File file = OpenCommon.adjustForDirectory(filename);
			chooser.setSelectedFile(file);
    		if (layoutName == null || "".equals(layoutName)) {

    		} else {
    			if (layoutName.startsWith(CsvSelectionPanel.NORMAL_CSV_STRING)) {
    				csvTabDtls.csvDetails.setFileDescription(layoutName);
    				csvTabDtls.readCheckPreview(file, false, layoutName);
    				csvTabDtls.setTabCode(NORMAL_CSV);
    			} else if (layoutName.startsWith(CsvSelectionPanel.UNICODE_CSV_STRING)) {
    				csvTabDtls.unicodeCsvDetails.setFileDescription(layoutName);
    				csvTabDtls.setTabCode(UNICODE_CSV);
    				csvTabDtls.readCheckPreview(file, false, layoutName);
    			} else {
    				File f = new File(layoutName);
					if (f .exists()) {
    					//file = f;
    					if (csvTabDtls.schemaSelectionPanel != null) {
    						csvTabDtls.setTabCode(CsvTabPane.SCHEMA);
    						csvTabDtls.schemaSelectionPanel.setLayoutFile(layoutName);
    						csvTabDtls.readCheckPreview(file, false, layoutName);
    					}
    				}
    			}
    		}
    	} catch (Exception e) {
    		e.printStackTrace();
    	} finally {
    		chooser.addActionListener(chooserListner);
    		chooser.addFileChangedListner(chgListner);
    		tabPane.addChangeListener(tabListner);
    	}
    }



    @Override
    public BasePanel getPanel() {
        return this;
    }

    public final void selectCsvExt() {
    	//TODO
//        if (csvFilter != null) {
//            chooser.setFileFilter(csvFilter);
//        }
    }
    

    private void readFilePreview(File f, boolean allowTabSwap) {
        String layoutDtls = null;
        try {
            layoutDtls = recent.getLayoutName(f.getCanonicalPath(), f, 2);
        } catch (Exception e) {
            // TODO: handle exception
        }
        Rectangle r = this.getBounds();
        this.setPreferredSize(new Dimension(r.width, r.height));
//		System.out.println(" !%%! 1 " + this.getPreferredSize().height + " " + this.getBounds().height
//				+ " " + this.getHeight());
        csvTabDtls.readCheckPreview(f, allowTabSwap, layoutDtls);
//		this.setBounds(r);
        super.validate();

//		System.out.println(" !%%! 2 " + this.getPreferredSize().height + " " + this.getBounds().height
//				+ " " + this.getHeight());
    }

    @Override
    public JMenu getRecentFileMenu() {
        return recentList.getMenu();
    }
    

	@Override
	public JMenu getRecentDirectoryMenu() {
		return recentList.getDirectoryMenu();
	}



    /* (non-Javadoc)
     * @see net.sf.RecordEditor.utils.openFile.FormatFileName#formatLayoutName(java.lang.String)
     */
    @Override
    public String formatLayoutName(String layoutName) {
        return layoutName;
    }

    public void setParentFrame(ReFrame parentFrame) {
        csvTabDtls.setParentFrame(parentFrame);
    }
    
    private class CsvWizardAction extends ReAbstractAction {
    	CsvWizardAction() {
    		super("Csv Wizard", Common.ID_WIZARD_ICON);
    	}

		@Override
		public void actionPerformed(ActionEvent e) {
	
			new WizardFileLayoutCsv(
					new ReFrame("", "Csv File Wizard", null), OpenCsvFilePnl.this, 
					chooser.getSelectedFile().getPath(),
					getSchema(IGetSchema.SCHEMA_DEFAULT).asAbstractLayoutDetails(), true, true);
		}
    	
    	
    }
}
