package net.sf.RecordEditor.re.cobol;

import javax.swing.JMenu;

import net.sf.JRecord.Details.IGetSchema;
import net.sf.RecordEditor.re.codeGen.CodeGenAction;
import net.sf.RecordEditor.re.codeGen.CodeGenTreeAction;
import net.sf.RecordEditor.re.codeGen.TemplateOption;
import net.sf.RecordEditor.utils.common.Common;
import net.sf.RecordEditor.utils.screenManager.ReMainFrame;
import net.sf.RecordEditor.utils.swing.SwingUtilsBldr;


public class GenerateMenu {
	public final JMenu generateMenu = SwingUtilsBldr.newMenu("Generate");
	
	public void bldMenu(ReMainFrame f) {
	    JMenu javaGen = new JMenu("Java Code");
	    JMenu pythonGen = new JMenu("Python/Ruby Code");
	    generateMenu.add(new JRecCodeGenAction());
	    generateMenu.add(f.addAction(new CodeGenTreeAction(IGetSchema.SCHEMA_DEFAULT)));
	    generateMenu.add(javaGen);
	    generateMenu.add(pythonGen);
	    generateMenu.addSeparator();
	    generateMenu.add(new ReMainFrame.ShowURI("Generate Information", Common.formatHelpURI(Common.HELP_GENERATE)));

	    
	    javaGen.add(f.addAction(new CodeGenAction("JRecord IoBuilder", "javaJRec", false, TemplateOption.ANY, IGetSchema.SCHEMA_DEFAULT)));
	    javaGen.add(f.addAction(new CodeGenAction("JRecord LineWrapper", "javaJRecWrapper", false, TemplateOption.ANY, IGetSchema.SCHEMA_DEFAULT)));
	    javaGen.add(f.addAction(new CodeGenAction("JRecord LineWrapper: derive field types", "javaJRecWrapper", false, TemplateOption.CSV, IGetSchema.SCHEMA_DERIVE_TYPE)));
	    javaGen.add(f.addAction(new CodeGenAction("JRecord Pojo (Single Record Type)", "javaJRecPojo", false, TemplateOption.ANY, IGetSchema.SCHEMA_DEFAULT)));
	    javaGen.add(f.addAction(new CodeGenAction("JRecord Pojo (Single Record Type/derive field types)", "javaJRecPojo", false, TemplateOption.CSV, IGetSchema.SCHEMA_DERIVE_TYPE)));
	 /*   javaGen.add(f.addAction(new CodeGenAction("JRecord Pojo (Multi Record Type)", "javaJRecPojoMr", false, TemplateOption.ANY)));*/
	    
	    pythonGen.add(f.addAction(new CodeGenAction("Python Csv IO", "pyCsvIO", false, TemplateOption.TEXT_CSV, IGetSchema.SCHEMA_DERIVE_TYPE)));
	    pythonGen.add(f.addAction(new CodeGenAction("Python Csv IO (DictReader/Writer, IGetSchema.SCHEMA_DERIVE_TYPE)",
	    							"pyCsvDictIO", false, TemplateOption.TEXT_CSV, IGetSchema.SCHEMA_DERIVE_TYPE)));
	    pythonGen.add(f.addAction(new CodeGenAction("Python Pandas Csv IO", "pyCsvPandas", false, TemplateOption.TEXT_CSV, IGetSchema.SCHEMA_DERIVE_TYPE)));
	    pythonGen.add(f.addAction(new CodeGenAction("Python Fixed IO", "pyFixedIO", false, TemplateOption.TEXT_FIXED, IGetSchema.SCHEMA_DERIVE_TYPE)));
	    pythonGen.add(f.addAction(new CodeGenAction("Python Fixed Pandas", "pyFixedPandas", false, TemplateOption.TEXT_FIXED, IGetSchema.SCHEMA_DERIVE_TYPE)));
	    pythonGen.addSeparator();
	    pythonGen.add(f.addAction(new CodeGenAction("Ruby Csv IO", "rubyCsvIO", false, TemplateOption.TEXT_CSV, IGetSchema.SCHEMA_DERIVE_TYPE)));

	    generateMenu.setToolTipText("<html><b>Generate Code</b> to read/write the file currently selected/edited</html>"); 
	}
}
