package net.sf.RecordEditor.re.cobol;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JCheckBox;
import javax.swing.JEditorPane;

import net.sf.RecordEditor.utils.params.IUpdatableBooleanOption;
import net.sf.RecordEditor.utils.screenManager.ReFrame;
import net.sf.RecordEditor.utils.swing.BasePanel;
import net.sf.recordEditor.ui.xEnvironment.SwingUtils;

public class WarningScreen {

	private final IUpdatableBooleanOption option;
	
	private final ReFrame frame;
	private final JCheckBox displayChk = new JCheckBox("Show this warning in the future ???", true);
	
	public WarningScreen(String id, IUpdatableBooleanOption opt, String msg) {
		this.option = opt;
		this.frame = new ReFrame(id, "Warning Screen", null);
		
		BasePanel pnl = new BasePanel("WarningPnl");
		JEditorPane html = new JEditorPane("text/html", msg);
		html.setPreferredSize(new Dimension(
				SwingUtils.values().STANDARD_FONT_HEIGHT * 45,
				SwingUtils.values().STANDARD_FONT_WIDTH * 135));
		html.setCaretPosition(0);
		
		pnl.addComponentRE(
				1, 3, SwingUtils.values().STANDARD_FONT_HEIGHT * 50, 
				BasePanel.GAP1,
		        BasePanel.FULL, BasePanel.FULL, 
		        html); 
		pnl.addLineRE("", displayChk);
		
//		frame.setPreferredSize(new Dimension(
//				SwingUtils.values().STANDARD_FONT_HEIGHT * 25,
//				SwingUtils.values().STANDARD_FONT_WIDTH * 150));
		frame.addMainComponent(pnl);
		
		displayChk.addActionListener(new ActionListener() {
			@Override public void actionPerformed(ActionEvent e) {
				option.set(displayChk.isSelected());
			}
		});
		

		frame.setVisible(true);
	}
}
