package net.sf.RecordEditor.re.cobol.tree;

import java.util.List;

import javax.swing.JTree;
import javax.swing.tree.TreePath;

import net.sf.JRecord.External.ExternalRecord;
import net.sf.RecordEditor.utils.swing.BaseHelpPanel;
import net.sf.RecordEditor.utils.swing.BasePanel;
import net.sf.RecordEditor.utils.swing.treeTable.JTreeTable;


/**
 * 
 * 
 * 
 * @author Bruce Martin
 *
 */
public class CobolRecordDisplay {
	
	public final BaseHelpPanel pnl;
	public final JTreeTable treeTbl;
	private final CobolItemTreeModel cobolTreeMdl;
	
	public CobolRecordDisplay(ExternalRecord rec, BaseHelpPanel pnl) {
		double gap = pnl == null ? BaseHelpPanel.GAP1 : BaseHelpPanel.GAP;
		this.pnl   = pnl == null ? new BaseHelpPanel("CobolRec_" + rec.getRecordName()) : pnl;
		
		cobolTreeMdl = CobolItemTreeModel.newTreeModel(rec.getUpdatebleItems());
		treeTbl = new JTreeTable(cobolTreeMdl);
		
		treeTbl.setTableCellAdapter(cobolTreeMdl.newAdapter(treeTbl));
		treeTbl.setRowHeight(24);
		
		List<TreePath> paths = cobolTreeMdl.getFirstPaths(100);
		JTree tree = treeTbl.getTree();
		tree.setRootVisible(false);
		for (int i = 0; i < paths.size(); i++) {
			tree.expandPath(paths.get(i));
		}
		
		this.pnl.addComponentRE(1, 3, BasePanel.FILL, gap, BasePanel.FULL, BasePanel.FULL, treeTbl);
	}
	
	public void cobolUpdate(CobolItemTreeModel.IProcessCobolItem typeUpdate) {
		cobolTreeMdl.applyToTree(typeUpdate);
		treeTbl.fireTableDataChanged();
	}

	/**
	 * 
	 * @see net.sf.RecordEditor.re.cobol.tree.CobolItemTreeModel#updateCobolItemType()
	 */
	public void updateCobolItemType() {
		cobolTreeMdl.updateCobolItemType();
	}
}
