package net.sf.RecordEditor.re.codeGen;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JDialog;

import net.sf.JRecord.Details.LayoutDetail;
import net.sf.RecordEditor.utils.BasicLayoutCallback;
import net.sf.RecordEditor.utils.screenManager.ReFrame;
import net.sf.RecordEditor.utils.screenManager.ReMainFrame;
import net.sf.RecordEditor.utils.swing.SwingUtilsBldr;
import net.sf.recordEditor.ui.icons.IconManager;
import net.sf.recordEditor.ui.xEnvironment.SwingUtils;

/**
 * This class asks the user for CodeGen options.
 *  
 * @author Bruce Martin
 *
 */
public class CodeGenOptions implements ActionListener {
	

	
	public final JDialog dialog = new JDialog(ReMainFrame.getMasterFrame());
	private final CodeGenOptionsPnl optionPnl;
	
	private final JButton goBtn = SwingUtilsBldr.newButton("Generate Code", IconManager.ICONS.generate.icon());
	

	
	public CodeGenOptions(LayoutDetail schema, String template, String templateResourceDir, String dataFileName,
			BasicLayoutCallback callback) {
		super();
		optionPnl = new CodeGenOptionsPnl(schema, dataFileName, callback, goBtn, template, templateResourceDir);

		dialog.getContentPane().add(optionPnl.codeGenOptionPnl);
		Dimension ps = dialog.getPreferredSize();
		dialog.setPreferredSize(new Dimension( 
				Math.min(ReFrame.getDesktopWidth(), 
						 Math.max(ps.width, 70 * SwingUtils.values().CHAR_FIELD_WIDTH)), 
				Math.min(ReFrame.getDesktopHeight(),
						Math.max(ps.height, 17 * SwingUtils.values().CHAR_FIELD_HEIGHT))));

		dialog.pack();
		
		goBtn.addActionListener(this);

	}
	

	
//	
//	/**
//	 * @param b
//	 * @see java.awt.Dialog#setVisible(boolean)
//	 */
//	public void setVisible(boolean b) {
//		dialog.setVisible(b);
//	}


	/* (non-Javadoc)
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	@Override
	public void actionPerformed(ActionEvent e) {
		optionPnl.generateTemplate(dialog);
	}






}
