package net.sf.RecordEditor.re.codeGen;

import javax.swing.JDialog;
import javax.swing.JOptionPane;

import net.sf.JRecord.Details.AbstractLayoutDetails;
import net.sf.JRecord.Details.LayoutDetail;
import net.sf.JRecord.Details.schema.IMultiFormatSchema;
import net.sf.RecordEditor.re.schema.ICreateFieldIterator;
import net.sf.RecordEditor.utils.lang.ReOptionDialog;
import net.sf.RecordEditor.utils.screenManager.IActiveCheckActive;

@SuppressWarnings("serial")
public class CodeGenTreeAction extends AbstractCodeGenAction implements IActiveCheckActive {

	
	public CodeGenTreeAction(int schemaRetrieveOption) {
		super("Generate Code From File", schemaRetrieveOption);
	}

	

	protected JDialog createDialog(
			ICreateFieldIterator fieldIt,
			IMultiFormatSchema schema, IMultiFormatSchema schemaDeriveTypes, String ds,
			net.sf.RecordEditor.utils.BasicLayoutCallback callback) {
		return net.sf.RecordEditor.re.codeGen.CodeGenOptionWiz.newTreeWizard(
				fieldIt, schema, schemaDeriveTypes, ds, callback).dialog;
//		return (new  net.sf.RecordEditor.re.codeGen.GenerateSelection(
//				(LayoutDetail)schema.asAbstractLayoutDetails(), (LayoutDetail)schemaDeriveTypes.asAbstractLayoutDetails(),
//				ds, callback)).dialog;
	}

	protected boolean checkSchemaOk(AbstractLayoutDetails schema) {
		if (schema == null) { return false; };
		if ( (schema.getRecordCount() != 1)) {
			
			JOptionPane.showMessageDialog(null,
					"Only Single Record Type files are supported. This file has "
					+ schema.getRecordCount()  + " Files");
			return false;
		}
		if (schema.getRecord(0).getFieldCount() == 0) {
			ReOptionDialog.showMessageDialog(null, "No valid File schema available");
			return false;
		}
		return true;
	}

	protected boolean checkSchemaMatches(net.sf.RecordEditor.re.schema.IGetSchemaAndFields schemaSource, int schemaCheckingType) {

		AbstractLayoutDetails schema = schemaSource.getSchema(net.sf.RecordEditor.re.schema.IGetSchemaAndFields.SCHEMA_4_GEN).asAbstractLayoutDetails();
		return schema instanceof LayoutDetail && schema.getRecordCount() == 1;
	}
}
