package net.sf.RecordEditor.re.codeGen;

import java.awt.Dimension;

import javax.swing.JDialog;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTree;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.tree.TreePath;

import net.sf.JRecord.Details.LayoutDetail;
import net.sf.RecordEditor.edit.util.ReMessages;
import net.sf.RecordEditor.utils.BasicLayoutCallback;
import net.sf.RecordEditor.utils.screenManager.ReFrame;
import net.sf.RecordEditor.utils.screenManager.ReMainFrame;
import net.sf.recordEditor.ui.xEnvironment.SwingUtils;

/**
 * Display tree of Code-Skelton which the user can choose from.
 * 
 * @author Bruce Martin
 *
 */
public class GenerateSelection /*implements ActionListener*/ {

	public final JSplitPane mainPane;
	
//	private LayoutDetail schema;
	private final JTree templateTree;
	public final JDialog dialog = new JDialog(ReMainFrame.getMasterFrame());
	private final CodeGenOptionsPnl optionPnl;
	
//	private final JButton goBtn = SwingUtilsBldr.newButton("Generate Code", IconManager.ICONS.generate.icon());
	
	private GenerateTreeItem genItem;
	//private final LayoutDetail schemaDeriveTypes;


	public GenerateSelection(LayoutDetail schema, LayoutDetail schemaDeriveTypes, String dataFileName, BasicLayoutCallback callback) {

		//this.schemaDeriveTypes = schemaDeriveTypes;
		
		GenerateTreeItem rootNode = GenerateTreeItem.buildTree(schema.isCsvLayout());
		GenerateTreeItem[] path = {rootNode, null, null};

		//goBtn.setVisible(false);
		templateTree = new JTree(rootNode);
		optionPnl = new CodeGenOptionsPnl(schema, dataFileName, callback, null/*goBtn*/);
		optionPnl.tips.setText(ReMessages.FILE_CODEGEN.get());
		
		for (int i = 0; i < rootNode.getChildCount(); i++) {
			GenerateTreeItem node = rootNode.getChildAt(i);
			if (node.getChildCount() > 0) {
				path[1] = node;
				path[2] = node.getChildAt(0);
				
				templateTree.scrollPathToVisible(new TreePath(path));
			}
		}
		

		mainPane = new JSplitPane(
				JSplitPane.HORIZONTAL_SPLIT,
				new JScrollPane(templateTree), optionPnl.codeGenOptionPnl);
		
		mainPane.setResizeWeight(0.5);
		
		dialog.getContentPane().add(mainPane);
		Dimension ps = dialog.getPreferredSize();
		dialog.setPreferredSize(new Dimension( 
				Math.min(ReFrame.getDesktopWidth(), 
						 Math.max(ps.width, 70 * SwingUtils.values().CHAR_FIELD_WIDTH)), 
				Math.min(ReFrame.getDesktopHeight(),
						Math.max(ps.height, 17 * SwingUtils.values().CHAR_FIELD_HEIGHT))));

		dialog.pack();
		
		templateTree.setRootVisible(false);
		templateTree.addTreeSelectionListener(new TreeSelectionListener() {		
			@Override public void valueChanged(TreeSelectionEvent e) {
				TreePath treePath = e.getNewLeadSelectionPath();
				genItem = ((GenerateTreeItem) treePath.getLastPathComponent());
				
				if (genItem != null && genItem.template != null) {
					optionPnl.setTemplateDtls(genItem.template, genItem.templateDirectory);
					//goBtn.setVisible(true);
				}
			}
		});

//		goBtn.addActionListener(this);
	}
	
	
	public final GenerateTreeItem getGenItem() {
		return genItem;
	}


	
//	private long lastLong = 0;
//	/* (non-Javadoc)
//	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
//	 */
//	@Override
//	public void actionPerformed(ActionEvent e) {
//		if (e.getWhen() != lastLong && genItem != null) {
//			lastLong = e.getWhen();
//
//			if (genItem.schemaRetrieveOption == IGetSchema.SCHEMA_DERIVE_TYPE && schemaDeriveTypes != null) {
//				optionPnl.setSchema(schemaDeriveTypes);
//			}
//			optionPnl.generateTemplate(dialog);	
//		}
//	}
	
	
	public void generateTemplate(JDialog parent, LayoutDetail schema2Gen) {
		optionPnl.generateTemplate(parent, schema2Gen);
	}

}
