package net.sf.RecordEditor.re.codeGen;

import net.sf.JRecord.Details.IGetSchema;
import net.sf.recordEditor.ui.tree.ArrayListNode;


public class GenerateTreeItem extends ArrayListNode<GenerateTreeItem> {
	
	public static final String TEMPLATE_DIRECTORY = "/net/sf/RecordEditor/cg/velocity/";

	public static GenerateTreeItem buildTree(boolean isCsv) {
		
		GenerateTreeItem root = new GenerateTreeItem(null, "root", "");
		
		GenerateTreeItem javaNode = new GenerateTreeItem(root, "Java", "java");
		GenerateTreeItem pyNode = new GenerateTreeItem(root, "pythos/ruby", "");
		

	    new GenerateTreeItem(javaNode, "JRecord IoBuilder", "javaJRec",  TemplateOption.ANY, IGetSchema.SCHEMA_DEFAULT, "java", false);
	    new GenerateTreeItem(javaNode, "JRecord LineWrapper", "javaJRecWrapper",  TemplateOption.ANY, IGetSchema.SCHEMA_DEFAULT, "java", false);
	    
	    if (isCsv) {
		    new GenerateTreeItem(javaNode, "JRecord LineWrapper: derive field types", "javaJRecWrapper",  TemplateOption.CSV, IGetSchema.SCHEMA_DERIVE_TYPE, "java", false);
		    genPojo(javaNode);
	    	new GenerateTreeItem(javaNode, "JRecord Pojo (Single Record Type/derive field types)", "javaJRecPojo",  TemplateOption.CSV, IGetSchema.SCHEMA_DERIVE_TYPE, "java", false);
	    } else {
		    genPojo(javaNode);
	    }
	    
	    new GenerateTreeItem(pyNode, "Python Csv IO", "pyCsvIO",  TemplateOption.TEXT_CSV, IGetSchema.SCHEMA_DERIVE_TYPE, "py", false);
	    new GenerateTreeItem(pyNode, "Python Csv IO (DictReader/Writer, IGetSchema.SCHEMA_DERIVE_TYPE)",
	    							 "pyCsvDictIO",  TemplateOption.TEXT_CSV, IGetSchema.SCHEMA_DERIVE_TYPE, "py", false);
	    new GenerateTreeItem(pyNode, "Python Pandas Csv IO", "pyCsvPandas",  TemplateOption.TEXT_CSV, IGetSchema.SCHEMA_DERIVE_TYPE, "py", false);
	    new GenerateTreeItem(pyNode, "Python Fixed IO", "pyFixedIO",  TemplateOption.TEXT_FIXED, IGetSchema.SCHEMA_DERIVE_TYPE, "py", false);
	    new GenerateTreeItem(pyNode, "Python Fixed Pandas", "pyFixedPandas",  TemplateOption.TEXT_FIXED, IGetSchema.SCHEMA_DERIVE_TYPE, "py", false);

	    new GenerateTreeItem(pyNode, "Ruby Csv IO", "rubyCsvIO",  TemplateOption.TEXT_CSV, IGetSchema.SCHEMA_DERIVE_TYPE, "ruby", false);
		
	    return root;
	}
	/**
	 * @param javaNode
	 */
	private static void genPojo(GenerateTreeItem javaNode) {
		new GenerateTreeItem(javaNode, "JRecord Pojo (Single Record Type)", "javaJRecPojo",  TemplateOption.ANY, IGetSchema.SCHEMA_DEFAULT, "java", false);
	}
	

	
	public final TemplateOption schemaType;
	public final int schemaRetrieveOption;
	public final String template, lang, templateDirectory = TEMPLATE_DIRECTORY;
	public final boolean multiRecord;
	
	public GenerateTreeItem(GenerateTreeItem parent, String name, String lang) {
		this(parent, name, null, TemplateOption.PARENT_NODE, 0,  lang, false);
	}
	public GenerateTreeItem(GenerateTreeItem parent, String name,
			String template, TemplateOption schemaType, 
			int schemaRetrieveOption,  String lang, boolean multiRecord) {
		super(parent, name);
		this.schemaType = schemaType;
		this.schemaRetrieveOption = schemaRetrieveOption;
		this.template = template;
		this.lang = lang;
		this.multiRecord = multiRecord;
		
		if (parent != null) {
			parent.addChild(this);
		}
	}
}
