package net.sf.RecordEditor.re.codeGen.cobol;

import javax.swing.JDialog;

import net.sf.JRecord.External.ExternalRecord;
import net.sf.RecordEditor.re.cobol.CblLoadData;
import net.sf.RecordEditor.re.cobol.ISetVisible;
import net.sf.RecordEditor.re.cobol.tree.CobolSchemaDisplay;
import net.sf.RecordEditor.re.cobol.tree.GenWizData;
import net.sf.RecordEditor.utils.screenManager.ReMainFrame;
import net.sf.RecordEditor.utils.wizards.AbstractWizard;
import net.sf.RecordEditor.utils.wizards.AbstractWizardPanel;

public class CodeGenOptionWizard extends AbstractWizard<GenWizData> implements ISetVisible {

	private final JDialog dialog;
	private final ExternalRecord xRecord;
	private final CodeGenOptionsCbl2 codeGenOptions;
	
	public CodeGenOptionWizard(CblLoadData data) {
		this(new JDialog(ReMainFrame.getMasterFrame()), data, new GenWizData());
	}
	
	private CodeGenOptionWizard(JDialog dialog, CblLoadData data, GenWizData wizData) {
		super(dialog, wizData);
		
		this.dialog = dialog;
		this.xRecord = data.getXRecordJR(data.dropCopybookNameChk.isSelected());
		this.codeGenOptions = new CodeGenOptionsCbl2(dialog, data);
		
		wizData.xRecord = xRecord;
		
		@SuppressWarnings("unchecked")
		AbstractWizardPanel<GenWizData>[] pnls = new AbstractWizardPanel[2];


		pnls[0] = codeGenOptions;
		pnls[1] = new CobolSchemaDisplay(xRecord);

		super.setPanels(pnls);
	}
	
	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.utils.wizards.AbstractWizard#finished(java.lang.Object)
	 */
	@Override
	public void finished(GenWizData details) {
		codeGenOptions.genSkel(xRecord);
	}
	
	/**
	 * @param b
	 * @see java.awt.Dialog#setVisible(boolean)
	 */
	public void setVisible(boolean b) {
		dialog.setVisible(b);
	}	



}
