package net.sf.RecordEditor.re.codeGen.type;

import javax.swing.DefaultCellEditor;
import javax.swing.JComboBox;
import javax.swing.JTable;
import javax.swing.table.TableCellEditor;
import javax.swing.table.TableCellRenderer;

//import net.sf.RecordEditor.re.cobol.tree.CobolItemTreeModel;
import net.sf.RecordEditor.utils.swing.interfaces.ITableCellAdapter;
import net.sf.recordEditor.ui.swing.tableCell.ComboBoxRender;

public abstract class AbstractTypeCellAdapter implements ITableCellAdapter {
	private static final DateComboFactory formatFactory = new DateComboFactory();
	
	private final static String[] TYPES_STR = {
			"int",
			"long",
			"short",
			"BigInteger",
			"BigDecimal",
			"double",
			"float",
			"LocalDate",
			"String"
			
	};

	//final CobolItemTreeModel mdl;
	//final JTree tree;
	private TableCellRenderer dateRendor = formatFactory.allFormats.asTableCellRenderer();
	final ComboBoxRender typeRender = new ComboBoxRender(TYPES_STR);	
	private final int typeColumn, formatColumn;
	
	
	public AbstractTypeCellAdapter(int typeColumn, int formatColumn) {
		this.typeColumn = typeColumn;
		this.formatColumn = formatColumn;
	}
	
	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.utils.swing.interfaces.ITableCellAdapter#getCellRenderer(javax.swing.JTable, int, int)
	 */
	@Override
	public TableCellRenderer getCellRenderer(JTable tbl, int row, int column) {
		TableCellRenderer ret = null;
		if (column == typeColumn) {
			if (isEditable(row, column)) {
				ret = typeRender;			
			}
		} else if (column == formatColumn) {
			if (isEditable(row, column)) {
				ret = dateRendor;
			}
		}
		return ret;
	}

	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.utils.swing.interfaces.ITableCellAdapter#getCellEditor(javax.swing.JTable, int, int)
	 */
	@Override
	public TableCellEditor getCellEditor(JTable tbl, int row, int column) {
		TableCellEditor ret = null;
		if (column == typeColumn) {
			if (isEditable(row, column)) {
				ret = new DefaultCellEditor(new JComboBox(TYPES_STR));			
			}
		} else if (column == formatColumn) {
			if (isEditable(row, column)) {
				ret = getFormatEditor(row);
			}
		}
		return ret;
	}
	
	protected abstract TableCellEditor getFormatEditor(int row);
	protected abstract boolean isEditable(int row, int column);
}
