package net.sf.RecordEditor.re.codeGen.type;

import java.util.ArrayList;

import javax.swing.DefaultCellEditor;
import javax.swing.JComboBox;
import javax.swing.table.TableCellEditor;
import javax.swing.table.TableCellRenderer;

import net.sf.RecordEditor.re.util.csv.StdDateFormatStr;
import net.sf.recordEditor.ui.swing.tableCell.ComboBoxRender;

public class DateComboFactory {
	public final IDateComboBuilder allFormats, numericFormats, shortNumericFormats;

	
	public DateComboFactory() {
		Object[] dateFormats = StdDateFormatStr.DATE_FORMATS.toArray(new Object[StdDateFormatStr.DATE_FORMATS.size()]);
		ArrayList<StdDateFormatStr>  numDates = new ArrayList<StdDateFormatStr>(dateFormats.length),
								shortNumDates = new ArrayList<StdDateFormatStr>(dateFormats.length);
		
		numDates.add(StdDateFormatStr.NULL_DATE_FORMAT);
		shortNumDates.add(StdDateFormatStr.NULL_DATE_FORMAT);
		
		for (int i = 1; i < dateFormats.length; i++) {
			StdDateFormatStr dt = StdDateFormatStr.DATE_FORMATS.get(i);
			if (dt.sep.length() == 0) {
				numDates.add(dt);
				if (dt.toString().length() < 8) {
					shortNumDates.add(dt);
				}
			}
		}
		allFormats = new DateComboBldr(dateFormats);
		numericFormats = new DateComboBldr(numDates.toArray(new Object[numDates.size()]));
		shortNumericFormats = new DateComboBldr(shortNumDates.toArray(new Object[shortNumDates.size()]));
	}

	private static class DateComboBldr implements IDateComboBuilder {
		private final Object[] dateFormats;

		public DateComboBldr(Object[] dateFormats) {
			super();
			this.dateFormats = dateFormats;
		}

		/* (non-Javadoc)
		 * @see net.sf.RecordEditor.re.cobol.gen.IDateComboBuilder#asTableCellRenderer()
		 */
		@Override
		public TableCellRenderer asTableCellRenderer() {
			return new ComboBoxRender(dateFormats);
		}

		/* (non-Javadoc)
		 * @see net.sf.RecordEditor.re.cobol.gen.IDateComboBuilder#asTableCellEditor()
		 */
		@Override
		public TableCellEditor asTableCellEditor() {
			return new DefaultCellEditor(new JComboBox(dateFormats));
		}

		/* (non-Javadoc)
		 * @see net.sf.RecordEditor.re.cobol.gen.IDateComboBuilder#asComboBox()
		 */
		@Override
		public JComboBox asComboBox() {
			return new JComboBox(dateFormats);
		}
		
	 
	}
}
