package net.sf.RecordEditor.re.codeGen.type;

import net.sf.JRecord.External.IGetJavaType;
import net.sf.JRecord.External.Def.ExternalField;
import net.sf.JRecord.Types.TypeManager;
import net.sf.JRecord.cg.schema.type.JavaTypeDetails;
import net.sf.RecordEditor.re.util.csv.StdDateFormatStr;

public class ExternalFieldJType extends ExternalField implements IGetJavaType {

	private static DateComboFactory formatFactory = new DateComboFactory();
	
	String javaType=null;
	StdDateFormatStr dateFormat;
	IDateComboBuilder dateComboBldr = formatFactory.allFormats;;
	
	public ExternalFieldJType(ExternalField fld, boolean isCsv) {
		super(	fld.getPos(), fld.getLen(), fld.getName(), fld.getDescription(), 
				fld.getType(), fld.getDecimal(), fld.getCellFormat(), 
				fld.getParameter(), fld.getDefault(), fld.getCobolName(), 
				fld.getSubKey(), fld.getDependOnDtls());
		super.setGroup(fld.getGroup());
		
		JavaTypeDetails td = new JavaTypeDetails(false, fld.getType(), null, fld.getLen(), fld.getDecimal(), 
				fld.getCellFormat(), fld.getParameter());
		javaType = td.javaTypeName;
		
		dateFormat = StdDateFormatStr.getStandardFormat(fld.getCellFormat(), fld.getParameter());

		if (! isCsv) {			
			if (TypeManager.isNumeric(fld.getType())) {
				dateComboBldr = formatFactory.numericFormats;
				if (td.isInteger) {
					dateComboBldr = formatFactory.shortNumericFormats;
				}
			}
		}
	}
	
	/**
	 * @param cobolItem
	 * @return
	 */
	public JavaTypeDetails getTypeDtls() {
		JavaTypeDetails td = new JavaTypeDetails(false, getType(), null, getLen(), getDecimal(), 
				super.getCellFormat(), getParameter());
		return td;
	}

	@Override
	public String getJavaTypeName() {
		return javaType;
	}	
}
