package net.sf.RecordEditor.re.codeGen.type;

import java.util.ArrayList;

import net.sf.JRecord.External.ExternalRecord;
import net.sf.RecordEditor.re.schema.ICreateFieldIterator;
import net.sf.RecordEditor.utils.swing.BaseHelpPanel;
import net.sf.RecordEditor.utils.swing.BasePanel;
import net.sf.RecordEditor.utils.swing.tbl.LinesTbl;

public class RecordPnl {

	public final BasePanel pnl;
	private final ExternalRecord xRec, xRecType;
	private FieldTblMdl mdl;
	private LinesTbl fieldTbl;
	private ArrayList<ExternalFieldJType> fields, fieldsWithType;
	
	RecordPnl(BasePanel pnl, ExternalRecord xRec, ExternalRecord xRecType,
			int recordIdx, ICreateFieldIterator createFieldIterator) {
		double gap = pnl == null ? BaseHelpPanel.GAP1 : BaseHelpPanel.GAP;
		this.pnl   = pnl == null ? new BaseHelpPanel("FldType_" + xRec.getRecordName()) : pnl;
		this.xRec = xRec;
		this.xRecType = xRecType;
		
		init_100_setup(recordIdx, createFieldIterator);
		
		this.pnl.addComponentRE(1, 3, BasePanel.FILL, gap, BasePanel.FULL, BasePanel.FULL, fieldTbl);
		
//		if (xRec.isCsv()) {
//			TableColumnModel columnMdl = fieldTbl.getColumnModel();
//			columnMdl.removeColumn(columnMdl.getColumn(FieldTblMdl.JAVA_LENGTH_COLUMN));
//		}
	}
	
	private void init_100_setup(int recordIdx, ICreateFieldIterator createFieldIterator) {
		fields = init_110_updateRecord(xRec);		
		fieldsWithType = init_110_updateRecord(xRecType);		
	
		mdl = new FieldTblMdl(fields, recordIdx, createFieldIterator);
		fieldTbl = new LinesTbl(mdl, mdl.newTypeCellAdapter());
		fieldTbl.setRowHeight(24);
		fieldTbl.putClientProperty("terminateEditOnFocusLost", Boolean.TRUE);
	}

	/**
	 * @return
	 */
	private ArrayList<ExternalFieldJType> init_110_updateRecord(ExternalRecord rec) {
		if (rec == null) { return null; }
		int size = rec.getNumberOfRecordFields();
		ArrayList<ExternalFieldJType> flds = new ArrayList<ExternalFieldJType>(size);
		
		for (int i = 0; i < size; i++) {
			flds.add(new ExternalFieldJType(rec.getRecordField(i), rec.isCsv()));
		}
		
		rec.clearRecordFields();
		rec.addRecordFields(flds);
		return flds;
	}

	public final boolean isChanged() {
		return mdl.isChanged();
	}

	public void apply(CheckForTypeUpdate check) {
		mdl.apply(check);
	}

	
	public void setFields(boolean normalFields) {

		if (fieldsWithType != null) {
			mdl.setFields(normalFields ? fields : fieldsWithType);
		}
	}
}
