package net.sf.RecordEditor.re.display;

import net.sf.JRecord.Details.AbstractLayoutDetails;
import net.sf.JRecord.Details.AbstractLine;
import net.sf.RecordEditor.re.file.AbstractLineNode;
import net.sf.RecordEditor.re.file.FileView;
import net.sf.RecordEditor.re.tree.AbstractLineNodeTreeParser;

/**
 * Description of a Class that will create views of a File
 * (based on a supplied screenType). This class is basically a
 * Screen-Builder class
 *
 * @author Bruce Martin
 *
 */
public interface IDisplayBuilder {

	/**
	 * <b>Warning:</b> if extra constants added update
	 * <b>ScriptData.DisplConstants</b> class to reflect the changes !!!
	 */
	public static int ST_INITIAL_EDIT     = 1;
	public static int ST_INITIAL_BROWSE   = 2;
	public static int ST_LIST_SCREEN      = 3;
	public static int ST_RECORD_SCREEN    = 4;
	public static int ST_RECORD_TREE      = 5;
	public static int ST_RECORD_COBOL_TREE = 12;
	public static int ST_CB2XML_TREE      = 6;
	public static int ST_LINES_AS_COLUMNS = 7;
	public static int ST_LINE_TREE_CHILD  = 8;
	public static int ST_LINE_TREE_CHILD_EXPAND_PROTO  = 9;
	public static int ST_DOCUMENT         = 10;
	public static int ST_COLORED_DOCUMENT = 11;

	public AbstractFileDisplayWithFieldHide newDisplay (
			final int screenType,
			final String screenName,
			final IDisplayFrame<? extends AbstractFileDisplay> parentFrame,
			final AbstractLayoutDetails group,
            final FileView viewOfFile,
            final int lineNo);

	public AbstractFileDisplayWithFieldHide newDisplay (
			final int screenType,
			final String screenName,
			final IDisplayFrame<? extends AbstractFileDisplay> parentFrame,
			final AbstractLayoutDetails group,
            final FileView viewOfFile,
            final AbstractLine line);

	public AbstractFileDisplayWithFieldHide newDisplay(
			int screenType,
			IDisplayFrame<? extends AbstractFileDisplay> parentFrame,
			AbstractLayoutDetails group, FileView viewOfFile,
			AbstractLineNodeTreeParser treeParser, boolean mainView, int columnsToSkip);

	public AbstractFileDisplayWithFieldHide newLineTreeChildScreen(
			int screenType,
			@SuppressWarnings("rawtypes") IDisplayFrame df,
			FileView viewOfFile,
			AbstractLineNode rootNode,
			boolean mainView, final int columnsToSkip);
}
