package net.sf.RecordEditor.re.file;

import java.util.Iterator;

import net.sf.JRecord.Details.AbstractLine;

public class FieldInViewIterator implements Iterator<String> {

	int idx = 0;
	final int recordNum, fieldNum;
	final FileView view;
	final boolean oneRecordType;
	boolean hasNext;
	String nextVal;
	
	
	
	public FieldInViewIterator(FileView view, int recordNum, int fieldNum) {
		super();
		this.view = view;
		this.recordNum = recordNum;
		this.fieldNum = fieldNum;
		oneRecordType = view.getLayout().getRecordCount() == 1;
		checkNext();
	}

	@Override
	public boolean hasNext() {
	
		return hasNext;
	}

	public void checkNext() {
		while (idx < view.getRowCount()) {
			AbstractLine line = view.getLine(idx++);
			if (oneRecordType || line.getPreferredLayoutIdx() == recordNum) {
				Object o = line.getField(recordNum, fieldNum);
				nextVal = o == null ? "" : o.toString();
				hasNext = true;
				return;
			}
		}
		hasNext = false;
	}

	@Override
	public String next() {
		String ret = nextVal;
		checkNext();
		return ret;
	}
}
