package net.sf.RecordEditor.re.firstTime.wizard;

import javax.swing.JComboBox;
import javax.swing.JEditorPane;

import net.sf.JRecord.Numeric.ConversionManager;
import net.sf.RecordEditor.re.editProperties.DefaultOptModel;
import net.sf.RecordEditor.utils.params.Parameters;
import net.sf.RecordEditor.utils.swing.BasePanel;
import net.sf.RecordEditor.utils.swing.ComboBoxs.EnglishStrModel;
import net.sf.RecordEditor.utils.swing.treeCombo.FileFieldCombo;
import net.sf.recordEditor.ui.fileFields.params.FileFieldParamBldr;
import net.sf.recordEditor.ui.xEnvironment.SwingUtils;

public class CobolPnl extends BaseWizPnl {

	private final static EnglishStrModel cobolDialectOptMdl = DefaultOptModel.newModel(ConversionManager.getInstance());
	
	JComboBox cobolDialect = new JComboBox(cobolDialectOptMdl);
	FileFieldCombo copybookDirCombo = new FileFieldCombo(FileFieldParamBldr.newFileFieldParamBuilder()
						.directory(true)
						.completeFile(true)
					.asBuilderAndParameter()
			);
			//null, null, null, null, null, true, true);
	
	private InitialSetupData detail;
	
	public CobolPnl() {
		super("CobolInitWiz", "");
		
		init_200_layoutScreen();
	}
	
	private void init_200_layoutScreen() {
		
		copybookDirCombo.setExpandVars(true);

		pnl	.addComponentRE(1, 3, SwingUtils.values().STANDARD_FONT_HEIGHT * 10, BasePanel.GAP3,
                BasePanel.FULL, BasePanel.FULL,
                new JEditorPane("text/html", "Setting various <b>Cobol</b> options"))
						.setFieldsToActualSize()
			.addLineRE("Default Cobol Dialect", cobolDialect)
						.setFieldsToFullSize()
			.addLineRE("Copybook Directory", copybookDirCombo.getMainComponent());
		
	}

	@Override
	public void setValues(InitialSetupData detail) throws Exception {
		ConversionManager dialectList = ConversionManager.getInstance();
		this.detail = detail;
		for (int i = 0; i < dialectList.getNumberOfEntries(); i++) {
			if (dialectList.getName(i).equals(detail.cobolDialect)) {
				cobolDialect.setSelectedIndex(i);
				break;
			}
		}
		copybookDirCombo.setFileNameSilently(detail.cobolDirectory);
	}
	
	

	@Override
	public InitialSetupData getValues() throws Exception {

		if (detail.usesCobol) {
			int selectedIndex = cobolDialect.getSelectedIndex();
			if (selectedIndex >= 0) {
				ConversionManager dialectList = ConversionManager.getInstance();
				detail.cobolDialect = dialectList.getName(selectedIndex);
				detail.setSavePropertyChanges(false);
				detail.setProperty(Parameters.DEFAULT_COBOL_DIALECT_NAME, detail.cobolDialect);
				detail.setProperty(Parameters.DEFAULT_COBOL_DIALECT, selectedIndex);
			}
			
			detail.cobolDirectory = copybookDirCombo.getText();
			detail.setSavePropertyChanges(true);
			detail.setProperty(Parameters.DEFAULT_COBOL_DIRECTORY, detail.cobolDirectory);
			
			detail.showSchemaScreen.set(true, true);
		}
		return detail;
	}

	@Override
	public boolean skip() {
		return detail == null || ! detail.usesCobol;
	}
}
