package net.sf.RecordEditor.re.firstTime.wizard;

import net.sf.RecordEditor.utils.screenManager.ReMsgId;

public class FtMessages {
	
	
	public final static ReMsgId WIN_START_LAF_MSG = new ReMsgId(
				"WinLafMsg",
				"<h3>Look and Feel</h3"
				+ "<p>On <i>Windows</i> there is little reason to choose anything<br/>" 
				+ "other than <b>Windows Look and Feel</b>, It is the closest to<br/>"
				+ "Windows native look."
			);
	
	public final static ReMsgId NIX_START_LAF_MSG = new ReMsgId(
				"NixLafMsg",
				"<h3>Look and Feel</h3"
				+ "<p>On <i>Linux / Unix</i> the <b>System</b> Look and Feel<br/>" 
				+ "is not very good, I suggest using <b>Nimbus</b><br>"
				+ "Look and Feel or Java default (Metal) Look and Feel."
			);

	
	public final static ReMsgId MAC_START_LAF_MSG = new ReMsgId(
				"MacLafMsg",
				"<h3>Look and Feel</h3"
				+ "<p>Not sure of the best look and feel to use on a Mac<br/>" 
				+ "Try <b>System</b> or <b>Nimbus</b>."
			);

	
	public final static ReMsgId WIN_LAF_OPEN_FILE_MSG = new ReMsgId(
				"WinOpenDialogMsg",
				"<h3>Open File Dialog</h3"
				+ "<p>There are three basic <i>Open File</i> options:<ul>"
				+ "<li>The new <b>Standard reCsvEditor</b> \"<i>Open File</i>\" dialog. This is the<br/>"
				+ "the most powerful, it has recent files / directories and<br/>"
				+ "favourite Files / directories."
				+ "<li>Standard \"<i>Windows</i>\" style open file.<br/>"
				+ "This is less powerful but more familiar the "
				+ "<li>Extended \"<i>Windows</i>\" style open file.<br/>"
				+ "This option adds a recent directory pane to the<br/>"
				+ "standard \"<i>Windows</i>\" style open file"
				+ "<ul>"
			);
	
	public final static ReMsgId CSV_OTHER_LAF_OPEN_FILE_MSG = new ReMsgId(
				"OtherOpenDialogMsg",
				"<h3>Open File Dialog</h3"
				+ "<p>There are three basic <i>Open File</i> options:<ul>"
				+ "<li>The new <b>Standard reCsvEditor</b> \"<i>Open File</i>\" dialog.<br/>"
				+ "This is the most powerful, it has recent files / directories<br/>"
				+ "and favourite Files / directories."
				+ "<li>Look and Feel based open file.<br/>"
				+ "This is less powerful but more familiar the "
				+ "<li>Extended \"<i>Windows</i>\" style open file.<br/>"
				+ "This option adds a recent directory pane to the<br/>"
				+ "standard \"<i>Windows</i>\" style open file"
				+ "<ul>"
			);

	private final static String tabs 
				= "There are Layout, Csv, Xml and Schema Tabs<br>"
				+ "where you can specify the file schema</br>";
	public final static ReMsgId RE_OPEN_FILE_MSG = new ReMsgId(
			"ReOpenDialogMsg",
			"<h3>Open File Dialog</h3"
			+ "<p>There are three <i>Open File</i> options:<ul>"
			+ "<li>\"<i>Classic</i>\" <b>RecordEditor</b> open dialog with a<br/>"
			+ "file Field."
			+ tabs
			+ "<p>This is a good option if you will use the <b>RecordEditor</b><br>"
			+ "from the <i>Command line</i> or your OS File Exploprer."
			+ "<li>The new \"<i>Open File List</i>\" dialog.<br/>"
			+ "This is an open File Dialog which lets you<br/>"
			+ "search/display files. This option has recent<br/>"
			+ "files / directories and favourite Files / directories.<br/>"
			+ tabs
			+ "<p>This is a good option if you will be searching<br>"
			+ "for files in the RecordEditor."
			+ "<li>Old Basic RecordEditor open dialog.<br/>"
			+ "Only use on small screens or slow computers."
			+ "<ul>"
		);

	public final static ReMsgId PGM_INIT_MSG = new ReMsgId(
				"InitMsg",
				"<h3>{0} First Time Initialisation</h3"
				+ "<p>This wizard is only displayed when you start {0}<br/>"
				+ "for the <b>first time</b> (or after an <b>upgrade</b>). It will let you<br/>"
				+ "set the Look and Feel + Open file dialogs.<br/><br/>"
				+ "This dialog is also available on the <b>Format</b> menu."
				+ "<p>If you are going to use the {0} with Cobol data files,<br/>"
				+ "check the option below."
			);


	public final static ReMsgId RE_TAB_INIT_MSG = new ReMsgId(
				"TabInitMsg",
				"<h3>Open Tab inialisation Screen</h3"
				+ "<p>This option lets youdecid which File Format options are displayed<br/>"
				+ "by the RecordEditor in the open file panel. The purpose is to simplify<br>"
				+ "the start up screen. Optional Tabs<ul><br/>"
				+  "<li><b>Xml</b> Xml file display option</li>"
				+  "<li><b>Schema/Cobol</b> Lets you Edit a file with File definition stored in<br/>"
				+ "either a <i>Xml Schema</li> or a Cobol copybook</li>"
				+  "<li><b>Regular Expression</b> Split text lines using a regular expression.</li>"
				+  "<li><b>Other</b> Language Translation PO files + SwingX Tip files.</li>"
				+ "</ul>"
				+ "<p>If you are going to use the {0} with Cobol data files,<br/>"
				+ "check the option below."
			);
	

	public final static ReMsgId RE_TAB_CSV_INIT_MSG = new ReMsgId(
				"TabInitMsg",
				"<h3>Open Tab inialisation Screen</h3"
				+ "<p>This option lets youdecid which File Format options are displayed<br/>"
				+ "by the RecordEditor in the open file panel. The purpose is to simplify<br>"
				+ "the start up screen. Optional Tabs<ul><br/>"
				+  "<li><b>Xml</b> Xml file display option</li>"
				+  "<li><b>Schema/Cobol</b> Lets you Edit a file with File definition stored in<br/>"
				+ "either a <i>Xml Schema</li> or a Cobol copybook</li>"
				+  "<li><b>Regular Expression</b> Split text lines using a regular expression.</li>"
				+  "<li><b>Other</b> Language Translation PO files + SwingX Tip files.</li>"
				+ "</ul>"
				+ "<p>If you are going to use the {0} with Cobol data files,<br/>"
				+ "check the option below."
			);


	public final static ReMsgId WIN_OPEN_FILE_TXT = new ReMsgId("winOfTxt", "Windows Style Open File Dialog");
	public final static ReMsgId WIN_OPEN_FILE_DESC = new ReMsgId(
			"winOfDesc", 
			"Java Standard <b>Windows</b> Style <i>Open file dialog</i>.");

	public final static ReMsgId WIN_OPEN_FILE_X_TXT  = new ReMsgId("winOfxTxt", "\"Windows Style Open File Dialog with recent files\"");
	public final static ReMsgId WIN_OPEN_FILE_X_DESC = new ReMsgId(
			"winOfxDesc", 
			"Java Standard <b>Windows</b> Style <i>Open file dialog</i>.");
	
	public final static ReMsgId NIMBUS_LAF_TEXT  = new ReMsgId(
			"nimbusLafText", 
			"Nimbus Look and Feel");
	
	public final static ReMsgId NIMBUS_LAF_DESC  = new ReMsgId(
			"nimbusLafDesc", 
			"<b>Nimbus</b> is last Internal Java Look and Feel.<br/>"
		  + "It will run on all systems. It is probably<br/>"
		  + "a better option than<b>Metal</b>./");

	
	public final static ReMsgId METAL_LAF_TEXT  = new ReMsgId(
			"metalLafText", 
			"Java Metal Look and Feel");
	
	public final static ReMsgId METAL_LAF_DESC  = new ReMsgId(
			"metalLafDesc", 
			"<b>Metal</b> is an old Java Look and Feel.<br/>"
		  + "You are probably better off using <b>Windows LAF</b>"
		  + "on Windows machines and <b>Nimbus</b> on Other Machines"
			);
	
	public final static ReMsgId SYSTEM_LAF_DESC  = new ReMsgId(
			"systemLafDesc",
			"Java's attempt at the local <b>System</b> look and Feel<br/>"
		  + "works better on some systems"
			);
	
	public final static ReMsgId WINDOWS_LAF_TEXT  = new ReMsgId(
			"systemLafText",
			"Windows Look and Feel"
			);
	
	public final static ReMsgId WINDOWS_LAF_DESC  = new ReMsgId(
			"systemLafDesc",
			"Java's attempt at <b>Windows</b> Look and Feel<br/>"
		  + "generally works reasonably well. It is the best<br>"
		  + "option for Windows based computers."
			);

	public final static ReMsgId FILE_FIELD_DESC  = new ReMsgId(
			"WizFfDesc",
			"There are three File field options available:<ul>"
			+ "<li>Breadcrumb style folder / file."
			+ "<li>Text field with file matching list."
			+ "<li>Plain text field"
			+ "</ul>"
			+ "<p>All Fields have <b>Recent, Favourite</b><br/>"
			+ "and <b>File Search</b> options"
			);
}
