package net.sf.RecordEditor.re.firstTime.wizard;

import javax.swing.ImageIcon;
import javax.swing.JCheckBox;
import javax.swing.JEditorPane;
import javax.swing.JLabel;

import net.sf.RecordEditor.utils.params.Parameters;
import net.sf.RecordEditor.utils.swing.BasePanel;


public class InfoPnl extends BaseWizPnl {

	private final JEditorPane tipTxt = new JEditorPane("text/html", "");
	
	private InitialSetupData data;
	private final JCheckBox  showLafPnl = super.createChk(
			"Show Look and Feel options",
			"Change the java <i>Look and Feel</i><br/>"
					+ "If selected you can change the Look and Feel<br/>"
					+ "Most people do not need this option");
	private final JCheckBox useCobolChk = super.createCobolChk();


	
	public InfoPnl(String appl) {
		super("InfoPnl", "help-file-name");

		init_100_setup(appl);
		
		init_200_LayoutScreen();
	}
	


	/**
	 * @param osType
	 * @return
	 */
	public void init_100_setup(String appl) {
		
		tipTxt.setText(FtMessages.PGM_INIT_MSG.get(appl));
	}
	



	
	private void init_200_LayoutScreen() {
		
		pnl	.addComponentRE(1, 3, BasePanel.FILL, BasePanel.GAP2,
                BasePanel.FULL, BasePanel.FULL,
                tipTxt)
			.addLineRE("", showLafPnl)
			.addLineRE("", useCobolChk);
	
		super.setRightComponent(
				new JLabel(
					new ImageIcon (
						InfoPnl.class.getResource("pics/setupWizard.png"))));
		super.splitPane.setDividerLocation(0.5);
		super.splitPane.setResizeWeight(0.5);
	}

	@Override
	public InitialSetupData getValues() throws Exception {
		data.usesCobol = useCobolChk.isSelected();
		data.showLaf = showLafPnl.isSelected();
		data.setProperty(Parameters.USES_COBOL, data.usesCobol ? "Y" : null);
		return data;
	}
	

	@Override
	public void setValues(InitialSetupData detail) throws Exception {
		data = detail;
		useCobolChk.setSelected(data.usesCobol);
		showLafPnl.setSelected(data.showLaf);
		
		super.splitPane.setDividerLocation(0.5);
	}
}
