package net.sf.RecordEditor.re.firstTime.wizard;

import java.util.ArrayList;

import javax.swing.ButtonGroup;
import javax.swing.JCheckBox;
import javax.swing.JEditorPane;

import net.sf.RecordEditor.re.editProperties.LooksPanel;
import net.sf.RecordEditor.utils.params.Parameters;
import net.sf.RecordEditor.utils.swing.BasePanel;
import net.sf.recordEditor.ui.fileFields.ChooseFileBtn;
import net.sf.recordEditor.ui.xEnvironment.Env;


public abstract class OpenTypePnl extends BaseWizPnl {
	private static final String SWING_FIELD_NAME_PREFIX = "OpenPnlWiz";

	final JEditorPane tipTxt = new JEditorPane("text/html", "");
	final JCheckBox webFileChooser;
	
	final ArrayList<OptionDtl> ofOptions = new ArrayList<OpenTypePnl.OptionDtl>();
	private final ButtonGroup btnGrp = new ButtonGroup();
	

	
	final Env.OsType osType;
	InitialSetupData data;

	private int  lastIndex = -121;
	private String lastLaf = "-------";
//	private final String paramName;
	private final boolean staticScreen;
//	private final String name;
	
//	private OpenFileOption lafOption = new OpenFileOption(
//			"ReCsvEditor Open File Dialog",
//			"Standard ReCsvEditor Open file Dialog.<br/>"
//					+ "It supports<ul><li> Favaourite Files/Directories<li>Recent Files/Direcories</ul>",
//			Parameters.FILE_CHOOSER_WEBLAF, "csvOpenStd.png");

	
	public OpenTypePnl(boolean staticScreen, String name, Env.OsType osType, InitialSetupData detail, String helpId) {
		super(SWING_FIELD_NAME_PREFIX, helpId);
		
		this.staticScreen = staticScreen;
		//this.name = name;
		this.osType = osType;
		this.data = detail;
		
		String lafChooser = "the Java FileChooser";	
		if (isWindowsLaf()) {
			lafChooser = "Windows Style FileChooser";
		}
		webFileChooser = super.createChk("Use " + name + " File Chooser",
				"Use the" + name + " File Chooser instead of " + lafChooser + "<br/>"
						  + "The "+ name + " File Chooser is more powerful, it supports<br/>"
						  + "Recent files & Directories, Favourite Files / Directories");
	}
	
	private void init() {
		init_100_setup();
		
		layoutScreen();
	}
	
	/**
	 * @param osType
	 * @return
	 */
	protected abstract void init_100_setup();
	
	
	void addOpenFileOption(OptionDtl optionDef) {

		ofOptions.add(optionDef);
		btnGrp.add(optionDef.radioBtn);
	}
	
	private void layoutScreen() {
		super.layoutScreen(ofOptions, tipTxt);
		pnl.setGapRE(BasePanel.GAP2)
			.addLineRE("", webFileChooser);
	}


	@Override
	public void setValues(InitialSetupData detail) throws Exception {
		data = detail;
		
		setSplitPaneSize();
		
		if (staticScreen) {
			
		} else if (lastIndex != data.lafIndex || ! lastLaf.equals(detail.lafClassName)) {
			init_100_setup();
			
			pnl.removeAll();
			
			layoutScreen();
			pnl.done();
			
			pnl.revalidate();
			pnl.repaint();
		}
		lastIndex = data.lafIndex;
		lastLaf = data.lafClassName == null ? "" : data.lafClassName;

		webFileChooser.setSelected(data.useReFileChooser);
		
		if (data.doInit) {
			ofOptions.get(0).radioBtn.setSelected(true);
			data.doInit = false;
		} else {
			for (OptionDtl ofOpt : ofOptions) {
//				System.out.println("~~~ " + ofOpt.value + " " + data.openFileOption);
				if (ofOpt.value.equals(data.openFileOption)) {
					ofOpt.radioBtn.setSelected(true);
					setRightComponent(ofOpt.imageLabel);
					return;
				}
			}
			ofOptions.get(0).radioBtn.setSelected(true);
		}
	}

	boolean isWindowsLaf() {
		String laf 	= data.lafClassName;
		return osType == Env.OsType.WINDOWS
				&& (   data.lafIndex == LooksPanel.SYSTEM_DEFAULT_INDEX) 
				|| LooksPanel.WINDOWS_LOOK_AND_FEEL.equals(laf)
				|| Parameters.VAL_RECORD_EDITOR_DEFAULT.equals(laf);
	}

	@Override
	public InitialSetupData getValues() throws Exception {
		data.useReFileChooser = webFileChooser.isSelected();
		data.setSavePropertyChanges(false);
		
		
		String useWebChooser = null;
		String chooserType = Parameters.FILE_CHOOSER_NEW;
		String oldOpenFileOption = data.openFileOption;
		if (! data.useReFileChooser) {
			useWebChooser = "N";
			chooserType = isWindowsLaf() ? Parameters.FILE_CHOOSER_NORMAL : Parameters.FILE_CHOOSER_EXTENDED;
		} 

		data.setProperty(Parameters.FILE_CHOOSER_UI, useWebChooser);
		data.setProperty(data.fileChooserOption, chooserType);
		data.setSavePropertyChanges(true);
		
		ChooseFileBtn.setUseUiFileChooser(data.useReFileChooser);
		for (OptionDtl ofOpt : ofOptions) {
			if (ofOpt.radioBtn.isSelected()) {
				data.openFileOption = ofOpt.value;
				Parameters.setProperty(data.fileOpenParam, ofOpt.value);
				break;
			}
		}
		
		
		if ((!data.init) && data.updateOpenPnl != null
		&& (oldOpenFileOption == null || ! oldOpenFileOption.equalsIgnoreCase(data.openFileOption))) {
			data.updateOpenPnl.updateOpenPanel();
		}

		return data;
	}
	


	
	public static class Csv extends OpenTypePnl {
		
		Csv(Env.OsType osType, InitialSetupData detail) {
			super(false, "reCsvEditor", osType, detail, "help-file-name");
			super.init();
		}
		
		protected void init_100_setup() {
			
			OptionDtl lafOption = new OptionDtl(
					"ReCsvEditor Open File Dialog",
					"Standard ReCsvEditor Open file Dialog.<br/>"
							+ "It supports<ul><li> Favaourite Files/Directories<li>Recent Files/Direcories</ul>",
					Parameters.FILE_CHOOSER_NEW, "csvOpenStd.png");
			ofOptions.clear();

			addOpenFileOption(lafOption);
			if (isWindowsLaf()) {
				tipTxt.setText(FtMessages.WIN_LAF_OPEN_FILE_MSG.get());
				
//				addOpenFileOption(
//						new OpenFileOption(
//								"Windows Style Open File Dialog",
//								"Java Standard <b>Windows</b> Style <i>Open file dialog</i>. ",
//								Parameters.FILE_CHOOSER_OPT_HIDE, ""));
				addOpenFileOption(
						new OptionDtl(
								FtMessages.WIN_OPEN_FILE_TXT.get(),
								FtMessages.WIN_OPEN_FILE_DESC.get(),
								Parameters.FILE_CHOOSER_NORMAL, "csvOpenWindows.png"));
				addOpenFileOption(
						new OptionDtl(
								"Windows Style Open File Dialog with recent files",
								"Java Standard <b>Windows</b> Style <i>Open file dialog</i> with recent files. ",
								Parameters.FILE_CHOOSER_EXTENDED, "csvOpenWindows.png"));
			} else {
				tipTxt.setText(FtMessages.CSV_OTHER_LAF_OPEN_FILE_MSG.get());

				addOpenFileOption(
						new OptionDtl(
								"Look and Feel File open Dialog + Recent Directory",
								"File Open Dialog based on the Java Look and Feel.<br/>"
								+ "with a Recent directory pane.<br>"
								+ "There is an option hide/display the Recent Directory<br>"
								+ "pane (right click menu) ",
								Parameters.FILE_CHOOSER_EXTENDED, "csvOpenOldX.png"));
				addOpenFileOption(
						new OptionDtl(
								"Look and Feel File open Dialog++",
								"File Open Dialog based on the Java Look and Feel.<br/>"
								+ "with a Recent directory pane (if there is room). ",
								Parameters.FILE_CHOOSER_NORMAL, "csvOpenOld.png"));
			}
		}
	}
	
	public static class RecordEditor extends OpenTypePnl { 
		
		RecordEditor(Env.OsType osType, InitialSetupData detail) {
			super(true, "RecordEditor", osType, detail, "help-file-name");
			super.init();
		}
		
		protected void init_100_setup() {

			String tabDefs = "and the file Format Definition tabs<ul>."
										+ "<li>RecordEditor Layout Tab"
										+ "<li>Csv File Description Tab"
										+ "<li>Xml Tab (for Xml files)"
										+ "<li>Schema Tab for Cobol / Xml schema files"
										+ "<li>Other Tab for specialist formats"
										+ "</ul> ";
			OptionDtl lafOption = new OptionDtl(
					"Open File List Dialog",
					"Open file list Dialog with a File Preview Screen.<br/>"
						+ "It supports<ul><li> Favaourite Files/Directories<li>Recent Files/Direcories</ul>"
						+ tabDefs,
					Parameters.FILE_CHOOSER_RE_SELECT, "reOpenFileSelect.png");
			
			ofOptions.clear();

			tipTxt.setText(FtMessages.RE_OPEN_FILE_MSG.get());
			addOpenFileOption(
					new OptionDtl(
							"Classic RecordEditor Open Dialog++",
							"Classic RecordEditor Open Dialog<br/>"
							+ "with File Field, File Preview<br/>"
							+ tabDefs,
							Parameters.FILE_CHOOSER_RE_CLASSIC, "reOpenClassic.png"));
			addOpenFileOption(lafOption);
			addOpenFileOption(
					new OptionDtl(
							"Old Basic RecordEditor Dialog",
							"Old Basic RecordEditor Dialog<br/>"
							+ "without Tabs/Preview (not really advised).",
							Parameters.FILE_CHOOSER_RE_OLD, "reOpenOld.png"));
		}	
	}

}
