package net.sf.RecordEditor.re.layoutSelection.def;

import java.util.ArrayList;
import java.util.List;

import net.sf.RecordEditor.utils.IGetFileName;
import net.sf.RecordEditor.utils.common.Common;

/**
 *
 * @author Bruce Martin
 *
 * These class's will -
 * <ol>
 *  <li>Add RecordLayout Selection fields to panels
 *  <li>Get / Set Record names
 *  <li>Read a record Layout from external storage
 * </ol>
 *
 * Basically it holds everything necessary for the user to Select a
 * record layout from an external storage medium (be it Database or File
 * storage).
 *
 */
public abstract class AbstractLayoutSelection
extends ReadLayout implements IFormatFileName {

	private IStartActionInterface executeAction = null;
//	private IGetFileName fileNameAccess;

	private List<IRecordLayoutChangedListner> layoutChangedListners = new ArrayList<IRecordLayoutChangedListner>(2);
	
//	/* (non-Javadoc)
//	 * @see net.sf.RecordEditor.re.layoutSelection.def.ILayoutSelection#getFileNameAccess()
//	 */
//	//@Override
//	public IGetFileName getFileNameAccess() {
//		return fileNameAccess;
//	}

	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.re.layoutSelection.def.ILayoutSelection#addLayoutSelection(net.sf.RecordEditor.utils.swing.BasePanel, net.sf.RecordEditor.utils.swing.treeCombo.TreeComboFileSelect, javax.swing.JPanel, javax.swing.JButton, javax.swing.JButton)
	 */
//	//@Override
//	public abstract void addLayoutSelection(BasePanel pnl, TreeComboFileSelect file, JPanel goPanel,
//			final JButton layoutCreate1, final JButton layoutCreate2);

	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.re.layoutSelection.def.ILayoutSelection#setFileNameField(net.sf.RecordEditor.utils.swing.treeCombo.TreeComboFileSelect)
	 */
	//@Override
	public void setFileNameField(IGetFileName fileNameField) {

	}

//	/* (non-Javadoc)
//	 * @see net.sf.RecordEditor.re.layoutSelection.def.ILayoutSelection#getDataBaseNames()
//	 */
//	@Override
//	public abstract String[] getDataBaseNames();
//
//	/* (non-Javadoc)
//	 * @see net.sf.RecordEditor.re.layoutSelection.def.ILayoutSelection#setDatabaseIdx(int)
//	 */
//	@Override
//	public abstract void setDatabaseIdx(int idx);
//

//	/* (non-Javadoc)
//	 * @see net.sf.RecordEditor.re.layoutSelection.def.ILayoutSelection#getDatabaseIdx()
//	 */
//	@Override
//	public abstract int getDatabaseIdx();
//
//	/* (non-Javadoc)
//	 * @see net.sf.RecordEditor.re.layoutSelection.def.ILayoutSelection#getDatabaseName()
//	 */
//	@Override
//	public abstract String getDatabaseName();
//
//
//	/* (non-Javadoc)
//	 * @see net.sf.RecordEditor.re.layoutSelection.def.ILayoutSelection#reload()
//	 */
//	@Override
//	public abstract void reload();
//
//
//	/* (non-Javadoc)
//	 * @see net.sf.RecordEditor.re.layoutSelection.def.ILayoutSelection#setLayoutName(java.lang.String)
//	 */
//	@Override
//	public abstract boolean setLayoutName(String layoutName);

	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.re.layoutSelection.def.ILayoutSelection#notifyFileNameChanged(java.lang.String, boolean)
	 */
	//@Override
	public void notifyFileNameChanged(String newFileName, boolean fileExists) {

	}

	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.re.layoutSelection.def.ILayoutSelection#notifyFileNameChanged(java.lang.String)
	 */
	//@Override
	public void notifyFileNameChanged(String newFileName) {

	}

//	/* (non-Javadoc)
//	 * @see net.sf.RecordEditor.re.layoutSelection.def.ILayoutSelection#getLayoutName()
//	 */
//	//@Override
//	public abstract String getLayoutName();
//
//	/* (non-Javadoc)
//	 * @see net.sf.RecordEditor.re.layoutSelection.def.ILayoutSelection#getRecordLayout(java.lang.String)
//	 */
//	//@Override
//	public abstract AbstractLayoutDetails getRecordLayout(String fileName);
	
	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.re.layoutSelection.def.ILayoutSelection#isOkToLoadFile(java.lang.String)
	 */
	//@Override
	public boolean isOkToLoadFile(String dataFileName) {
		return true;
	}

//	/* (non-Javadoc)
//	 * @see net.sf.RecordEditor.re.openFile.ISchemaProvider#getRecordLayout(java.lang.String, java.lang.String)
//	 */
//	/* (non-Javadoc)
//	 * @see net.sf.RecordEditor.re.layoutSelection.def.ILayoutSelection#getRecordLayout(java.lang.String, java.lang.String)
//	 */
//	//@Override
//	public abstract AbstractLayoutDetails getRecordLayout(String name, String fileName);
//
//	/* (non-Javadoc)
//	 * @see net.sf.RecordEditor.re.layoutSelection.def.ILayoutSelection#setMessage(javax.swing.text.JTextComponent)
//	 */
//	//@Override
//	public abstract	void setMessage(JTextComponent message);
//
//	/* (non-Javadoc)
//	 * @see net.sf.RecordEditor.re.layoutSelection.def.ILayoutSelection#isFileBasedLayout()
//	 */
//	@Override
//	public abstract boolean isFileBasedLayout();

	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.re.layoutSelection.def.ILayoutSelection#forceLayoutReload()
	 */
	//@Override
	public void forceLayoutReload() {

	}

	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.utils.openFile.FormatFileName#formatLayoutName(java.lang.String)
	 */
	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.re.layoutSelection.def.ILayoutSelection#formatLayoutName(java.lang.String)
	 */
	@Override
	public String formatLayoutName(String layoutName) {
		return layoutName;
	}

	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.re.layoutSelection.def.ILayoutSelection#setExecuteAction(net.sf.RecordEditor.re.layoutSelection.def.IStartActionInterface)
	 */
	//@Override
	public final void setExecuteAction(IStartActionInterface executeAction) {
		this.executeAction = executeAction;
	}

	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.re.layoutSelection.def.ILayoutSelection#loadFile(boolean)
	 */
	//@Override
	public void loadFile(boolean pBrowse) {
		if (executeAction == null) {
			Common.logMsgRaw("No load Action defined", null);
		} else {
			executeAction.loadFile(pBrowse);
		}
	}
	
	public void addRecordLayoutChangedListner(IRecordLayoutChangedListner listner) {
		layoutChangedListners.add(listner);
	}
	
	protected void notifyListnersOfLayoutChanged() {
		for (IRecordLayoutChangedListner l : layoutChangedListners) {
			l.recordLayoutHasChange();
		}
	}
}