package net.sf.RecordEditor.re.layoutSelection.def;

import javax.swing.text.JTextComponent;

import net.sf.JRecord.Details.AbstractLayoutDetails;
import net.sf.RecordEditor.utils.IGetFileName;

public interface IUserLayoutSelectionBase extends  ISchemaProvider {


	void setFileNameField(IGetFileName fileNameField);

	/**
	 * get the Database names
	 * @return Database names
	 */
	String[] getDataBaseNames();

	/**
	 * set the database index
	 * @param idx new index
	 */
	void setDatabaseIdx(int idx);

	/**
	 *
	 * @return Database index
	 */
	int getDatabaseIdx();

	/**
	 *
	 * @return Database name
	 */
	String getDatabaseName();

	/**
	 * Reload Database details
	 */
	void reload();

	/**
	 * Set the layout name
	 * @param layoutName new layout
	 *
	 * @return wether the layout was found
	 */
	boolean setLayoutName(String layoutName);

	void notifyFileNameChanged(String newFileName, boolean fileExists);

	/**
	 *
	 * @param newFileName
	 */
	void notifyFileNameChanged(String newFileName);

	/**
	 * Get the layout Name
	 * @return layout name
	 */
	String getLayoutName();

	/**
	 * retrieve the layout
	 * @return the layout
	 */
	AbstractLayoutDetails getRecordLayout(String fileName);

	boolean isOkToLoadFile(String dataFileName);

	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.re.openFile.ISchemaProvider#getRecordLayout(java.lang.String, java.lang.String)
	 */
	AbstractLayoutDetails getRecordLayout(String name, String fileName);

	/**
	 * set the message field
	 * @param message
	 */
	void setMessage(JTextComponent message);

	boolean isFileBasedLayout();

//	void forceLayoutReload();

//	/**
//	 * @param executeAction the executeAction to set
//	 */
//	void setExecuteAction(IStartActionInterface executeAction);
//
//	/**
//	 * @param pBrowse
//	 * @see net.sf.RecordEditor.re.layoutSelection.def.IStartActionInterface#loadFile(boolean)
//	 */
//	void loadFile(boolean pBrowse);
//
}