package net.sf.RecordEditor.re.openFile;

import java.io.File;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;

import net.sf.RecordEditor.edit.open.BaseList;
import net.sf.recordEditor.ui.listManagers.BasicListItem;
import net.sf.recordEditor.ui.listManagers.IListItem;

public class RecentDirectoryList extends BaseList {


	private final RecentFiles recentFiles;
		
	public RecentDirectoryList(RecentFiles recentFiles) {
		super();
		this.recentFiles = recentFiles;
		recentFiles.addDirListChangedListner(this);
	}


	
	/* (non-Javadoc)
	 * @see com.alee.extended.bm.listManagers.IBasicList#getItemList()
	 */
	@Override
	public List<IListItem> getItemList() {
		List<IListItem> ret = new ArrayList<IListItem>(RecentFiles.RECENT_FILE_LIST);
		HashSet<String> usedDirs = new HashSet<String>();
		int j = 0;
		String s;
		
		for (int i = 0; i < 100; i++) {
			s = new File(recentFiles.getRecentFullFileName(i)).getParent();
			if (s == null || "".equals(s) || usedDirs.contains(s)) {
				
			} else {
				ret.add(new BasicListItem(s, s, s));

				usedDirs.add(s);
				if (j >= RecentFiles.RECENT_FILE_LIST) {
					break;
				}
			}
		}
		return ret;
	}

	/* (non-Javadoc)
	 * @see com.alee.extended.bm.listManagers.IBasicList#getListName()
	 */
	@Override
	public String getListName() {
		return "Directory";
	}
}