package net.sf.RecordEditor.re.openFile;

import java.util.ArrayList;
import java.util.List;

import net.sf.RecordEditor.edit.open.BaseList;
import net.sf.recordEditor.ui.listManagers.BasicListItem;
import net.sf.recordEditor.ui.listManagers.IListItem;

public class RecentFilesListMgr extends BaseList {

	private final RecentFiles recentFiles;
	
	public RecentFilesListMgr(RecentFiles recentFiles) {
		super();
		this.recentFiles = recentFiles;
		recentFiles.addFileListChangedListner(this);
	}

	/* (non-Javadoc)
	 * @see com.alee.extended.bm.listManagers.IBasicList#getItemList()
	 */
	@Override
	public List<IListItem> getItemList() {
		
		List<IListItem> ret = new ArrayList<IListItem>(RecentFiles.RECENT_FILE_LIST);
		String s;
		
		for (int i = 0; i < RecentFiles.RECENT_FILE_LIST; i++) {
			s = recentFiles.getRecentFileName(i);
			if (s != null && ! "".equals(s)) {
				ret.add(new BasicListItem(s, s, recentFiles.getRecentFullFileName(i)));
			}
		}		
		return ret;
	}


	/* (non-Javadoc)
	 * @see com.alee.extended.bm.listManagers.IBasicList#getListName()
	 */
	@Override
	public String getListName() {
		return "Files";
	}
}