package net.sf.RecordEditor.re.tree.cobolItem;

import javax.swing.tree.DefaultMutableTreeNode;

import net.sf.JRecord.detailsBasic.IItemDetails;

@SuppressWarnings("serial")
public class CobolItemNode extends DefaultMutableTreeNode {
	
//	private final AbstractLine line;
	private final IItemDetails cobolItem;
	private       int index;
	private final int indexLvl;
	private final CobolItemNode parent, parentArray;
	
	
	public CobolItemNode(IItemDetails cobolItem,
				int index, int indexLvl,
				CobolItemNode parent, CobolItemNode parentArray) {
		super(cobolItem == null || index >= 0 
							? "Tree Root" 
							: cobolItem.getFieldName());
//		this.line = line;
		this.cobolItem   = cobolItem;
		this.index       = index;
		this.indexLvl    = indexLvl;
		this.parent      = parent;
		this.parentArray = parentArray;
	}
	
	public int getIndex() {
		return index;
	}
	
	public void setIndex(int index) {
		this.index = index;
	}

	public IItemDetails getCobolItem() {
		return cobolItem;
	}
	public int getIndexLvl() {
		return indexLvl;
	}
	
	public int[] buildIndexArray(int adj) {
		int[] ret;

		if (indexLvl >= 0) {
			ret= bldIndexArray(1);
		} else {
			ret = parentArray.bldIndexArray(1);
		}
		ret[indexLvl] += adj;
		
		return ret;
	}
	
	private int[] bldIndexArray(int count) {
		int[] ret;
		if (parentArray == null) {
			ret = new int[count];
		} else {
			ret = parentArray.bldIndexArray(count+1);
		}
		ret[indexLvl] = index;
		return ret;
	}
}
