package net.sf.RecordEditor.re.tree.cobolItem;

import java.util.List;

import net.sf.JRecord.detailsBasic.IItemDetails;

public class ParseItems {
	public int arrayIndexs = 0;
	
	public CobolItemNode root;
	public List<? extends IItemDetails> items;
	
	public CobolItemNode parse(List<? extends IItemDetails> items) {
		this.items = items;
		this.root = new CobolItemNode(null, -1, -1, null, null);
		
		arrayIndexs = Math.max(arrayIndexs, parse(root, null, items));
		
		return this.root;
	}
	
	public int parse(CobolItemNode parent, CobolItemNode parentArray, List<? extends IItemDetails> items) {
		int lvl, maxLvl = 0;
		
		for (IItemDetails item : items) {
			if (item.getOccurs() >= 0) {
				lvl = generateNode(parent, parentArray, item, 0);
				int inc = 1;
				if (lvl == 1) {
					inc = 10;
				}
				for (int i = inc; i < item.getOccurs(); i+=inc) {
					generateNode(parent, parentArray, item, i);
				}					
			} else {
				CobolItemNode node = new CobolItemNode(item, -1, -1, parent, parentArray);
				lvl = parse(node, parentArray, item.getChildItems());
				parent.add(node);
			}
			
			maxLvl = Math.max(lvl, maxLvl);
		}
		
		return maxLvl;
	}

	/**
	 * @param parent
	 * @param parentArray
	 * @param item
	 * @return
	 */
	private int generateNode(CobolItemNode parent, CobolItemNode parentArray, IItemDetails item, int idx) {
		int lvl;
		CobolItemNode node = new CobolItemNode(item, idx, parentArray == null ? 1 : parentArray.getIndexLvl() + 1, parent, parentArray);				
		lvl = parse(node, node, item.getChildItems()) + 1;
		parent.add(node);
		return lvl;
	}

}
