package net.sf.RecordEditor.re.util.csv;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collections;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

import net.sf.RecordEditor.re.jrecord.format.ICellFormat;


public class ColumnDateFormatChk {

	public static final int MAX_ROWS_TO_CHECK = 5000;
	private static final int LENGTH_COUNT_MAX = 16;
	private static final int SLASH_IDX = 0;
	private static final int DOT_IDX = 1;
	private static final int MINUS_IDX = 2;
	private static final int SPACE_IDX = 3;
	private static final int DAY_START_IDX = 4;
	private static final int MONTH_START_IDX = 5;
	private static final int YEAR_START_IDX = 6;
	private static final int CENTURY_START_IDX = 7;
	private static final int DAY_END_IDX = 8;
	//private static final int MONTH_END_IDX = 9;
	private static final int YEAR_END_IDX = 10;
	private static final int CENTURY_END_IDX = 11;
	private static final int MM2_IDX = 12;
	private static final int MM3_IDX = 13;
	private static final int MM4_IDX = 14;
	private static final int MM5_IDX = 15;
	
	private static final int DD_COL1_IDX = 16;
	private static final int DD_COL2_IDX = 17;
	private static final int DD_COL3_IDX = 18;
	private static final int MM_COL1_IDX = 19;
	private static final int MM_COL2_IDX = 20;
	private static final int MM_COL3_IDX = 21;
	
	private static final int YYYY_COL1_IDX = 22;
	private static final int YYYY_COL2_IDX = 23;
	private static final int YYYY_COL3_IDX = 24;
	private static final int YYYY_START_IDX = 25;

	private static final int CYY_START_IDX = 26;

	private static final int ARRAY_SIZE = CYY_START_IDX + 1;
	private static final String[] MONTHS = {
		"jan", "feb", "mar", "apr", "may", "jun", "jul", "aug", "sep", "oct", "nov", "dec"	
	};
	
	private static final int YY1, YY2, CENT1, CENT2, CYY;
	static {
		Calendar c =Calendar.getInstance();
		c.setTime(new Date());
		int year = c.get(Calendar.YEAR);
		//int yy = year % 100;
		CENT1 = (year - 50) / 100;
		CENT2 = (year + 20) / 100;
		CYY = year - 1900 + 30;
		YY1 = year - 60 - CENT1 * 100;
		YY2 = year + 20 - CENT2 * 100;
	}
	
	private final ArrayList<String> cells = new ArrayList<String>(30);
	private final ArrayList<StdDateFormatStr> dateFormats = new ArrayList<StdDateFormatStr>();
	private boolean done = false;
	
//	public ColumnDateFormatChk() {
//	}

	public void add(String cell) {
		cells.add(cell);
	}


	public void addAll(Iterator<String> fields) {
		int idx=0;
		while (fields.hasNext() && idx++ < 3000) {
			cells.add(fields.next());
		}
	}

	public List<StdDateFormatStr> getPossibleDateFormats() {
		analyse();
		return dateFormats;
	}
	
	private void analyse() {
		int cellsToCheck = Math.min(MAX_ROWS_TO_CHECK, cells.size());
		if (done || cellsToCheck < 3) { return ; }
		
		int[] lengthCount = new int[LENGTH_COUNT_MAX + 1];
		int[] counts = new int[ARRAY_SIZE]; 
		int strMonth1 = 0, strMonth2 = 0;
		//char[] seps = {'/', '.', ' '};
		
		for (int i = 0; i < cellsToCheck; i++) {
			String s = cells.get(i);
			int sLength = s.length();
			AnalyseCell ac = new AnalyseCell(s);

			lengthCount[Math.min(LENGTH_COUNT_MAX, sLength)] += 1;
			
			//			int numCount = 0, otherCount = 0;
//			int[] cellCounts = {0, 0, 0, 0, 0,}; 
//			String s = cells.get(i);
//			int sLength = s.length();
//			lengthCount[Math.min(LENGTH_COUNT_MAX, sLength)] += 1;
//			int[] parts = {0, 0, 0};
//			int partNo = 0;
//			int otherCh = 0;
//			
//			for (int sIdx = 0; sIdx < sLength; sIdx++) {
//				switch (s.charAt(sIdx)) {
//				case '0': case '1': case '2': case '3': case '4': 
//				case '5': case '6': case '7': case '8': case '9':
//					numCount += 1;
//					otherCh += 1;
//					break;
//				case '\\':
//					cellCounts[BS_IDX] += 1;
//					if (otherCh > 0) {
//						partNo += 1;
//						otherCh = 0;
//					}
//					break;
//				case '.':
//					cellCounts[DOT_IDX] += 1;
//					if (otherCh > 0) {
//						partNo += 1;
//						otherCh = 0;
//					}
//					break;
//				case '-':
//					cellCounts[MINUS_IDX] += 1;
//					if (otherCh > 0) {
//						partNo += 1;
//						otherCh = 0;
//					}
//					break;
//				case ' ':
//					cellCounts[SPACE_IDX] += 1;
//					break;
//			default:
//					otherCount += 1;
//					otherCh += 1;
//				}
//			}
			
			int otherCountTst = 0;
			if (ac.otherCount >= 3) {
				String lc = s.toLowerCase();
				int idx;
				for (int j = 0; j < MONTHS.length; j++) {
					if ((idx = lc.indexOf(MONTHS[j])) >= 0) {
						if (idx == 0) {
							strMonth1 += 1;
						} else {
							strMonth2 += 1;
						}
						otherCountTst = 3;
						break;
					}
				}
			} 
			if (sLength < 8 && sLength >= 3 && sLength == ac.numCount) {
				int y = sLength < 5 ? 0 : Integer.parseInt(s.substring(0, sLength -4));
				if (y > 19 && y <= CYY) {
					counts[CYY_START_IDX] += 1;
					if (y >= 100) {
						counts[CYY_START_IDX] += 1;
					}
				}
			}
			if (ac.otherCount != otherCountTst && ac.otherCount != otherCountTst + 2) {
				//System.out.println("## " + otherCount);
			} else if (ac.numCount > 1) {
				if (ac.sepIdx >= 0) {
					counts[SLASH_IDX + ac.sepIdx] += 1;

//					System.out.print("  " + ac.parts[2]);
//					if (i % 30 == 0)  System.out.println();
					for (int ci = 0; ci < 3; ci++) {
						if (ac.parts[ci] > 0 && ac.parts[ci] <= 12) {
							counts[DD_COL1_IDX + ci] += 1;
							counts[MM_COL1_IDX + ci] += 1;
						} else if (ac.parts[ci] > 0 && ac.parts[ci] <= 31) {
							counts[DD_COL1_IDX + ci] += 1;
						} else if (ac.parts[ci] > 1400 && ac.parts[ci] <= 2500) {
							counts[YYYY_COL1_IDX + ci] += 1;
						} 
					}
				}
				
				
				if (((sLength == 5 || sLength == 7) && ac.numCount == 5)
				||   (sLength == 7 && ac.numCount == 7)) {
					s = '0' + s;
					sLength += 1;
				} else if (sLength == ac.numCount && (sLength == 3 || sLength == 4)) {
					s = "000".substring(sLength-3) + s;
					sLength = 6;
				}
				if (sLength > 5) {
					check4DateType(s, 0, counts);
					check4DateType(s, sLength - 2, counts);
					
					if ((sLength == 6 || sLength == 8 || sLength == 10) ) {
						int en = sLength == 10 ? 6 : 5;
						int tst;
						for (int st = 2; st < en; st++) {
							if ((tst = int2ch(s, st)) > 0 && (tst <= 12)) {
								counts[MM2_IDX + st - 2] += 1;
							}
						}
					}
					int tst1 = int2ch(s, 0), tst2= int2ch(s, 2);
					if (tst1 > 14 && tst1 < 30 && tst2 >= 0) {
						counts[YYYY_START_IDX] += 1;
					}
				}
			}
		}
		
		int size = StdDateFormatStr.DATE_FORMATS.size();
		int chkCount = cellsToCheck * 8 / 10;
		ArrayList<DateFormatItem> possibleDateFormats = new ArrayList<ColumnDateFormatChk.DateFormatItem>();
		for (int i = 1; i < size; i++) {
			
			StdDateFormatStr df = StdDateFormatStr.DATE_FORMATS.get(i);
			
//			if (df.idxStringMonth>0) {//dateFormatStr.startsWith("dd")) {
//			System.out.println(			df.dateDisplayStr
//					 + " --> " + df.dayFirst+ ", " + (counts[DAY_START_IDX] + " > " + chkCount )
//					 + " --> " +df.monthFirst+ ", " + (counts[MONTH_START_IDX] )
//					 + " --> " +df.yyFirst+ ", " + (counts[YEAR_START_IDX] )   
//					 + " --> " +df.yyLast+ ", " + (counts[YEAR_END_IDX])
//					 + " --> " +df.dayLast+ ", " + (counts[DAY_END_IDX] )
//					 + " --> "+ "\\".equals(df.sep)+ ", " + (counts[BS_IDX] >= chkCount)
//					 + " --> "+ ".".equals(df.sep) + ", " + (counts[DOT_IDX] >= chkCount)    
//					 + " --> -".equals(df.sep) + ", " + (counts[MINUS_IDX] >= chkCount)
//					 + " -->  ".equals(df.sep) + ", " + (counts[SPACE_IDX] >= chkCount)
//					 );
//			}
			
			boolean ok;
			if (df.sep.length() == 0) {
//				System.out.println(df.dateFormatStr
//						+ " " + df.dayFirst+ " ~ " + counts[DAY_START_IDX] + " >= " +chkCount
//						+ " " + df.monthFirst+ " ~ " + counts[MONTH_START_IDX] + " >= " +chkCount
//						+ " " + df.yyFirst+ " ~ " + counts[YEAR_START_IDX] + " >= " +chkCount
//						+ " " + df.yyLast+ " ~ " + counts[YEAR_END_IDX] + " >= " +chkCount
//						+ " " + df.dayLast+ " ~ " + counts[DAY_END_IDX] + " >= " +chkCount
//						+ " " + (df.positionMM == 2)+ " ~ " + counts[MM2_IDX] + " >= " +chkCount
//						+ " " + (df.positionMM == 3)+ " ~ " + counts[MM3_IDX] + " >= " +chkCount
//						+ " " + (df.positionMM == 4)+ " ~ " + counts[MM4_IDX] + " >= " +chkCount
//						+ " " + (df.positionMM == 5)+ " ~ " + counts[MM5_IDX] + " >= " +chkCount
//						+ " " + df.yyyyFirst+ " ~ " + counts[YYYY_START_IDX] + " >= " +chkCount
//						+ " " + (df.yyyyPresent && df.yyLast)+ " ~ " + counts[CENTURY_END_IDX] + " >= " +chkCount 
//						//+ " " + ! df.yyyyPresent + " ~ " + counts[YYYY_START_IDX] + counts[CENTURY_END_IDX] + " <= " + (cellsToCheck - chkCount) 
//						+ " " +( counts[SLASH_IDX] + counts[DOT_IDX] + counts[MINUS_IDX] + counts[SPACE_IDX]) + " <= " + (cellsToCheck - chkCount)
//						);
				if (df.fieldFormat == ICellFormat.FMT_DATE_CYMD) {
					ok = counts[CYY_START_IDX] >= cellsToCheck * 3 / 2 
						&& counts[MM4_IDX] > cellsToCheck / 2
						&& counts[DAY_END_IDX] >= chkCount;
				} else {
					ok =	lengthCount[df.dateFormatStr.length()] + lengthCount[df.dateFormatStr.length()-1] >= chkCount
							
						&&  chk(df.dayFirst, counts[DAY_START_IDX] >= chkCount)
						&&  chk(df.monthFirst, counts[MONTH_START_IDX] >= chkCount)
						&&  chk(df.yyFirst, counts[YEAR_START_IDX] >= chkCount)
						&&  chk(df.yyLast, counts[YEAR_END_IDX] >= chkCount)
						&&  chk(df.dayLast, counts[DAY_END_IDX] >= chkCount)
						&&  chk(df.positionMM == 2, counts[MM2_IDX] >= chkCount)
						&&  chk(df.positionMM == 3, counts[MM3_IDX] >= chkCount)
						&&  chk(df.positionMM == 4, counts[MM4_IDX] >= chkCount)
						&&  chk(df.positionMM == 5, counts[MM5_IDX] >= chkCount)
						&&  chk(df.yyyyFirst, counts[YYYY_START_IDX] >= chkCount)
						&&  chk(df.yyyyPresent && df.yyLast, counts[CENTURY_END_IDX] >= chkCount )
						//&&  chk(! df.yyyyPresent , counts[YYYY_START_IDX] + counts[CENTURY_END_IDX] <= cellsToCheck - chkCount )
						&& counts[SLASH_IDX] + counts[DOT_IDX] + counts[MINUS_IDX] + counts[SPACE_IDX] <= cellsToCheck - chkCount
	
						;
				}
			} else {
//				System.out.println(	df.dateFormatStr	+ ">" + df.sep + "<"		
//						+ " " + df.dayFirst                         + " ~ " + counts[DD_COL1_IDX] + " >= " + chkCount
//						+ " " + (! (df.dayFirst || df.dayLast))        + " ~ " + counts[DD_COL2_IDX] + " >= " + chkCount
//						+ " " + df.dayLast                           + " ~ " + counts[DD_COL3_IDX] + " >= " + chkCount
//						+ " " + df.monthFirst                        + " ~ " + counts[MM_COL1_IDX] + " >= " + chkCount
//						+ " mm " + df.monthMiddle    + " ~ " + counts[MM_COL2_IDX] + " >= " + chkCount
//						+ " " + df.monthLast                         + " ~ " + counts[MM_COL3_IDX] + " >= " + chkCount
//						+ " " + "/"  + " ~ " + counts[SLASH_IDX] + " >= " + chkCount
//						+ " " + "."  + " ~ " + counts[DOT_IDX] + " >= " + chkCount
//						+ " " + "-"  + " ~ " + counts[MINUS_IDX] + " >= " + chkCount                 
//						+ " " + "space"   + " ~ " + counts[SPACE_IDX] + " >= " + chkCount );
				
				ok =  chk(df.dayFirst,                         counts[DD_COL1_IDX] >= chkCount)
				  &&  chk(! (df.dayFirst || df.dayLast),       counts[DD_COL2_IDX] >= chkCount)
				  &&  chk(df.dayLast,                          counts[DD_COL3_IDX] >= chkCount)
				  &&  chk(df.monthFirst,    counts[MM_COL1_IDX] >= chkCount)
				  &&  chk(df.monthMiddle,   counts[MM_COL2_IDX] >= chkCount)
				  &&  chk(df.monthLast,     counts[MM_COL3_IDX] >= chkCount)
				  &&  chk(df.yyyyPresent,   counts[YYYY_COL1_IDX + df.idxYYYY] >= chkCount)
				  &&  chk(!df.yyyyPresent, 
						  counts[YYYY_COL1_IDX]+counts[YYYY_COL2_IDX]+counts[YYYY_COL3_IDX] <= cellsToCheck - chkCount)
				  &&  ("/".equals(df.sep)  == (counts[SLASH_IDX] >= chkCount))
				  &&  (".".equals(df.sep)  == (counts[DOT_IDX] >= chkCount))
				  &&  ("-".equals(df.sep)  == (counts[MINUS_IDX] >= chkCount))
				  &&  (" ".equals(df.sep)  == (counts[SPACE_IDX] >= chkCount));
			}

			if (ok 
			&&  chk(df.idxStringMonth == 0, strMonth1 >= chkCount)
			&&  chk(df.idxStringMonth > 0, strMonth2 >= chkCount)

			) {
				ICheckDateString check = df.getDateCheck();
				int matches = 0;
				for (int j = 0; j < cellsToCheck; j++) {
					if (check.check(cells.get(j))) {
						matches += 1;
					}
				}

				if (matches >= cellsToCheck / 2 ) {
					possibleDateFormats.add(new DateFormatItem(matches, df) );
				}
			}
		}
		
		if (possibleDateFormats.size() > 1) {
			Collections.sort(possibleDateFormats);
		}
		for (DateFormatItem dfi :  possibleDateFormats) {
			dateFormats.add(dfi.df);
		}
	}
	
	private boolean chk(boolean value, boolean tstResult) {
		return (! value) || (value && tstResult);
	}
	
	private void check4DateType(String s, int start, int[] counts) {
		int idx = DAY_START_IDX;
		int yyStart = start;
		if (start != 0) {
			idx = DAY_END_IDX;
			yyStart -= 2;
		}
		
		int tst = int2ch(s, start);
		if (tst >= 0) {
			if (tst > 0 && tst <= 12) {
				counts[idx] += 1;
				counts[idx + MONTH_START_IDX - DAY_START_IDX] += 1;
			} else if (tst > 0 && tst <= 31) {
				counts[idx] += 1;
			}
			
			if (YY1 > YY2) {
				if (YY1 < tst || tst < YY2) {
					counts[idx + YEAR_START_IDX - DAY_START_IDX] += 1;
				}
			} else {
				if (YY1 < tst && tst < YY2) {
					counts[idx + YEAR_START_IDX - DAY_START_IDX] += 1;
				}
			}
		}
		tst = int2ch(s, yyStart);
		if (tst == CENT1 || tst == CENT2) {
			counts[idx + CENTURY_START_IDX - DAY_START_IDX] += 1;
		}
	}
	
	private int int2ch(String s, int start ) {
		int tst = Integer.MIN_VALUE;
		char ch1 = s.charAt(start);
		char ch2 = s.charAt(start+1);
		if (ch1 >= '0' && ch1 <= '9' && ch2 >= '0' && ch2 <= '9') {
			tst = (ch1 - '0') * 10 + ch2 - '0';
		}
		
		return tst;
		
	}
	
	private static class DateFormatItem  implements Comparable<DateFormatItem>{
		public final int count;
		public final StdDateFormatStr df ;
		public DateFormatItem(int count, StdDateFormatStr df) {
			super();
			this.count = count;
			this.df = df;
		}
		
		@Override
		public int compareTo(DateFormatItem o) {
			return Integer.compare(o.count, count);
		}
		
		
	}
	
	private static class AnalyseCell {
		final int[] parts = {0, 0, 0};
		int partIdx = 0, numCount=0, otherCount=0;
		int otherCh = 0;
		final int[] cellCounts =  {0, 0, 0, 0, 0,};
		
		int sepIdx = -1;

		public AnalyseCell(String s) {
//			this.cellCounts = cellCounts;
			int sLength = s.length();
			for (int sIdx = 0; sIdx < sLength; sIdx++) {
				char charAt = s.charAt(sIdx);
				switch (charAt) {
				case '0': case '1': case '2': case '3': case '4': 
				case '5': case '6': case '7': case '8': case '9':
					numCount += 1;
					otherCh += 1;
					if (partIdx < parts.length) {
						parts[partIdx] = parts[partIdx] * 10 + charAt - '0'; 
					}
					break;
				case '/':
					updateSeperator(SLASH_IDX);
					break;
				case '.':
					updateSeperator(DOT_IDX);
					break;
				case '-':
					updateSeperator(MINUS_IDX);
					break;
				case ' ':
					updateSeperator(SPACE_IDX);
					break;
				default:
					otherCount += 1;
					otherCh += 1;
				}
			}
			
			if (cellCounts[SLASH_IDX] + cellCounts[DOT_IDX] + cellCounts[SPACE_IDX] + cellCounts[MINUS_IDX]== 2) {
				for (int j = 0; j < cellCounts.length; j++) {
					if (cellCounts[j] == 2) {
						sepIdx = j;
						break;
					}
				}
			}

		}

		private void updateSeperator(int dx) {
			cellCounts[dx] += 1;
			if (otherCh > 0) {
				partIdx += 1;
				otherCh = 0;
			}
		}
	}
}
