package net.sf.RecordEditor.re.util.csv;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusAdapter;
import java.awt.event.FocusEvent;
import java.awt.event.KeyAdapter;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.StringTokenizer;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.Icon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.SwingUtilities;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableModel;
import javax.swing.text.JTextComponent;

import net.sf.JRecord.ByteIO.ByteTextReader;
import net.sf.JRecord.Common.Conversion;
import net.sf.JRecord.Common.IFileStructureConstants;
import net.sf.JRecord.CsvParser.CsvParserManagerChar;
import net.sf.JRecord.Details.IGetSchema;
import net.sf.JRecord.Details.LayoutDetail;
import net.sf.JRecord.Details.schema.MultiFormatSchema;
import net.sf.RecordEditor.re.codeGen.CodeGenOptionWiz;
import net.sf.RecordEditor.re.popups.MenuPopupListener;
import net.sf.RecordEditor.re.util.openTabPane.IFilePreview;
import net.sf.RecordEditor.utils.charsets.FontCombo;
import net.sf.RecordEditor.utils.common.Common;
import net.sf.RecordEditor.utils.edit.ManagerRowList;
import net.sf.RecordEditor.utils.fileAnalysis.CharsetDetails;
import net.sf.RecordEditor.utils.fileAnalysis.CheckEncoding;
import net.sf.RecordEditor.utils.fileAnalysis.CsvAnalyser;
import net.sf.RecordEditor.utils.fileAnalysis.CsvSchemaBuilder;
import net.sf.RecordEditor.utils.lang.LangConversion;
import net.sf.RecordEditor.utils.lang.ReAbstractAction;
import net.sf.RecordEditor.utils.swing.BaseHelpPanel;
import net.sf.RecordEditor.utils.swing.BasePanel;
import net.sf.RecordEditor.utils.swing.BmKeyedComboBox;
import net.sf.RecordEditor.utils.swing.BmKeyedComboModel;
import net.sf.RecordEditor.utils.swing.SwingUtilsBldr;
import net.sf.RecordEditor.utils.swing.ComboBoxs.DelimiterCombo;
import net.sf.RecordEditor.utils.swing.ComboBoxs.QuoteCombo;
import net.sf.recordEditor.ui.form.FormBuilder;
import net.sf.recordEditor.ui.form.FormHelper;
import net.sf.recordEditor.ui.form.LineBuilder;
import net.sf.recordEditor.ui.form.ThreeColumnFormBuilder;
import net.sf.recordEditor.ui.icons.IconManager;
import net.sf.recordEditor.ui.xEnvironment.SwingUtils;


@SuppressWarnings("serial")
public class CsvSelectionPanel extends BaseFilePreview implements IFilePreview {


	//private static final int FILE_HEIGHT = SwingUtils.values().TABLE_ROW_HEIGHT * 27 / 2;


	private static final String COLUMN_NAMES_LINE_NUMBER = "Column Names Line Number";

	private static final String PANEL_ID = "CsvPnl";

	private JTextComponent messageTxt;
	
	private boolean isByteBased = true;

	private CsvParserManagerChar parserManager = CsvParserManagerChar.getInstance();
	private MenuPopupListener popup;
	private String	lastFont = null,
					lastSeperator = null,
					filename;
//	private String[] lines = null;
//	private int lines2display = 0;
	 


	private BmKeyedComboModel styleModel = new BmKeyedComboModel(
												new ManagerRowList(parserManager, false));
    public final DelimiterCombo fieldSeparatorCombo;
    public final JTextField fieldSepTxt = new JTextField(5);
    public final JTextField quoteTxt = new JTextField(5);
    public final QuoteCombo quoteCombo = QuoteCombo.newCombo();
    //public JTextField fontTxt = new JTextField();
    //private final TreeCombo charsetCombo = new TreeCombo(null);
    private final FontCombo charsetCombo = new FontCombo();

    public BmKeyedComboBox  parseType  = new BmKeyedComboBox(styleModel, false);

    public final JCheckBox  fieldNamesOnLine = new JCheckBox();
    public       JLabel     nameLineNumLbl;
    public final JTextField nameLineNumTxt = new JTextField(5);
    public final JCheckBox  checkTypes = new JCheckBox();
    public final JCheckBox  embeddedCrJCheck = new JCheckBox();

    public final JButton goBtn;
    public final JButton cancelBtn = SwingUtilsBldr.newButton("Cancel");
    private JButton wizardBtn;

    private final JTable tbl; //= new JTable();

    private AbstractCsvTblMdl tblMdl;
    private LineTableRender tblRendor = new LineTableRender();
    private JTextComponent message;

    private final boolean externalTbl;
    private boolean    doAction = true;
    private byte[][]  dataLines = null;
    private byte[] data;
    private boolean useMyType = false;
    
    private ThreeColumnFormBuilder form = FormBuilder.threeColumnForm(PANEL_ID, pnl)
				.setFieldCoumnCount(4)
				.setColumnSizesToAnything(FormHelper.formFieldWidths(
						FormHelper.PREFERRED,
						FormHelper.PREFERRED, FormHelper.PREFERRED, FormHelper.PREFERRED, FormHelper.PREFERRED,
						FormHelper.PREFERRED, FormHelper.FILL
				))
				.setFieldPosition(FormBuilder.LEFT)
				//.setLabelPosition(FormBuilder.LEFT)
				.setShowHelp(true)
			.form();


    private ActionListener changedAction = new ActionListener() {
    	   public void actionPerformed(ActionEvent e) {

    		   if (doAction) {
    			   valueChanged();
    		   }
    	   }
    };
    private ChangeListener changeListner = new ChangeListener() {

		/* (non-Javadoc)
		 * @see javax.swing.event.ChangeListener#stateChanged(javax.swing.event.ChangeEvent)
		 */
		@Override
		public void stateChanged(ChangeEvent e) {
 			if (doAction) {
 				if ((lastFont == null || ! lastFont.equals(getFontName()))) {
 					setData(filename, data, false, "");
					//valueChanged(false);
 				}
		   }
		}
    };

    private ActionListener fieldNamesChanged = new ActionListener() {
   	   public void actionPerformed(ActionEvent e) {

			updateWizardBtn();

	   		if (doAction) {
	   		   tblMdl.setSeperator(getSeperator());
	   		   tblMdl.setHideFirstLine(fieldNamesOnLine.isSelected());

	   		   valueChanged();
	   		}
   	   }
    };

    private ChangeListener quoteChanged  = new ChangeListener() {
    	public void stateChanged(ChangeEvent e)  {
	 		if (doAction) {
	 			if (firstCsvLine > 1) {
	 				reReadData(true);
	 			}
 				valueChanged();
	 		}
    	}
     };

     private ChangeListener sepChanged  = new ChangeListener() {
     	public void stateChanged(ChangeEvent e)  {
 	 		if (doAction) {
 	 			String seperator = getSeperator();
 	 			if ((! seperator.equals(lastSeperator))
 	 			||	embeddedCrJCheck.isSelected()) {
 	 				lastSeperator = seperator;
 	 				
 	 				reReadData(true);
 	 			}
  				valueChanged(false);
 	 		}
     	}
      };

     private ActionListener crChanged = new ActionListener() {
     	public void actionPerformed(ActionEvent e) {

 	 		if (doAction) {
 	 			if (embeddedCrJCheck.isSelected() && "".equals(getQuote())) {
 	 				try {
 	 					doAction = false;

 	 					tblMdl.setEmbedded(true);
 	 					CsvAnalyser anaylyser = tblMdl.getAnalyser(AbstractCsvTblMdl.DERIVE_SEPERATOR);
 	 					setQuoteCombo(anaylyser);
 	 					setQuoteTxt(anaylyser.getSpecialQuote());		
 	 				} finally {
 	 					doAction = true;
 	 				}
 	 			}
 	 			reReadData(firstCsvLine > 1);
 	 			valueChanged(false);
 	 		}
 	 		if (embeddedCrJCheck.isSelected() && "".equals(getQuote())) {
	 			CsvSelectionPanel.this.setMessageTxtRE("You must specify a quote when embedded Cr is used");
 	 		}
      	}

      };
	/**
	 * @param anaylyser
	 */
	private void setQuoteCombo(CsvAnalyser anaylyser) {
		String quote = anaylyser.getQuote();

		if (isPresent(quote)) {
			quoteCombo.setTextValue(quote);;
		} else {
			quoteCombo.setSelectedIndex(0);
		}
	}

	/**
	 * @param str
	 * @return
	 */
	private boolean isPresent(String str) {
		return str != null && str.length() != 0;
	}

    private FocusAdapter focusHandler = new FocusAdapter() {
    	public void focusLost(FocusEvent e) {

    		boolean reRead = true;
    		String seperator = getSeperator();
			if ((e.getSource() == charsetCombo.getTextCompenent()
			&& (lastFont == null || ! lastFont.equals(getFontName()))) ) {
    			lastFont = getFontName();
//    			if (dataLines == null) {
    				setData(filename, data, false, "");
    				reRead = false;
//    			} else {
//    				setData(dataLines, lastFont);
//    			}
			} else if (e.getSource() == embeddedCrJCheck
		    		|| (   (e.getSource() == fieldSeparatorCombo || e.getSource() == fieldSepTxt)
		        		&& (! seperator.equals(lastSeperator) )	)) {
    			lastSeperator = seperator;
    			if (dataLines == null) {
    				reReadData(firstCsvLine > 1);
    				reRead = false;
    			} else {
    				setData(dataLines, lastFont);
    			}
    		} else if (embeddedCrJCheck.isSelected() && dataLines == null) {
    			reReadData(false);
    			reRead = false;
    		} else if (e.getSource() == nameLineNumTxt) {
    			try {
					setFirstCsvLineValue(Integer.parseInt(nameLineNumTxt.getText()));
				} catch (NumberFormatException e1) {
					e1.printStackTrace();
				}
    		}
    		valueChanged(reRead);
    	}
    };


	public CsvSelectionPanel(byte[][] dataLines, String font,
			boolean showCancel, JTextComponent msg) {
		this(dataLines, font, showCancel,  "", msg, false, false, null);
    };


	public CsvSelectionPanel(byte[][] dataLines, String font,
			boolean showCancel, String heading, JTextComponent msg,
			boolean adjustableTblHeight,  boolean showGenBtn,
			Action wizardAction) {
		super(null, true);
	
		this.goBtn = SwingUtilsBldr.newButton("Go");
		tbl = new JTable();
		//linesTbl.setDefaultRenderer(Object.class, tblRendor);
		externalTbl = false;
		fieldSeparatorCombo = DelimiterCombo.NewDelimCombo();
		message = msg;

		init_100_SetupFields();
		init_200_LayoutScreen(showCancel, true, showGenBtn, heading, adjustableTblHeight, wizardAction);

		setData(dataLines, font);
	};


	public CsvSelectionPanel(byte[] data, String font,
			boolean showCancel, String heading, JTextComponent msg,
			boolean adjustableTblHeight, boolean showGenCodeBtn,
			Action wizardAction) {
		this(data, font, showCancel, false, heading, msg, adjustableTblHeight, wizardAction, true, 
				showGenCodeBtn, new JTable(), "Go");
	};


	public CsvSelectionPanel(byte[] data, String font,
			boolean showCancel, boolean useMyType,
			String heading, JTextComponent msg,
			boolean adjustableTblHeight,
			Action wizardAction,
			boolean displayTbl,
			JTable jTbl,
			String goLbl) {
		this(data, font, showCancel, useMyType, heading, msg, adjustableTblHeight, wizardAction, displayTbl,
				false, jTbl, goLbl);
	};
	


	private CsvSelectionPanel(byte[] data, String font,
			boolean showCancel, boolean useMyType,
			String heading, JTextComponent msg,
			boolean adjustableTblHeight,
			Action wizardAction,
			boolean displayTbl,
			boolean showGenCodeBtn,
			JTable jTbl,
			String goLbl) {
		super(null, true);
		
		
		this.useMyType = useMyType;
		tbl = jTbl;
		message = msg;
		isByteBased = false;
		fieldSeparatorCombo = DelimiterCombo.NewDelimCombo();
		this.goBtn = SwingUtilsBldr.newButton(goLbl);
		this.externalTbl = ! displayTbl;

		setData(filename, data, true, null);

		init_100_SetupFields();
		init_200_LayoutScreen(showCancel, displayTbl, showGenCodeBtn, heading, adjustableTblHeight, wizardAction);
		valueChanged(false);
	};


//	@Override
//	public JPanel getPanel() {
//		return this;
//	}


	@Override
	public JButton getGoButton() {
		return goBtn;
	}


	@Override
	public String getFontName() {
		String font = charsetCombo.getText();
		if (Conversion.DEFAULT_CHARSET_DETAILS.isMultiByte
		&& (font == null || font.length() == 0)) {
			if (isByteBased) {
				font = Conversion.getDefaultSingleByteCharacterset();
			} else {
				font = Conversion.DEFAULT_CHARSET_DETAILS.charset;
			}
		}
		return font;
	}


	private void setData(byte[][] dataLines, String font) {
		CsvAnalyser anaylyser = new CsvAnalyser(dataLines, -1, font, embeddedCrJCheck.isSelected());
		setUpSeperator(anaylyser);

		this.dataLines = dataLines;

		tblMdl = new CsvSelectionTblMdl();
		tblMdl.setLines(dataLines, font);
		tblMdl.setFieldLineNo(getFieldLineNo());

		tbl.setModel(tblMdl);
		valueChanged(true);
	}



	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.utils.csv.FilePreview#setData(byte[], boolean)
	 */
	@Override
	public boolean setData(String filename, byte[] data, boolean checkCharset, String layoutId) {
		
		this.filename = filename;
		if (layoutId != null && ! "".equals(layoutId)) {
			setFileDescription(layoutId);
		}

		String font = getFontName();
		CsvAnalyser anaylyser;
		boolean reRead = false;


		this.data = data;
		if (data == null || data.length == 0) {
			return false;
		}
		dataLines = null;
		this.lastFont = font;

		CharsetDetails charsetDetails = CheckEncoding.determineCharSet(data);
		if (checkCharset) {
			setCharset(charsetDetails.charset);
		} else if (Conversion.averageBytesPerChar(font) > 1.9 && isBinarySep()) {
			try {
				doAction = false;
				fieldSeparatorCombo.setSelectedIndex(0);	
			} finally {
				doAction = true;
			}
		}
		setCharsetCombo(charsetDetails);


		setTblMdl(isBinarySep() || possibleBinarySep(data, font), font);

		//anaylyser = new CsvAnalyser(tblMdl.getLinesString(), -1, font);
		anaylyser = tblMdl.getAnalyser(AbstractCsvTblMdl.DERIVE_SEPERATOR);

		int firstCsvData = anaylyser.getFieldNameLineNo();
		boolean embeded = anaylyser.isLikelyEmbeddedCr();
		boolean embededSelect = embeddedCrJCheck.isSelected();
		reRead = (embeded && ! embededSelect) 
				|| embededSelect && isPresent(anaylyser.getQuote()) && "".equals(getQuote());
		setUpSeperator(anaylyser);

		this.setFirstCsvLine(firstCsvData);
		tblMdl.setFieldLineNo(firstCsvData);

		tbl.setModel(tblMdl);
		valueChanged(reRead);

		return anaylyser.isValidChars();
	}


	public final void setCharset(String charset) {

		boolean holdAction = doAction;
		try {
			doAction = false;
			charsetCombo.setTextSilently(charset);
			if (Conversion.averageBytesPerChar(charset) > 1.9 && isBinarySep()) {
				fieldSeparatorCombo.setSelectedIndex(0);
			}
		} finally {
			doAction = holdAction;
		}
	}

	private void setCharsetCombo(CharsetDetails dtls) {

		//TreeComboItem[] items;
		//String currCharset = getFontName();
		//TreeComboItem currCharsetItm = new TreeComboItem(1, currCharset, currCharset);
		String[] likelyCharsets = dtls.likelyCharsets;
		if (likelyCharsets == null || likelyCharsets.length == 0) {
			//items = new TreeComboItem[] {new TreeComboItem(1, currCharset, currCharset)};
		} else {
//			int noCharSets = likelyCharsets.length + 1;
//			int j = 0;

			ArrayList<String> charsets = new ArrayList<String>(likelyCharsets.length + 2);
			charsets.add("");
			if (Conversion.DEFAULT_CHARSET_DETAILS.isMultiByte) {
				charsets.add(Conversion.DEFAULT_ASCII_CHARSET);
			}
			
			for (String c : likelyCharsets) {
				if (c.trim().length() > 0) {
					charsets.add(c);
					//break;
				}
			}

			charsetCombo.setFontList(charsets.toArray(new String[charsets.size()]));
		}
	}

	private boolean possibleBinarySep(byte[] data, String font)  {
		boolean ret = false;

		if (Conversion.isSingleByte(font)) {
			try {
				List<byte[]> l = ByteTextReader.readStream(font, new ByteArrayInputStream(data), 90);
				byte[][] lines = l.toArray(new byte[l.size()][]);
				String sep = CsvAnalyser.getSeperator(lines, lines.length, font);

				ret = sep != null && sep.startsWith("x'");
			} catch (IOException e) {
				e.printStackTrace();
			}
		}

		return ret;
	}

//	private void reReadData() {
//		reReadData(false);
//	}

	private void reReadData(boolean checkForColumnNames) {

		if (data == null || (dataLines != null && ! checkForColumnNames)) {
			return;
		}

		setTblMdl(isBinarySep(), getFontName());

		if (checkForColumnNames) {
			checkColumnNames(tblMdl.getAnalyser(AbstractCsvTblMdl.USE_CURRENT_SEPERATOR));
		}
//		tblMdl.setFieldLineNo(getFieldLineNo());
		tbl.setModel(tblMdl);
	}

	private void setTblMdl(boolean useByteMdl, String font) {

		if (useByteMdl) {
			tblMdl = new CsvSelectionTblMdl();
		} else {
			tblMdl = new CsvSelectionStringTblMdl(parserManager);
		}

		tblMdl.setParserType(((Integer) parseType.getSelectedItem()).intValue());
		tblMdl.setQuote(Conversion.decodeCharStr(getQuote(), font, '"'));
		tblMdl.setSeperator(getSeperator()); 
		//boolean embeddedCr = embeddedCrJCheck.isSelected();
		
		tblMdl.setFieldLineNo(fieldNamesOnLine.isSelected() ? getFieldLineNo() : 1);

		tblMdl.setDataFont(data, font, embeddedCrJCheck.isSelected());
	}

	/**
	 * Setup screen fields
	 *
	 */
	private void init_100_SetupFields() {

		setFirstCsvLine("1", 1);
		//fieldSeparatorCombo.addFocusListener(focusHandler);
		fieldSepTxt.addFocusListener(focusHandler);
		quoteCombo.addFocusListener(focusHandler);
		quoteTxt.addFocusListener(focusHandler);
		parseType.addFocusListener(focusHandler);
		charsetCombo.getTextCompenent().addFocusListener(focusHandler);
		fieldNamesOnLine.addFocusListener(focusHandler);
		nameLineNumTxt.addFocusListener(focusHandler);
		embeddedCrJCheck.addFocusListener(focusHandler);

		fieldSeparatorCombo.addTextChangeListner(sepChanged);
		quoteCombo.addTextChangeListner(quoteChanged);
		quoteTxt.addActionListener(changedAction);
		parseType.addActionListener(changedAction);
		charsetCombo.addTextChangeListner(changeListner);
		fieldNamesOnLine.addActionListener(fieldNamesChanged);
		embeddedCrJCheck.addActionListener(crChanged);
	}

	private void init_200_LayoutScreen(
			boolean showCancel, boolean displayTbl, boolean showGenCodeBtn,
			String heading, boolean adjustableTblHeight, Action wizardAction) {
		double fileTblHeight = SwingUtils.values().TABLE_ROW_HEIGHT * 27 / 2;
		JPanel fieldSeperatorPnl = init_200_bld2fieldPnl(fieldSeparatorCombo, fieldSepTxt, "FieldSep");
		JPanel quotePnl = init_200_bld2fieldPnl(quoteCombo, quoteTxt, "Quote");
		//pnl1.add(BorderLayout.WEST, pnl);
		
		//super.setFieldsToActualSize();
		//super.setAddFillToEnd(true);
		BasePanel.setToCommonWidth(1, 10, fieldSeparatorCombo, quoteCombo);
		BasePanel.setToCommonWidth(1, 15, fieldSeperatorPnl, quotePnl, charsetCombo);

		if (adjustableTblHeight) {
			fileTblHeight = BasePanel.FILL;
		} else if (! isByteBased) {
			fileTblHeight -= SwingUtils.values().TABLE_ROW_HEIGHT * 2;
		}
		if (heading != null && ! "".equals(heading)) {
			JLabel headingLabel = new JLabel("  " + heading + "  ");
			Font font = headingLabel.getFont();
			headingLabel.setBackground(Color.WHITE);
			headingLabel.setOpaque(true);
			headingLabel.setFont(new Font(font.getFamily(), Font.BOLD, font.getSize() +2));

//			this.addHeadingComponentRE(headingLabel);
			form.cell(headingLabel, FormBuilder.FULL_WIDTH, 1, 1, form.fieldColumnCount);
			form.setGap(FormHelper.GAP0);
		}
		JButton genBtn = null;
		if (showGenCodeBtn) {
			genBtn = new JButton(new AbstractAction("Generate Code", IconManager.ICONS.generate.icon()) {
				@Override public void actionPerformed(ActionEvent e) {
					if (filename == null) {
						JOptionPane.showMessageDialog(null, "No File Selected - Can not generate code");
						return;
					}
					LayoutDetail layout = getLayout(false, charsetCombo.getText(), null);
					if (layout.getRecordCount() == 0 || layout.getRecord(0).getFieldCount() == 0) {
						JOptionPane.showMessageDialog(null, "Selected File is not a valid CSV file - Can not generate code");
						return;
					}
					CodeGenOptionWiz.newTreeWizard(
							CsvSelectionPanel.this,
							new MultiFormatSchema(false, layout), 
							new MultiFormatSchema(true, getLayout(true, charsetCombo.getText(), null)), 
							filename, null);
					
//					new GenerateSelection(layout, getLayout(true, charsetCombo.getText(), null), filename, null)
//							.dialog.setVisible(true);
				}
			});
		}
		form
			
				.ls(     "Field Seperator", fieldSeperatorPnl, genBtn)	.setGap(FormHelper.GAP0)
				.ls(               "Quote", quotePnl)					.setGap(FormHelper.GAP0);

		if (! isByteBased) {
			form.ls(                "Font", charsetCombo)				.setGap(FormHelper.GAP0);
		}

		form.ls(                  "Parser", parseType)		;

		nameLineNumLbl = new JLabel(COLUMN_NAMES_LINE_NUMBER);
		LineBuilder<ThreeColumnFormBuilder> line = form.line()
				.add("Column Names present")	.add(fieldNamesOnLine, FormBuilder.LEFT)
				.add("")
				.add(nameLineNumLbl)			.add(nameLineNumTxt, FormBuilder.LEFT);
		if ( wizardAction != null ) {
//			form.ls(       "Names on Line", fieldNamesOnLine);
//		} else {
			wizardBtn = new JButton(wizardAction);
			//form.ls(       "Names on Line", fieldNamesOnLine, wizardBtn);
			line.add(wizardBtn, FormBuilder.LEFT);			
		} else if (showCancel) {
			line.add(goBtn, FormBuilder.LEFT);						
		}
		line.lineEnd();
		if (showCancel) {
			form//.ls("Line Number of Names", nameLineNoTxt, goBtn)	    	.setGapRE(ScreenConstants.GAP)
				.ls(    "set Column Types", checkTypes)
				.ls(  "embedded New Lines", embeddedCrJCheck, cancelBtn)	.setGap(FormHelper.GAP);
		} else {
			form//.ls("Line Number of Names", nameLineNoTxt)
				.ls(    "set Column Types", checkTypes)
				.ls(  "embedded New Lines", embeddedCrJCheck, goBtn)		.setGap(FormHelper.GAP1);
		}

		if (displayTbl) {
			form.ls(new JScrollPane(tbl), FormBuilder.FULL_WIDTH, 1, 1, form.lastColumn)	
				.setRowHeight(fileTblHeight);;
//			addComponentRE(
//					1, 6, fileTblHeight, ScreenConstants.GAP,
//			        ScreenConstants.FULL, ScreenConstants.FULL,
//			        linesTbl);
			tbl.setDefaultRenderer(Object.class, tblRendor);
		}
		
		
		if (message == null) {
			messageTxt = new JTextField();

			form.setGap(FormHelper.GAP1);
			form.ls(messageTxt, FormBuilder.FULL_WIDTH, 1, 1, form.lastColumn);

//			this.addMessage(message);
//			this.setHeightRE(HEIGHT_1P4);
		} else {
			messageTxt = message;
		}

		form.build();
		popup = new MenuPopupListener();
		popup.setTable(tbl);
		popup.getPopup().add(new FirstCsvLineChanged("set as Field Name Row", true));
		popup.getPopup().add(new FirstCsvLineChanged("first Data Row (no field name row)", false));
	
		tbl.addMouseListener(popup);
		

//		fieldNamesOnLine.addActionListener(new ActionListener() {
//			
//			@Override public void actionPerformed(ActionEvent e) {
//				lineNumVisible();
//			}
//		});
		//lineNumVisible();
	}

//	private void lineNumVisible() {
//		boolean selected = fieldNamesOnLine.isSelected();
//		
//		nameLineNumTxt.setEditable(selected);
//
////		nameLineNumLbl.setVisible(selected);
////		nameLineNumTxt.setVisible(selected);
////		this.repaint();
//	}

	private JPanel init_200_bld2fieldPnl(JComponent field1, JComponent field2, String fieldName) {
		JPanel ret = new JPanel(new BorderLayout());

		JPanel pnl1 = new JPanel();
		JLabel orLbl = new JLabel("   or ");
		tbl.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);

		pnl1.add(orLbl);
		//pnl1.add(fieldSepTxt);
		orLbl.setAlignmentX(JLabel.CENTER_ALIGNMENT);
		//pnl.setLayout();
		ret.add(BorderLayout.WEST, field1);
		ret.add(BorderLayout.CENTER, pnl1);
	   //pnl.add(BorderLayout.CENTER, orLbl);
		ret.add(BorderLayout.EAST, field2);
		ret.setMinimumSize(new Dimension(ret.getPreferredSize().width, SwingUtils.values().TABLE_ROW_HEIGHT));

		setComponentName(field2, fieldName);

		return ret;
	}


	private void updateWizardBtn() {
		boolean selected = fieldNamesOnLine.isSelected();
		
//		nameLineNumTxt.setEditable(selected);

		nameLineNumLbl.setText(selected ? COLUMN_NAMES_LINE_NUMBER : "First Data Line");
		//nameLineNumTxt.setVisible(selected);
		pnl.repaint();
		if (wizardBtn != null) {
			wizardBtn.setVisible(! selected);
		}
	}


	private void valueChanged() {
		valueChanged(true);
	}


	private void valueChanged(boolean reRead) {


		boolean lastDoAction = doAction;
		try {
			doAction = false;
			String quoteStr = getQuote();

			if ((reRead && embeddedCrJCheck.isSelected()) || tblMdl == null) {
				reReadData(false);
			} else {
				tblMdl.setParserType(((Integer) parseType.getSelectedItem()).intValue());
				tblMdl.setQuote(quoteStr);
				tblMdl.setSeperator(getSeperator());
				tblMdl.setFont(getFontName());
			}

			if (tblMdl != null) {
				if (tblMdl.getRowCount() > 0) {
					try {
						String l = tblMdl.getLine(0).trim();

						tblMdl.setFieldLineNo(getFieldLineNo());
						if (fieldNamesOnLine.isSelected() && ! "".equals(quoteStr)
						&& l.startsWith(quoteStr) && l.endsWith(quoteStr)
						&& parseType.getSelectedIndex() == 0) {
							parseType.setSelectedIndex(3);
							tblMdl.setParserType(((Integer) parseType.getSelectedItem()).intValue());
						}

				 		tblMdl.setHideFirstLine(fieldNamesOnLine.isSelected());
					} catch (Exception e) {
					}
				}
				tblMdl.setupColumnCount();
				tblMdl.fireTableStructureChanged();
			}
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			doAction = lastDoAction;
		}
	}


	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.utils.csv.FilePreview#getSeperator()
	 */
	@Override
	public final String getSeperator() {

		String sep = fieldSepTxt.getText();

		if (sep == null || "".equals(sep) || ! isSepValid()) {
			sep = fieldSeparatorCombo.getKeyValue();
		}

		if ("<Space>".equals(sep)) {
			sep = " ";
		} else if ("<Tab>".equals(sep)) {
			sep = "\t";
		} else if ("<Default>".equals(sep)) {
			sep = ",";
		}

		return sep;
	}

	/**
	 * Check if field seperator is valid
	 * @return wether the field seperator is valid
	 */
	private boolean isSepValid() {
		boolean ret = false;
		String v = fieldSepTxt.getText();
		boolean singleByte = Conversion.isSingleByte(getFontName());

		if (v.length() < 2) {
			ret = true;
		} else if (singleByte && ( CsvCode.isHex(v) || CsvCode.isUnicode(v))) {
			try {
				CsvCode.checkDelimiter(v, null);
				ret = true;
			} catch (Exception e) {
				setMessageTxtRE("Invalid Delimiter - " + e.getMessage());
			}
			
		} else if (singleByte) {
			setMessageTxtRE("Invalid Delimiter, should be a single character or a hex character");
		} else {
			setMessageTxtRE("Invalid Delimiter, should be a single character");
		}

		return ret;
	}


	private void setMessageTxtRE(String msg) {
		setMessageRawTxtRE(LangConversion.convert(msg));
	}

	private void setMessageTxtRE(String msg, String error) {
		setMessageRawTxtRE(LangConversion.convert(msg) + " " + error);
	}


	private void setMessageRawTxtRE(String msg) {
		if (messageTxt == null) {
			Common.logMsgRaw(msg, null);
		} else {
			messageTxt.setText(msg);
		}
	}


	private boolean isBinarySep() {
		return CsvCode.isLikelyHex(getSeperator()) || CsvCode.isLikelyHex(getQuote());
	}

	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.utils.csv.FilePreview#getQuote()
	 */
	@Override
	public final String getQuote() {
//		return quoteCombo.getQuote();
		String q = quoteTxt.getText();
		if (q == null || "".equals(q)) {
			return quoteCombo.getKeyValue(); 
		}
		return q;
	}

	public final String getQuoteText() {
//		return quoteCombo.getQuote();
		String q = quoteTxt.getText();
		if (q == null || "".equals(q)) {
			return quoteCombo.getQuote();
		}
		return q;
	}


	/**
	 * @see net.sf.RecordEditor.re.util.openTabPane.IFilePreview.FilePreview#setLines(byte[][], java.lang.String, int)
	 */
	@Override
	public boolean setLines(byte[][] newLines, String font, int numberOfLines) {
		CsvAnalyser analyser = new CsvAnalyser(newLines, numberOfLines, "", embeddedCrJCheck.isSelected());
		tblMdl.setLines(newLines, font);
		tblMdl.setLines2display(numberOfLines);

		setUpSeperator(analyser);
		tblMdl.setFieldLineNo(getFieldLineNo());
		valueChanged();

		return analyser.isValidChars();
	}




	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.utils.csv.FilePreview#setLines(java.lang.String[], java.lang.String, int)
	 */
	@Override
	public void setLines(String[] newLines, String font, int numberOfLines) {

		tblMdl.setLines(newLines);
		tblMdl.setLines2display(numberOfLines);
		setUpSeperator(new CsvAnalyser(newLines, numberOfLines, "", embeddedCrJCheck.isSelected()));
		valueChanged();
	}

	private void setUpSeperator(CsvAnalyser analyse) {

		try {
			this.doAction = false;
			fieldSeparatorCombo.setText(analyse.getSeperatorId());
			fieldSepTxt.setText("");
			setQuoteCombo(analyse); 
			quoteTxt.setText("");
			setQuoteTxt(analyse.getSpecialQuote());	
			//TODO -------------------------------------
			if (! embeddedCrJCheck.isSelected()) {
				embeddedCrJCheck.setSelected(analyse.isLikelyEmbeddedCr());
			}

			checkColumnNamesInternal(analyse);
			setFirstCsvLine(analyse.getFieldNameLineNo());
		} finally {
			this.doAction = true;
			updateWizardBtn();
		}
	}

	private void checkColumnNames(CsvAnalyser analyse) {
		try {
			this.doAction = false;
			checkColumnNamesInternal(analyse);
			setQuoteCombo(analyse);
		} finally {
			this.doAction = true;
			updateWizardBtn();
		}
		
	}

	private void checkColumnNamesInternal(CsvAnalyser analyse) {
		switch (analyse.getColNamesOnFirstLine()) {
		case CsvAnalyser.COLUMN_NAMES_NO:
			fieldNamesOnLine.setSelected(false);
			setFirstCsvLine("1", 1);
			break;
		case CsvAnalyser.COLUMN_NAMES_YES:
			fieldNamesOnLine.setSelected(true);
			setFirstCsvLine(analyse.getFieldNameLineNo());
			break;
		default:
			if (fieldNamesOnLine.isSelected() || analyse.getFieldNameLineNo() == 1) {
				setFirstCsvLine(analyse.getFieldNameLineNo());
			}
		}
	}
	
	private void setQuoteTxt(Character c) {
		
		if (c != null) {
			quoteTxt.setText(c.toString());
		}
	}


	public int getColumnCount() {
		return tblMdl.getColumnCount();
	}


	public String getColumnName(int idx) {
		return tblMdl.getColumnName(idx);
	}


	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.utils.csv.FilePreview#getLayout(java.lang.String, byte[])
	 */
	@Override
	public LayoutDetail getLayout(String font, byte[] recordSep, int requestType) {
		return getLayout(false, font, recordSep);
	}
	
	public LayoutDetail getLayout(boolean deriveTypes, String font, byte[] recordSep) {


	    int numCols = getColumnCount();
	    int ioId = IFileStructureConstants.IO_BIN_TEXT;
//        int i         = 0;
        int fldLineNo = getFieldLineNo();
//        boolean useThisLayout = true;

//	    FieldTypeDetails fieldType ;
//	    FieldTypeDetails[] fieldTypes = null;
//
//        RecordDetail.FieldDetails[] flds = new RecordDetail.FieldDetails[numCols];
//        RecordDetail[] recs = new RecordDetail[1];
        
        boolean colNamesOnFirstLine = fieldNamesOnLine.isSelected() && fldLineNo < 2;
		if (Conversion.isSingleByte(font)) {
        	if (colNamesOnFirstLine) {
        		ioId = IFileStructureConstants.IO_BIN_NAME_1ST_LINE;
        	}
        } else {
        	ioId = IFileStructureConstants.IO_UNICODE_TEXT;
        	if (colNamesOnFirstLine) {
        		ioId = IFileStructureConstants.IO_UNICODE_NAME_1ST_LINE;
        	}
        }

		boolean deriveTheTypes = deriveTypes
					|| checkTypes.isSelected()
			        || parseType.getSelectedIndex() == 2
			        || parseType.getSelectedIndex() == 5;

		CsvAnalyser analyser = tblMdl.getAnalyser(AbstractCsvTblMdl.USE_CURRENT_SEPERATOR);
		String[] colNames = new String[numCols];
		for (int i = 0; i < numCols; i++) {
			 colNames[i] = getColumnName(i);
		}
		analyser.setColumnNames(colNames);
		return new CsvSchemaBuilder(analyser, filename, ioId, fieldNamesOnLine.isSelected())
				.setDeriveTheTypes(deriveTheTypes)
				.setEmbeddedCr(embeddedCrJCheck.isSelected())
				.setFont(font)
				.setParserType(((Integer)parseType.getSelectedItem()).intValue())
				.setQuote(getQuote())
				.setRecordSep(recordSep)
				.setSeperator(getSeperator())
				.buildSchema();
	    //return generateSchema(deriveTheTypes, ioId, font, numCols, recordSep);
	}

//	private LayoutDetail generateSchema(boolean deriveTheTypes, int ioId, String font, int numCols, byte[] recordSep) {
//		LayoutDetail layout;
//		String s;
//		FieldTypeDetails fieldType ;
//	    FieldTypeDetails[] fieldTypes = null;
//
//        RecordDetail.FieldDetails[] flds = new RecordDetail.FieldDetails[numCols];
//        RecordDetail[] recs = new RecordDetail[1];
//        CsvAnalyser analyser = tblMdl.getAnalyser(AbstractCsvTblMdl.USE_CURRENT_SEPERATOR);
//		if (deriveTheTypes) {
//         	fieldTypes = analyser.getTypes();
//        } else {
//         	fieldTypes = analyser.getTextTypes();
//        }
//
//	    for (int i = 0; i < numCols; i++) {
//	    	fieldType = FieldTypeDetails.CHAR_TYPE_DETAILS;
//	    	if (fieldTypes != null && i < fieldTypes.length) {
//	    		fieldType = fieldTypes[i];
//	    	}
//		    s = getColumnName(i);
//
//            flds[i] = new RecordDetail.FieldDetails(s, s, fieldType.type, fieldType.decimal,
//                        font, fieldType.format, fieldType.paramter);
//            flds[i].setPosOnly(i + 1);
//	    }
//	    
//	    //TODO update
//        boolean useThisLayout = true;
//	    if (fieldTypes == null 
//	    && analyser.getColNamesOnFirstLine() != CsvAnalyser.COLUMN_NAMES_NO
//	    && linesTbl.getRowCount() == 0) {
//	    	useThisLayout = false; 
//	    }
//
//        String layoutName = "GeneratedCsv";
//        String recordName = Common.GENERATED_CSV_SCHEMA_NAME;
//        if (filename != null && filename.length() > 0) {
//        	String fname = new File(filename).getName();
//        	int pos = fname.indexOf('.');
//        	if (pos > 0) {
//        		fname = fname.substring(0, pos);
//        	}
//            IFieldNameConversion conversion = FieldNameConversionManager.STD_CBL_FIELD_NAME_CONVERSION;
//        	String javaId = conversion.string2JavaId(fname);
//			layoutName = conversion.toClassName(javaId);
//        	recordName = "Rec" + conversion.toSuffix(javaId);
//        }
//        recs[0] = new RecordDetail(recordName, "", "", Constants.rtDelimited,
//        		getSeperator(),  getQuote(), font, flds,
//        		((Integer)parseType.getSelectedItem()).intValue(), 0, embeddedCrJCheck.isSelected());
//
//        
//		layout  =
//            new LayoutDetail(layoutName, recs, "",
//                Constants.rtDelimited,
//                recordSep, "", font, null,
//                ioId
//            );
//
//        layout.setUseThisLayout(useThisLayout);
//		return layout;
//	}

	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.utils.csv.FilePreview#getFileDescription()
	 */
	@Override
	public String getFileDescription() {
		String csv = getCsvType();


		return csv	+ SEP + getStr(fieldSeparatorCombo.getDelimiter())
					+ SEP + getStr(fieldSepTxt.getText())
					+ SEP + getStr(quoteCombo.getQuote())
					+ SEP + parseType.getSelectedIndex()
					+ SEP + getBool(fieldNamesOnLine)
					+ SEP + getBool(checkTypes)
					+ SEP + getStr(getFontName())
					+ SEP + getStr(nameLineNumTxt.getText())
					+ SEP + getStr(quoteTxt.getText())
					+ SEP + getBool(embeddedCrJCheck)

					;
	}

	/**
	 * @return
	 */
	private String getCsvType() {
		String csv = UNICODE_CSV_STRING;

		if (isByteBased) {
			csv = NORMAL_CSV_STRING;
		}
		return csv;
	}

	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.utils.csv.FilePreview#setFileDescription(java.lang.String)
	 */
	public void setFileDescription(String val) {
		StringTokenizer tok = new StringTokenizer(val, SEP, false);

		try {
			doAction = false;
			String id = tok.nextToken();
			if (NORMAL_CSV_STRING.equalsIgnoreCase(id)
			||  UNICODE_CSV_STRING.equalsIgnoreCase(id)) {
//				System.out.print(id);
				fieldSeparatorCombo.setDelimiter(getStringTok(tok));
				fieldSepTxt.setText(getStringTok(tok));
				quoteCombo.setText(getStringTok(tok));
				parseType.setSelectedIndex(getIntTok(tok));
				fieldNamesOnLine.setSelected(getBoolTok(tok));
				checkTypes.setSelected(getBoolTok(tok));
				charsetCombo.setText(getStringTok(tok));
				setFirstCsvLine(getStringTok(tok));
				quoteTxt.setText(getStringTok(tok));
				embeddedCrJCheck.setSelected(getBoolTok(tok));
			}
		} catch (Exception e) {

		} finally {
			doAction = true;
			updateWizardBtn();
		}
	}

	private String getBool(JCheckBox chk) {
		String s = "N";
		if (chk.isSelected()) {
			s = "Y";
		}
		return s;
	}

	private String getStr(String s) {
		if (s == null || "".equals(s)) {
			s = NULL_STR;
		}

		return s;
	}

	private int getIntTok(StringTokenizer tok) {
		int ret = 0;
		try {
			ret = Integer.parseInt(tok.nextToken());
		} catch (Exception e) {
			// TODO: handle exception
		}

		return ret;
	}


	private boolean getBoolTok(StringTokenizer tok) {
		return "Y".equalsIgnoreCase(tok.nextToken());
	}



	private String getStringTok(StringTokenizer tok) {

		String s = tok.nextToken();
		if (s == null || NULL_STR.equals(s)) {
			s = "";
		}
		return s;
	}

	private int getFieldLineNo() {
		int ret = 1;
		String s = nameLineNumTxt.getText();
		if (! "".equals(s)) {
			try {
				ret = Integer.parseInt(s);

				if (ret < 1) {
					ret = 1;
					setMessageTxtRE("Field Line Number should be one or more and not",  s);
				}
			} catch (Exception e) {
				setMessageTxtRE("Invalid Field Line Number:", s);
			}
		}


		return ret;
	}


	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.re.util.csv.FilePreview#isMyLayout(java.lang.String)
	 */
	@Override
	public int isMyLayout(String layoutId, String filename, byte[] data) {
		return useMyType && layoutId != null && layoutId.startsWith(getCsvType())
				? YES :	NO;
	}
	

	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.re.util.csv.FilePreview#getSchemaCheckType()
	 */
	@Override
	public int getSchemaCheckType() {
		return isByteBased ? IGetSchema.ST_CSV : IGetSchema.ST_TEXT_CSV ;
	}

//	/* (non-Javadoc)
//	 * @see net.sf.RecordEditor.re.util.csv.IFilePreview#getJTable()
//	 */
//	@Override
//	public JTable getJTable() {
//		return tbl;
//	}
	
	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.re.util.csv.IFilePreview#notifyHasReceivedFocus()
	 */
	@Override
	public void notifyHasReceivedFocus() {
		if (externalTbl) {
			tbl.setModel(tblMdl);
		}
	}
	

	public final void setComponentName(Component component, String name) {

	    if (component != null && name != null && ! "".equals(name)) {
	    	String suffix = "";
	    	if (component instanceof JTextField
	    	|| component instanceof JTextArea
	    	|| component instanceof JComboBox) {
	    		suffix = "_Txt";
	    	} else if (component instanceof JCheckBox) {
	    		suffix = "_Chk";
	    	}  else if (component instanceof JButton) {
	    		suffix = "_Btn";
	    	} else if (component instanceof JTable) {
	    		suffix = "_JTbl";
	    	}
	    	component.setName(PANEL_ID + "." + name + suffix);
	    }
	}

	
//	/* (non-Javadoc)
//	 * @see net.sf.RecordEditor.re.util.csv.IFilePreview#setHelpURL(java.net.URL)
//	 */
//	@Override
//	public void setHelpURL(URL helpUrl) {
//		form.getHelpDisplay().setHelpURL(helpUrl);
//		
//	}

	/**
     * Add a key adapter to be added to the list
     * @param adapter keyadapter
     */
    public void addReKeyListener(KeyAdapter adapter) {
    	//list.add(adapter);
    	pnl.addKeyListener(adapter);

    	for (Component c : pnl.getComponents()) {
    		if (c instanceof BaseHelpPanel) {
    			((BaseHelpPanel) c).addReKeyListener(adapter);
    		} else {
    			c.addKeyListener(adapter);
    		}
    	}
    }

    private void setFirstCsvLine(int lineNum) {
    	setFirstCsvLine(Integer.toString(lineNum), lineNum);
	}

	private void setFirstCsvLine(String t) {
		try {
			setFirstCsvLine(t, Integer.parseInt(t));
		} catch (NumberFormatException e) {
		}
	}

	private int firstCsvLine = 0;
	private void setFirstCsvLine(String t,  int lineNum) {
		nameLineNumTxt.setText(t);
		setFirstCsvLineValue(lineNum);
	}

	/**
	 * @param lineNum
	 */
	private void setFirstCsvLineValue(int lineNum) {
		if (firstCsvLine != lineNum-1) {
			firstCsvLine = lineNum-1;
	
			SwingUtilities.invokeLater(new Runnable() {
				@Override public void run() {
					Rectangle cellRect = tbl.getCellRect(firstCsvLine, 0, true);
					tbl.scrollRectToVisible(new Rectangle(cellRect));
					tblMdl.fireTableDataChanged();
				}
			});
		}
	}
	
	

	@Override
	public Icon getIcon() {
		return IconManager.ICONS.extensionCsv.icon();
	}



	@Override
	public TableCellRenderer getTableRenderer() {
		return tblRendor;
	}





	@Override
	public Iterator<String> getFieldIterator(int recordIdx, int fieldIdx) {
		return tblMdl == null ? null : new StringIteratorOverTblModel(tblMdl, fieldIdx);
	}





	private final class LineTableRender extends DefaultTableCellRenderer {

		@Override
		public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus,
				int row, int column) {
			Component ret = super.getTableCellRendererComponent(table, value, isSelected, hasFocus, row, column);
            if (isSelected) {
                setForeground(table.getSelectionForeground());
                super.setBackground(table.getSelectionBackground());
            }
            else {
                setForeground(table.getForeground());
                setBackground(table.getBackground());
            }
			if (firstCsvLine < 1 || row != firstCsvLine ) {
				
			} else if (fieldNamesOnLine.isSelected()) {
				ret.setBackground(Color.CYAN);
			} else {
				ret.setBackground(Color.YELLOW);
			}
			return ret;
		}
		
		
	}


	private final class FirstCsvLineChanged extends ReAbstractAction {
		final boolean columnNamePreset;
		private FirstCsvLineChanged(String name, boolean columnNamePreset) {
			super(name);
			
			this.columnNamePreset = columnNamePreset;
		}

		public void actionPerformed(ActionEvent e) {
			
			try {
				doAction = false;
				
				fieldNamesOnLine.setSelected(columnNamePreset);
				int inc = 1;
				if (fieldNamesOnLine.isSelected() && getFieldLineNo() == 1) {
					inc = 2;
				}
	//				System.out.println("Set Row " + fieldNamesOnLine.isSelected()
	//						+ " " + getFieldLineNo()
	//						+ " " + inc
	//						+ " " + popup.getPopupRow());
				updateWizardBtn();
	
				int row = popup.getPopupRow() + inc;
				setFirstCsvLine(row);
				
				AbstractCsvTblMdl tblM = tblMdl;
				if (tblM != null) {
					tblM.setFieldLineNo(row);
					//CsvAnalyser analyser = tblM.getAnalyser(AbstractCsvTblMdl.DERIVE_SEPERATOR);
					setUpSeperator(tblM.getAnalyser(AbstractCsvTblMdl.DERIVE_SEPERATOR));
					valueChanged();
					tblM.setFieldLineNo(row); // trigger setting up column names
				} else {
					valueChanged();
				}
			} finally {
				doAction = false;
			}
		}
	}

	private static class StringIteratorOverTblModel implements Iterator<String> {
		final TableModel mdl;
		final int col;
		int idx = 0;
		
		
		public StringIteratorOverTblModel(TableModel mdl, int col) {
			super();
			this.mdl = mdl;
			this.col = col;
		}
		@Override
		public boolean hasNext() {
			// TODO Auto-generated method stub
			return idx < mdl.getRowCount() ;
		}
		@Override
		public String next() {
			Object value = mdl.getValueAt(idx++, col);
			return value == null ? "": value.toString();
		}
		
		
		
	}
}
