package net.sf.RecordEditor.re.util.openTabPane;

import java.net.URL;

import javax.swing.Icon;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JTable;
import javax.swing.table.TableCellRenderer;

import net.sf.JRecord.Details.AbstractLayoutDetails;
import net.sf.RecordEditor.re.schema.ICreateFieldIterator;
import net.sf.RecordEditor.utils.params.IUpdatableBooleanOption;

public interface IFilePreview extends ICreateFieldIterator {

//	public static final String     AP_RECORD_EDITOR = "re";
//	public static final String     AP_RECSVEDITOR = "csv";
	
	public static final int     NO = 1;
	public static final int LIKELY = 3;
	public static final int    YES = 5;
	
	public static final String SEP       = "~";
	public static final String NULL_STR  = "Empty";
	
	public static final String XML_ID    = "XML";
	public static final String OTHER_ID  = "OTHER";
	public static final String NORMAL_CSV_STRING  = "CSV";
	public static final String UNICODE_CSV_STRING = "UNICODECSV";
	public static final String SCHEMA_ID = "SCHEMA";
	public static final String RECORD_DB = "RecordDb" + SEP;
	
	public static final String OTHER_PO_SUFFIX  = "PO";
	public static final String OTHER_TIP_SUFFIX = "TIPS";

	public static final String OTHER_PO_ID  = OTHER_ID + SEP + OTHER_PO_SUFFIX;
	public static final String OTHER_TIP_ID = OTHER_ID + SEP + OTHER_TIP_SUFFIX;
	
	
	
	public static final String[] NON_RECORD_DB_IDS = {
			XML_ID + SEP,
			OTHER_ID + SEP,
			NORMAL_CSV_STRING + SEP,
			UNICODE_CSV_STRING + SEP,
			SCHEMA_ID + SEP,
			RECORD_DB
	};


	public abstract JPanel getPanel();
	public abstract JButton getGoButton();

	public abstract boolean setData(String filename, byte[] data, boolean checkCharset, String layoutId);

	/**
	 * Get The field seperator
	 * @return field seperator
	 */
	public abstract String getSeperator();

	/**
	 * Get The Quote
	 * @return Quote
	 */
	public abstract String getQuote();

	/**
	 * @param newLines the lines to set
	 * @param numberOfLines the actual number of lines used
	 */
	public abstract boolean setLines(byte[][] newLines, String font,
			int numberOfLines);


	/**
	 * @param newLines the lines to set
	 * @param numberOfLines the actual number of lines used
	 */
	public abstract void setLines(String[] newLines, String font,
			int numberOfLines);


	public abstract AbstractLayoutDetails getLayout(String font, byte[] recordSep, int requestType);

	public abstract String getFileDescription();

//	public abstract void setFileDescription(String val);

	public abstract String getFontName();

	public abstract int isMyLayout(String layout, String filename, byte[] data);
	
	public abstract int getSchemaCheckType();
	
	public abstract JTable getJTable();
	
	public abstract void notifyHasReceivedFocus();
	
	public abstract void setHelpURL(URL helpUrl);
	
	public abstract TableCellRenderer getTableRenderer();
	
	public Icon getIcon();
	
	public abstract IUpdatableBooleanOption displayThePnl();
	
	public abstract void setDisplaySchemaScreen(IDisplaySchemaScreen displaySchemaScreen);
//	public abstract boolean isDisplayPnl();
//	public abstract void setDisplayPnl(boolean display);

	
}