package net.sf.RecordEditor.re.util.re;

import java.awt.BorderLayout;

import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JTable;
import javax.swing.text.JTextComponent;

import net.sf.JRecord.Details.AbstractLayoutDetails;
import net.sf.JRecord.Details.IGetSchema;
import net.sf.RecordEditor.re.layoutSelection.def.IRecordLayoutChangedListner;
import net.sf.RecordEditor.re.layoutSelection.def.IUserLayoutSelection;
import net.sf.RecordEditor.re.openFile.RecentFiles;
import net.sf.RecordEditor.re.util.csv.BaseFilePreview;
import net.sf.RecordEditor.re.util.csv.FileTableDisplay;
import net.sf.RecordEditor.utils.LayoutConnection;
import net.sf.RecordEditor.utils.swing.BasePanel;
import net.sf.RecordEditor.utils.swing.SwingUtilsBldr;
import net.sf.recordEditor.ui.icons.IconManager;

public class RecordEditorPreview extends  BaseFilePreview implements IRecordLayoutChangedListner {

	private final JButton edit = SwingUtilsBldr.newButton("Edit", IconManager.ICONS.documentEdit.icon()) ;
	public final JButton browse = SwingUtilsBldr.newButton("Browse", IconManager.ICONS.document.icon());
//	private BaseHelpPanel pnl = new BaseHelpPanel();
	private final IUserLayoutSelection layoutSelection;
	private final LayoutConnection fileFld;
	private final FileTableDisplay fileTblDisplay;;
	private final JTextComponent message;
	
	private byte[] lastData;
	private String lastLayoutName;
	
	private final boolean addTbl;

	
	public RecordEditorPreview(
			LayoutConnection fileSourrce,
			IUserLayoutSelection layoutSelection, 
			JTextComponent message, 
			final JButton layoutCreate1,
			final JButton layoutCreate2,
			boolean addTbl,
			JTable jTbl
			) {
		super(null, true);
		
		this.fileFld = fileSourrce;;
		this.message = message;
		this.fileTblDisplay = new FileTableDisplay(jTbl, null);
		this.layoutSelection = layoutSelection;
		this.addTbl = addTbl;
		super.setCreateFieldIterator(fileTblDisplay);
		
		init_200_layoutScreen(layoutCreate1, layoutCreate2);
		
		layoutSelection.addRecordLayoutChangedListner(this);
	}



	private void init_200_layoutScreen(
			final JButton layoutCreate1,
			final JButton layoutCreate2
			) {
   		JPanel goPanel = new JPanel();

		goPanel.setLayout(new BorderLayout());
		goPanel.add(BorderLayout.NORTH, edit);
		goPanel.add(BorderLayout.CENTER, new JPanel());
		goPanel.add(BorderLayout.SOUTH, browse);
		
		layoutSelection.setMessage(message);
		layoutSelection.addLayoutSelection(pnl, fileFld, goPanel, layoutCreate1, layoutCreate2);
		
		if (addTbl) {
			pnl.addComponentRE(
					1,  BasePanel.LAST_USED_COLUMN, BasePanel.FILL, BasePanel.GAP0,
			        BasePanel.FULL, BasePanel.FULL,
			        fileTblDisplay.getFileTable());
		}
//
//		browse.addActionListener(this);
//		edit.addActionListener(this);
	}

	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.re.layoutSelection.def.IRecordLayoutChangedListner#recordLayoutHasChange()
	 */
	@Override
	public void recordLayoutHasChange() {
		String ln = layoutSelection.getLayoutName();
		if (ln != null && ! ln.equalsIgnoreCase(lastLayoutName)) {
			lastLayoutName = ln;
			buildFileLayout(lastData);
		}
	}


//	/* (non-Javadoc)
//	 * @see net.sf.RecordEditor.re.util.csv.FilePreview#getPanel()
//	 */
//	@Override
//	public BaseHelpPanel getPanel() {
//		return pnl;
//	}

	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.re.util.csv.FilePreview#getGoButton()
	 */
	@Override
	public JButton getGoButton() {
		return edit;
	}

	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.re.util.csv.FilePreview#setData(java.lang.String, byte[], boolean, java.lang.String)
	 */
	@Override
	public boolean setData(String filename, byte[] data, boolean checkCharset, String layoutId) {
		if (lastData == data) {
			return buildFileLayout(data);
		}

		if (layoutId != null && ! "".equals(layoutId)) {
			getLayoutNameFromLayoutId(layoutId);
		}

		lastData = data;
		return buildFileLayout(data);
	}

	private boolean buildFileLayout(byte[] data) {
		return fileTblDisplay.buildFileLayout(layoutSelection.getRecordLayout(fileFld.getCurrentFileName()), message, data);
	}

//	/* (non-Javadoc)
//	 * @see net.sf.RecordEditor.re.util.csv.FilePreview#getSeperator()
//	 */
//	@Override
//	public String getSeperator() {
//		return "";
//	}
//
//	/* (non-Javadoc)
//	 * @see net.sf.RecordEditor.re.util.csv.FilePreview#getQuote()
//	 */
//	@Override
//	public String getQuote() {
//		return "";
//	}
//
	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.re.util.csv.FilePreview#setLines(byte[][], java.lang.String, int)
	 */
	@Override
	public boolean setLines(byte[][] newLines, String font, int numberOfLines) {
		return false;
	}

	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.re.util.csv.FilePreview#setLines(java.lang.String[], java.lang.String, int)
	 */
	@Override
	public void setLines(String[] newLines, String font, int numberOfLines) {
		// TODO Auto-generated method stub
		
	}

	/**
	 * @see net.sf.RecordEditor.re.util.openTabPane.IFilePreview#getLayout(java.lang.String, byte[])
	 */
	@Override
	public AbstractLayoutDetails getLayout(String font, byte[] recordSep, int requestType) {
		return layoutSelection.getRecordLayout(fileFld.getCurrentFileName());
	}

	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.re.util.csv.FilePreview#getFileDescription()
	 */
	@Override
	public String getFileDescription() {
		return RECORD_DB + layoutSelection.getLayoutName();
	}

	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.re.util.csv.FilePreview#getFontName()
	 */
	@Override
	public String getFontName() {
		return "";
	}

	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.re.util.csv.FilePreview#isMyLayout(java.lang.String, java.lang.String, byte[])
	 */
	@Override
	public int isMyLayout(String layout, String filename, byte[] data) {
		int ret = NO;
		
		String layoutName = getLayoutNameFromLayoutId(layout);
		if (layoutName != null && layoutName.length() > 0) {
			ret = YES;
		}
		return ret;
	}

	/**
	 * @param layout
	 * @param layoutName
	 * @return
	 */
	protected String getLayoutNameFromLayoutId(String layout) {
		
		String layoutName = null;
		if (layout == null) {
		} else if (layout.startsWith(RECORD_DB)) {
			layoutName = layout.substring(RECORD_DB.length());
		} else if (layout.indexOf(SEP) < 0) {
			layoutName = layout;
		} else {
			String ln = RecentFiles.tabLayoutNameToLayoutName(layout);
			if (! layout.equals(ln)) {
				layoutSelection.setLayoutName(ln);
			}
		}

		if (layoutName != null) {
			layoutSelection.setLayoutName(layoutName);
		} 

		return layoutName;
	}

	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.re.util.csv.FilePreview#getSchemaCheckType()
	 */
	@Override
	public int getSchemaCheckType() {
		return IGetSchema.ST_CHECK_SCHEMA;
	}


//	/* (non-Javadoc)
//	 * @see net.sf.RecordEditor.re.util.csv.IFilePreview#getJTable()
//	 */
//	@Override
//	public JTable getJTable() {
//		return fileTblDisplay.getFileTable();
//	}

	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.re.util.csv.IFilePreview#notifyHasReceivedFocus()
	 */
	@Override
	public void notifyHasReceivedFocus() {
		if (! addTbl) {
			fileTblDisplay.assignModelToTbl();
		}
	}
	
//	/* (non-Javadoc)
//	 * @see net.sf.RecordEditor.re.util.csv.IFilePreview#setHelpURL(java.net.URL)
//	 */
//	@Override
//	public void setHelpURL(URL helpUrl) {
//		getPanel().setHelpURLre(helpUrl);
//	}
}
