/**
 *
 */
package net.sf.RecordEditor.re.util.wizard;


import javax.swing.DefaultCellEditor;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JTable;
import javax.swing.table.TableColumn;

import net.sf.JRecord.Common.RecordException;
import net.sf.JRecord.Details.AbstractLayoutDetails;
import net.sf.RecordEditor.re.file.filter.BaseFieldSelection;
import net.sf.RecordEditor.re.layoutSelection.def.IUserLayoutSelection;
import net.sf.RecordEditor.utils.common.Common;
import net.sf.RecordEditor.utils.wizards.AbstractWizardPanel;
import net.sf.RecordEditor.xml.classes.BaseCopyDif;
import net.sf.recordEditor.ui.swing.tableCell.ComboBoxRender;
import net.sf.recordEditor.ui.xEnvironment.SwingUtils;

/**
 * @author Bruce Martin
 *
 */
@SuppressWarnings("serial")
public class FieldChoice<save extends BaseCopyDif> extends BaseFieldSelection
implements AbstractWizardPanel<save> {

	private save values;
	private String lastLayoutName1 = "";
	private String lastLayoutName2 = "";
	private IUserLayoutSelection selection1;
	private IUserLayoutSelection selection2;
	private boolean toInit = true;

	private AbstractLayoutDetails layout2 = null;

	/**
	 * @param layoutSelection
	 */
	public FieldChoice(IUserLayoutSelection layoutSelection1,
			IUserLayoutSelection layoutSelection2,
			String helpName) {
		super();

		selection1 = layoutSelection1;
		selection2 = layoutSelection2;
		if (helpName != null & ! "".equals(helpName)) {
			setHelpURLre(Common.formatHelpURL(helpName));
		}
	}

    /**
     * Set Record Table
     * @param tbl table to update
     */
    protected void setFieldTableDetails(JTable tbl) {
        ComboBoxRender fieldRendor = new ComboBoxRender(
	  	        getFilter().getComboModelLayout2());
        TableColumn tc;

        setTableDetailsCol0(tbl);

		tc = tbl.getColumnModel().getColumn(1);
	  	tc.setCellRenderer(fieldRendor);
		tc.setCellEditor(new DefaultCellEditor(
			    new JComboBox(getFilter().getComboModelLayout2a())));
		tc.setPreferredWidth(FIELD_NAME_WIDTH);

		tbl.setRowHeight(FIELD_VALUE_ROW_HEIGHT);
		
    }

    /**
     * Set Record Table
     * @param tbl table to update
     */
    protected void setRecordTableDetails(JTable tbl) {

    	TableColumn tc;
    	setTableDetailsCol0(tbl);


    	tc = tbl.getColumnModel().getColumn(1);

    	tc.setCellRenderer(new ComboBoxRender(getFilter().getRecordOptions()));

    	tc.setCellEditor(new DefaultCellEditor(new JComboBox(getFilter().getRecordOptions())));

    	tc.setPreferredWidth(FIELD_NAME_WIDTH);

    	tbl.setRowHeight(FIELD_VALUE_ROW_HEIGHT);
    }


	/**
	 * @see net.sf.RecordEditor.utils.wizards.AbstractWizardPanel#getValues()
	 */
	@Override
	public save getValues() throws Exception {
		String sold = values.getOldfile().getLayoutDetails().name;

		values.getOldfile().layoutDetails = super.getFilter().getExternalLayout();
		values.getOldfile().getLayoutDetails().name = sold;

		String snew = values.getNewfile().getLayoutDetails().name;

		values.getNewfile().layoutDetails = super.getFilter().getExternalLayout2();
		values.getNewfile().getLayoutDetails().name = snew;

		return values;
	}

	/**
	 * @see net.sf.RecordEditor.utils.wizards.AbstractWizardPanel#setValues(net.sf.RecordEditor.xml.classes.DiffDefinition)
	 */
	@Override
	public void setValues(save detail) throws Exception {

		values = detail;

		String newLayoutName = values.getNewfile().getLayoutDetails().name;
		if (newLayoutName.startsWith("CsvSchema~") 
		|| ! lastLayoutName2.equalsIgnoreCase(newLayoutName)) {
			lastLayoutName2 = values.getNewfile().getLayoutDetails().name;
			layout2 = selection2.getRecordLayout(values.getNewfile().name);
			toInit = true;
			if (layout2 == null) {
				throw new RecordException("Can not get layout for the New File");
			}
		}

		String oldLayoutName = values.getOldfile().getLayoutDetails().name;
		if (oldLayoutName.startsWith("CsvSchema~")
		|| ! lastLayoutName1.equalsIgnoreCase(oldLayoutName)) {
			super.setRecordLayout(selection1.getRecordLayout(values.getOldfile().name),
					layout2, true,
					SwingUtils.values().NORMAL_FIELD_HEIGHT * 4);
			lastLayoutName1 = values.getOldfile().getLayoutDetails().name;
			toInit = true;
		}

		if (toInit) {
			//System.out.println("Layout Name " + values.newFile.getLayoutDetails().name);
			super.getFilter().set2ndLayout(
					layout2,
					values.getOldfile().getLayoutDetails(),
					values.getNewfile().getLayoutDetails());

			setRecordTableDetails(super.getRecordTbl());
			setFieldTableDetails(super.getFieldTbl());
			toInit = false;
		}
	}


	/**
	 * @see net.sf.RecordEditor.utils.wizards.AbstractWizardPanel#getComponent()
	 */
	@Override
	public JComponent getComponent() {
		return this;
	}


	/**
	 * @see net.sf.RecordEditor.utils.wizards.AbstractWizardPanel#isMore()
	 */
	@Override
	public boolean skip() {
		return false;
	}
}
