package net.sf.RecordEditor.utils.fileAnalysis;

public class LineArrayList<LineType> {
	public int firstLineNumber;
	private int lastLineNumber;
	public LineType[] lines;
	
	public LineArrayList() {
		this.firstLineNumber = 0;
		this.lastLineNumber = 0;
	}

	public LineArrayList(LineType[] lines, int firstLine, int lastLine) {
		super();
		this.lines = lines;
		this.firstLineNumber = firstLine;
		this.lastLineNumber =  lastLine;
	}
	
//	public StringArrayLineList set(String[] lines, int firstLine, int lastLine) {
//		return this;
//	}
	
	public int getLineCount() {
		return getLastLineNumber() - firstLineNumber;
	}
	
	public LineType getLine(int lineNum) {
		int idx = lineNum + firstLineNumber;
		return idx < 0 || idx >= lines.length ? null : lines[idx];
	}

	/**
	 * @return the lastLine
	 */
	public final int getLastLineNumber() {
		return lastLineNumber < 0 && lines != null ? lines.length : lastLineNumber;
	}

	/**
	 * @param lastLine the lastLine to set
	 */
	public void setLastLineNumber(int lastLine) {
		this.lastLineNumber = lastLine;
	}
	
//	public static class StringList extends LineArrayList<String> {}
//	
//	public static class ByteArrayList extends LineArrayList<byte[]> {}
}
