package net.sf.RecordEditor.utils.params;

import java.util.ArrayList;

public class BooleanOption implements IUpdatableBooleanOption {
	boolean val;
	private ArrayList<INotifyOptionChanged> listners;
	


	public BooleanOption(boolean initialVal) {
		val = initialVal;
	}


	public boolean isSelected() {
		return val;
	}

	public void set(boolean newValue) {
		set(newValue, true);
	}

	public void set(boolean newValue, boolean notify) {
		//System.out.println(" ==> " + val + " " + newValue);
		val = newValue;
		
		if (notify && listners != null) {
			for (INotifyOptionChanged l : listners) {
				l.optionChanged(this);
			}
		}
	}


	@Override
	public void addListner(INotifyOptionChanged notify) {
		if (listners == null) {
			synchronized (this) {
				if (listners == null) {
					listners = new ArrayList<INotifyOptionChanged>(2);
				}
			}
		}
		listners.add(notify);
	}
}
