package net.sf.RecordEditor.utils.params;

public class UpdateableBoolOpt extends BooleanOption {
	private String param;

	public UpdateableBoolOpt(String value) {
		super("Y".equalsIgnoreCase(Parameters.getString(value)));
		param = value;
	}

	public UpdateableBoolOpt(String value, boolean defTrue) {
		super(
				defTrue ? ! "N".equalsIgnoreCase(Parameters.getString(value))
						:   "Y".equalsIgnoreCase(Parameters.getString(value))
			);
		param = value;
		if (defTrue) {
			Parameters.setDefaultTrue(value);
		}
	}

	public void set(boolean newVal, boolean notify) {
		String value = "N";

		if (newVal) {
			value = "Y";
		}

		Parameters.setProperty(param, value);
		super.set(newVal, notify);
	}

}
