package net.sf.RecordEditor.utils.swing.filechooser;

import java.awt.Component;
import java.awt.HeadlessException;
import java.io.File;
import java.util.List;

import javax.swing.JComponent;
import javax.swing.JFileChooser;


public class JRFileChooserWrapper extends JRFileChooserWrapperBase {

	private JFileChooser fileChooser;
	private String currentDirectoryPath;
//	private final JComponent displayItem;

	protected JRFileChooserWrapper(String currentDirectoryPath) {
		this.currentDirectoryPath = currentDirectoryPath;
	}
	
	
	
	
	protected JRFileChooserWrapper() {
		super();
	}




	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.utils.swing.filechooser.IFileChooserWrapper#getFileChooser()
	 */
	@Override
	public JFileChooser getFileChooser() {
		if (fileChooser == null) {
			fileChooser = new JFileChooser();
			if (currentDirectoryPath != null && currentDirectoryPath.length() > 0) {
				fileChooser.setSelectedFile(new File(currentDirectoryPath));
			}
		}

		return fileChooser;
	}

	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.utils.swing.filechooser.IFileChooserWrapper#getDisplayItem()
	 */
	@Override
	public JComponent getDisplayItem() {
		return getFileChooser();
	}


	

	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.utils.swing.filechooser.IFileChooserWrapper#showDialog(boolean, java.awt.Component)
	 */
	@Override
	public int showDialog(boolean open, Component parent) throws HeadlessException {
		if (open) {
			return showOpenDialog(parent);
		} else {
			return showSaveDialog(parent);
		}
	}


	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.utils.swing.filechooser.IFileChooserWrapper#showOpenDialog(java.awt.Component)
	 */
	@Override
	public int showOpenDialog(Component parent) throws HeadlessException {
		return getFileChooser().showOpenDialog(parent);
	}
	
	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.utils.swing.filechooser.IFileChooserWrapper#showSaveDialog(java.awt.Component)
	 */
	@Override
	public int showSaveDialog(Component parent) throws HeadlessException {
		return getFileChooser().showSaveDialog(parent);
	}

	





	@Override
	public void updateRecentDirectories(List<File> recentDirs) {
		
	}
}



