package net.sf.RecordEditor.utils.swing.filechooser;

import java.awt.event.ActionListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.io.File;
import java.util.ArrayList;

import javax.swing.JFileChooser;

import net.sf.RecordEditor.utils.swing.SwingUtilsBldr;

public abstract class JRFileChooserWrapperBase implements IFileChooserWrapper, PropertyChangeListener {

	private ArrayList<IFileChanged> fileChangedList = new ArrayList<IFileChanged>(3);
	private boolean toAddListner = true;
	
	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.utils.swing.filechooser.IFileChooserWrapper#addFileChangedListner(net.sf.RecordEditor.utils.swing.filechooser.IFileChanged)
	 */
	@Override
	public void addFileChangedListner(IFileChanged listner) {
		if (toAddListner) {
			getFileChooser().addPropertyChangeListener(this);
			toAddListner = false;
		}
		
		fileChangedList.add(listner);
	}

	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.utils.swing.filechooser.IFileChooserWrapper#removeFileChangedListner(net.sf.RecordEditor.utils.swing.filechooser.IFileChanged)
	 */
	@Override
	public void removeFileChangedListner(IFileChanged listner) {
		fileChangedList.remove(listner);
	}

	/* (non-Javadoc)
	 * @see java.beans.PropertyChangeListener#propertyChange(java.beans.PropertyChangeEvent)
	 */
	@Override
	public void propertyChange(PropertyChangeEvent evt) {
        String pname = evt.getPropertyName();

        if (JFileChooser.SELECTED_FILE_CHANGED_PROPERTY.equals(pname)) {
          File f = (File) evt.getNewValue();
          
          if (f != null) {
	          for (IFileChanged fc : fileChangedList) {
	        	  fc.fileChanged(f);
	          }
          }
        }
	}

	@Override
	public File getSelectedFile() {
		return getFileChooser().getSelectedFile();
	}
	
//	@Override
//	public void addChoosableFileFilter(FileFilter filter) {
//		getFileChooser().addChoosableFileFilter(filter);
//	}
	
	@Override
	public void addFileExtension(String description, String... ext) {
		getFileChooser().addChoosableFileFilter(new javax.swing.filechooser.FileNameExtensionFilter(description, ext));
	}

	@Override
	public void addAllFilesFilter() {
		JFileChooser fileChooser = getFileChooser();
		fileChooser.addChoosableFileFilter(fileChooser.getAcceptAllFileFilter());
	}

	@Override
	public final void addActionListener(ActionListener l) {
		getFileChooser().addActionListener(l);
	}
	
	@Override
	public void removeActionListener(ActionListener l) {
		getFileChooser().removeActionListener(l);
	}
	
	@Override
	public void setFileSelectionMode(int mode) {
		getFileChooser().setFileSelectionMode(mode);
	}
	
//	@Override
//	public void setFileFilter(FileFilter filter) {
//		getFileChooser().setFileFilter(filter) ;
//	}
	
//	@Override
//	public FileFilter getFileFilter() {
//		return getFileChooser().getFileFilter();
//	}
//	
	@Override
	public void setSelectedFile(File file) {
		//if (file != null && file.isDirectory() &&)
		JFileChooser fileChooser = getFileChooser();
		if (file != null && file.isDirectory() && ! fileChooser.isDirectorySelectionEnabled()) {
			fileChooser.setCurrentDirectory(file);
		} else {
			fileChooser.setSelectedFile(file);
		}
	}
	
	@Override
	public File getCurrentDirectory() {
		return getFileChooser().getCurrentDirectory();
	}
	@Override
	public void setCurrentDirectory(File directory) {
		getFileChooser().setCurrentDirectory(directory);
	}
//	
//	@Override
//	public void setControlButtonsAreShown(boolean b) {
//		getFileChooser().setControlButtonsAreShown(b);
//	}
//	
//	@Override
//	public void setDialogType(int dialogType) {
//		getFileChooser().setDialogType(dialogType);
//	}
	
	@Override
	public void clickOpenBtn(boolean doEnter) {
		SwingUtilsBldr.clickOpenBtn(getFileChooser(), true);
	}
	
	public void setApproveButtonText(String text) {
		getFileChooser().setApproveButtonText(text);
	}
	
	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.utils.swing.filechooser.IFileChooserWrapper#setApproveButtonToolTipText(java.lang.String)
	 */
	@Override
	public void setApproveButtonToolTipText(String text) {
		getFileChooser().setApproveButtonToolTipText(text);
	}

	public abstract JFileChooser getFileChooser();

}
