package net.sf.RecordEditor.utils.swing.filechooser;

import java.awt.Component;
import java.awt.HeadlessException;
import java.awt.event.ActionListener;
import java.io.File;
import java.util.ArrayList;
import java.util.List;

import javax.swing.JComponent;

import net.sf.recordEditor.ui.def.FileChooserDefs;
import net.sf.recordEditor.ui.def.file.IFileDirectoryChangedListner;
import net.sf.recordEditor.ui.fileChooser.UiFileChooser;
import net.sf.recordEditor.ui.fileChooser.UiFileChooserDialog;
import net.sf.recordEditor.ui.fileFields.params.IFileChooserParam;
import net.sf.recordEditor.ui.icons.IconManager;
import net.sf.recordEditor.ui.xfiles.AllFilesFilter;
import net.sf.recordEditor.ui.xfiles.FileExtensionFilter;




public class JRUiFileChooser  implements IFileChooserWrapper, IFileDirectoryChangedListner {

	private final ArrayList<IFileChanged> fileChangedList = new ArrayList<IFileChanged>(3);
	private boolean toAddListner = true;
	private final UiFileChooser fileChooser;
	
	public JRUiFileChooser(IFileChooserParam param) {
	
	//(RecentFiles recent, String favParam, boolean cancel) {
		
//		IUpdateableFileList fileList = null, dirList = null;
		
		
//		if (favParam != null && favParam.length() > 0) {
//			fileList = UpdatableParameterList.newFileList(favParam + "." + UpdatableParameterList.FILES, 25, false);
//			dirList = UpdatableParameterList.newDirectoryList(favParam + "." + UpdatableParameterList.DIRECTORIES, 25, false);
//		}
//		
//		fileChooser = new WebFileChooserPanel2(
//				FileChooserType.open_TextField, 
//				cancel	? ControlButtonDisplay.ALL_CONTROLS 
//						: ControlButtonDisplay.FILTERS_APPROVE,
//				new RecentFilesListMgr(recent), new RecentDirectoryList(recent),
//				fileList, dirList);
		fileChooser = new UiFileChooser(param);
		//fileChooser.setViewType(FileChooserViewType.table);
	}


	
	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.utils.swing.filechooser.IFileChooserWrapper#addFileChangedListner(net.sf.RecordEditor.utils.swing.filechooser.IFileChanged)
	 */
	@Override
	public void addFileChangedListner(IFileChanged listner) {
		if (toAddListner) {
			fileChooser.addFileChooserListner(this);
			toAddListner = false;
		}
		
		fileChangedList.add(listner);
	}

	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.utils.swing.filechooser.IFileChooserWrapper#removeFileChangedListner(net.sf.RecordEditor.utils.swing.filechooser.IFileChanged)
	 */
	@Override
	public void removeFileChangedListner(IFileChanged listner) {
		fileChangedList.remove(listner);
	}


	/* (non-Javadoc)
	 * @see com.alee.laf.filechooser.FileChooserListener#directoryChanged(java.io.File)
	 */
	@Override
	public void directoryChanged(File newDirectory) {
		
	}


	@Override
	public void fileChanged(File file) {
		
		if (file != null) {
			for (IFileChanged fc : fileChangedList) {
				fc.fileChanged(file);
			}
		}
	}



//	/* (non-Javadoc)
//	 * @see com.alee.laf.filechooser.FileChooserListener#selectionChanged(java.util.List)
//	 */
//	@Override
//	public void selectionChanged(List<File> selectedFiles) {
//        File f = getSelectedFile();
//        
//        if (f != null) {
//	          for (IFileChanged fc : fileChangedList) {
//	        	  fc.fileChanged(f);
//	          }
//        }
//	}


	@Override
	public JComponent getDisplayItem() {
		return fileChooser.getUiContainer();
	}

	@Override
	public int showDialog(boolean open, Component parent) throws HeadlessException {

		if (open) {
			fileChooser.setChooserType(FileChooserDefs.FileChooserType.open);
		} else {
			fileChooser.setChooserType(FileChooserDefs.FileChooserType.save);
		}
		
		return (new UiFileChooserDialog(parent, fileChooser)).showDialog(parent);
	}

	@Override
	public int showOpenDialog(Component parent) throws HeadlessException {
		fileChooser.setChooserType(FileChooserDefs.FileChooserType.open);
		
		return (new UiFileChooserDialog(parent, fileChooser)).showDialog(parent);
	}

	@Override
	public int showSaveDialog(Component parent) throws HeadlessException {
		fileChooser.setChooserType(FileChooserDefs.FileChooserType.save);
	
		return (new UiFileChooserDialog(parent, fileChooser)).showDialog(parent);
	}

	@Override
	public void addActionListener(ActionListener l) {
		fileChooser.addActionListner(l);
	}

	@Override
	public void updateRecentDirectories(List<File> recentDirs) {
		// TODO Auto-generated method stub

	}
//
//	@Override
//	public void setDialogType(int dialogType) {
//		// TODO Auto-generated method stub
//
//	}

//	@Override
//	public void setFileFilter(FileFilter filter) {
//		fileChooser.setFileFilter(filter);
//	}

	@Override
	public void setFileSelectionMode(int mode) {
		fileChooser.setFileSelectionModeImp(mode);
	}

	@Override
	public void removeActionListener(ActionListener l) {
		fileChooser.removeActionListner(l);
	}

//	@Override
//	public void addChoosableFileFilter(FileFilter filter) {
////		List<AbstractFileFilter> availableFilters = fileChooser.getAvailableFilters();
////		AbstractFileFilter[] filters;
////		AbstractFileFilter transformFileFilter = FileUtils.transformFileFilter(filter);
////		if (availableFilters == null || availableFilters.size() == 0) {
////			filters = new AbstractFileFilter[] {transformFileFilter};
////		} else {
////			filters = new AbstractFileFilter[availableFilters.size() + 1];
////			int i = 0;
////			for (AbstractFileFilter f :  availableFilters) {
////				filters[i++] = f;
////			}
////			filters[i] =transformFileFilter;
////		}
////
////		fileChooser.setFileFilters(filters);
//	}

	@Override
	public File getSelectedFile() {
		return fileChooser.getSelectedFile();
	}

//	@Override
//	public FileFilter getFileFilter() {
//		//TODO Fix ...
//		return null;
////		return fileChooser.getActiveFileFilter();
//	}

	@Override
	public void setSelectedFile(File file) {
		//fileChooser.setCurrentFolder(file);
		fileChooser.setSelectedFile(file);
	}

	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.utils.swing.filechooser.IFileChooserWrapper#getCurrentDirectory()
	 */
	@Override
	public File getCurrentDirectory() {
		return fileChooser.getCurrentDirectory();
	}



	/**
	 * @param folder
	 * @see com.alee.laf.bm.filechooser.WebFileChooserPanel2#setCurrentFolder(java.io.File)
	 */
	@Override
	public void setCurrentDirectory(File folder) {
		fileChooser.setDirectory(folder);
	}


//	@Override
//	public void setControlButtonsAreShown(boolean b) {
//		//fileChooser.set
//	}


	/**
	 * @param text
	 * @see com.alee.laf.bm.filechooser.WebFileChooserPanel2#setApproveButtonText(java.lang.String)
	 */
	public void setApproveButtonText(String text) {
		if ("edit".equalsIgnoreCase(text)) {
			fileChooser.setAcceptButtonTxt(IconManager.ICONS.documentEdit, text);
		} else {
			fileChooser.setAcceptButtonTxt(null, text);
		}
	}


	/* (non-Javadoc)
	 * @see net.sf.RecordEditor.utils.swing.filechooser.IFileChooserWrapper#setApproveButtonToolTipText(java.lang.String)
	 */
	@Override
	public void setApproveButtonToolTipText(String tooltip) {
		fileChooser.setAcceptButtonToolTipTxt(tooltip);
	}



	@Override
	public void clickOpenBtn(boolean doEnter) {
		fileChooser.clickAcceptBtn();
	}



	@Override
	public void addFileExtension(String description, String... ext) {
		fileChooser.addFilter(new FileExtensionFilter(description, ext));
	}



	@Override
	public void addAllFilesFilter() {
		fileChooser.addFilter(AllFilesFilter.ALL_FILES);
	}

}
