package net.sf.RecordEditor.utils.swing.filechooser;

import java.io.File;
import java.util.List;

import javax.swing.JFileChooser;

import net.sf.RecordEditor.utils.common.Common;
import net.sf.RecordEditor.utils.params.Parameters;
import net.sf.RecordEditor.utils.params.ProgramOptions;
import net.sf.recordEditor.ui.def.FileChooserDefs;
import net.sf.recordEditor.ui.def.FileChooserDefs.FileChooserType;
import net.sf.recordEditor.ui.fileFields.params.IFileChooserParamAndBuilder;
import net.sf.recordEditor.ui.listManagers.IListItem;
import net.sf.recordEditor.ui.listManagers.IRecentList;

public class JrFileChooserBldr {

	public static IFileChooserWrapper newChooserCsvEditor(
			int screenWidth, String initialFile, IFileChooserParamAndBuilder paramBldr) {
			//RecentFiles recent, String favParam) {
		//List<File> directoryList = recent.getDirectoryList();
		return newChooser(
				Parameters.FILE_OPEN_CSV_EDIT, 
				screenWidth <= 0 || screenWidth > 1100, 
				initialFile, 
				null,
				paramBldr); 
	}

	public static IFileChooserWrapper newChooser(String initialFile, IFileChooserParamAndBuilder paramBldr) {
			//RecentFiles recent, String favParam) {
		//List<File> directoryList = recent.getDirectoryList();
		return newChooser(
				Common.OPTIONS.programType == ProgramOptions.ProgramType.CSV_EDITOR
							? Parameters.FILE_CHOOSER_OPTION_CSV
							: Parameters.FILE_CHOOSER_OPTION_RE, 
				true, 
				initialFile, 
				null,
				paramBldr); 
	}
	
	public static IFileChooserWrapper newChooser(String initialFile, File[] recentDirs) {
		return newChooser(
				Common.OPTIONS.programType == ProgramOptions.ProgramType.CSV_EDITOR
					? Parameters.FILE_CHOOSER_OPTION_CSV
					: Parameters.FILE_CHOOSER_OPTION_RE, 
				true, initialFile, recentDirs,
				null);
	}
	
	private static IFileChooserWrapper newChooser(
			String param, boolean suitableScreenSize,
			String initialFile, File[] recentDirs,
			IFileChooserParamAndBuilder paramBldr
			/*File[] recentDirs,
			RecentFiles recent, String favParam*/) {
		String s = Parameters.getString(param);
		boolean extended = true;
		boolean visible = true;
		
		if (Parameters.FILE_CHOOSER_EXTENDED.equals(s)) {
//			extended = true; 
//		} else if (Parameters.FILE_CHOOSER_OPTIONAL.equals(s)) {
//			extended = ! Parameters.isWindowsLAF();
		} else if (paramBldr!= null
				&& (s == null || s.length() == 0 || Parameters.FILE_CHOOSER_NEW.equals(s))) {
			try {
				File file = null;
				if (initialFile != null && initialFile.length() > 0) {
					if (initialFile.endsWith("*")) {
						initialFile = initialFile.substring(0, initialFile.length()-1);
					}
					file = new File(initialFile);
					paramBldr.initialPath(file);
				}
				JRUiFileChooser netFileChooser =  new JRUiFileChooser(paramBldr
									.showControlButtons(FileChooserDefs.ControlButtonDisplay.FILTERS_APPROVE)
								.asBuilderAndParameter()); 

				if (file != null && ! file.isDirectory()) {
					netFileChooser.setSelectedFile(file);
				}
				return netFileChooser;
			} catch (Exception e) {
				e.printStackTrace();
				Common.logMsg("Error creating File Chooser", null);
				Common.logMsg("", e);
				visible = suitableScreenSize && ! Parameters.isWindowsLAF();
			}
		} else if (! Parameters.FILE_CHOOSER_NORMAL.equals(s)) {
//			extended = true;
			visible = suitableScreenSize && ! Parameters.isWindowsLAF();
		} else {
			extended = false;
		}
		
		if (extended) {
			IRecentList recentDirectory;
			if (recentDirs == null && paramBldr != null 
			&& (recentDirectory = paramBldr.getRecentDirectory()) != null) {
				List<IListItem> itemList = recentDirectory.getItemList();
				recentDirs = new File[itemList.size()]; 
				int idx = 0;
				for (IListItem itm : itemList) {
					recentDirs[idx++] = new File(itm.getItemText());
				}
			}
			if (recentDirs != null && recentDirs.length > 0) {
				return setDialogType(new JRFileChooserExtendedWrapper(initialFile, recentDirs, visible), paramBldr);
			}
		}
		
		return setDialogType(new JRFileChooserWrapper(initialFile), paramBldr);
	}

	private static IFileChooserWrapper setDialogType(JRFileChooserWrapperBase chooser, IFileChooserParamAndBuilder paramBldr) {
		if (paramBldr != null) {
			FileChooserType chooserType = paramBldr.getChooserType();
			
			JFileChooser fileChooser = chooser.getFileChooser();
			if ((chooserType) != null) {
				switch (chooserType) {
				case save:
					fileChooser.setDialogType(JFileChooser.SAVE_DIALOG);
					break;
		
				default:
					fileChooser.setDialogType(JFileChooser.OPEN_DIALOG);
				}
			}
			switch (paramBldr.getShowControlButtons()) {
			case FILTERS:
				fileChooser.setControlButtonsAreShown(false);
				break;
//		case FILTERS_APPROVE:
//			chooser.set
			}
		}
		return chooser;
	}
}
