package net.sf.RecordEditor.utils.swing.saveRestore;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.JButton;
import javax.swing.JFileChooser;

import net.sf.RecordEditor.utils.common.Common;
import net.sf.RecordEditor.utils.lang.LangConversion;
import net.sf.RecordEditor.utils.swing.filechooser.IFileChooserWrapper;
import net.sf.RecordEditor.utils.swing.filechooser.JrFileChooserBldr;
import net.sf.RecordEditor.xml.ILoadSavedClass;
import net.sf.recordEditor.ui.fileFields.params.FileFieldParamBldr;
import net.sf.recordEditor.ui.fileFields.params.IFileChooserParamAndBuilder;

@SuppressWarnings("serial")
public class LoadButton<What> extends JButton implements ActionListener {

	private final IUpdateDetails<What> saveCallBack;
	private final String dir;
	private IFileChooserWrapper fileChooser = null;

	private final ILoadSavedClass<What> loader;
	//private final Class dtlsClass;

	public LoadButton(IUpdateDetails<What> save, String directory, ILoadSavedClass<What> loader) {
		super(LangConversion.convert(LangConversion.ST_BUTTON, "Load"), Common.getRecordIcon(Common.ID_OPEN_ICON));

		saveCallBack = save;
		dir = directory;
		this.loader = loader;

		this.addActionListener(this);
	}

	@Override
	public void actionPerformed(ActionEvent e) {

		if (e.getSource() == this) {
			try {
				
				if (fileChooser == null) {
					IFileChooserParamAndBuilder paramBuilder = FileFieldParamBldr.newFileChooserParamAndBuilder();
					fileChooser = JrFileChooserBldr.newChooser(null, paramBuilder);
				}

				if (dir != null) {
					fileChooser.setSelectedFile(new File(dir));
				}

				int ret = fileChooser.showOpenDialog(this);

				if (ret == JFileChooser.APPROVE_OPTION) {
//					net.sf.RecordEditor.jibx.JibxCall<What> jibx
//					= new net.sf.RecordEditor.jibx.JibxCall<What>(dtlsClass);

					System.out.println(fileChooser.getSelectedFile().getPath());
					//What saveDetails = jibx.marshal(fileChooser.getSelectedFile().getPath());
					
					What saveDetails = loader.load(fileChooser.getSelectedFile().getPath());

					saveCallBack.update(saveDetails);
				}
			} catch (Exception ex) {
				ex.printStackTrace();
				Common.logMsg("Execute Error", ex);
			}
		}
	}


}
