package net.sf.RecordEditor.utils.swing.treeCombo;

import java.io.File;
import java.util.Arrays;
import java.util.List;

import net.sf.RecordEditor.utils.params.Parameters;
import net.sf.RecordEditor.utils.swing.filechooser.IFileChooserWrapper;
import net.sf.RecordEditor.utils.swing.filechooser.JrFileChooserBldr;

/**
 * Class to select jar files
 * 
 * @author Bruce
 *
 */
@SuppressWarnings("serial")
public class JarFileSelect extends TreeComboFileSelect {

	private static File[] standardFiles = {
		new File(Parameters.expandVars("<lib>")),
	};
	private static final IFileChooserWrapper cw = JrFileChooserBldr.newChooser(null, standardFiles) ;

	public JarFileSelect(boolean isOpen,  List<FileTreeComboItem> itms) {
		super(true, false, ((List<FileTreeComboItem>) null), cw, Arrays.asList(standardFiles));
		//super(isOpen, false, true, itms, null);
		
		IFileChooserWrapper fileChooser = super.getChooseHelper().getChooseFile();

		//FileFilter filter = fileChooser.getFileFilter();
		
		fileChooser.addFileExtension("Jar/Zip file", "jar", "zip");
		fileChooser.addFileExtension("Jar file", "jar");
//		fileChooser.addChoosableFileFilter(new javax.swing.filechooser.FileNameExtensionFilter("Jar/Zip file", "jar", "zip"));
//		fileChooser.addChoosableFileFilter(new javax.swing.filechooser.FileNameExtensionFilter("Jar file", "jar"));

		fileChooser.addAllFilesFilter();
	}
}
