package net.sf.RecordEditor.utils.swingx;

import java.awt.Component;
import java.awt.Dimension;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.Properties;

import net.sf.RecordEditor.utils.params.Parameters;
import net.sf.recordEditor.ui.xEnvironment.SwingUtils;


public class TipsImpl {


	protected static void startTips(Component parent, String tipfile, String tipVariable) {
		try {
			Properties tipsProperties = new Properties();
			tipsProperties.load(new FileInputStream(tipfile));

			org.jdesktop.swingx.tips.TipOfTheDayModel model = org.jdesktop.swingx.tips.TipLoader.load(tipsProperties);
			org.jdesktop.swingx.JXTipOfTheDay tips = new org.jdesktop.swingx.JXTipOfTheDay(model);

			long startTip = System.currentTimeMillis() % Math.max(1, model.getTipCount());

			Dimension d = tips.getPreferredSize();

			if (d.height > 0) {
				d.height = d.height + SwingUtils.values().CHAR_FIELD_HEIGHT * 3;
				d.width = d.width + SwingUtils.values().CHAR_FIELD_WIDTH * 5;

				tips.setPreferredSize(d);
			}

			for (int i = 0; i < startTip; i++) {
				tips.nextTip();
			}
			tips.showDialog(parent, new StartupHandler(tipVariable));
		} catch (IOException ioe) {
//			Common.logMsgRaw("IO Error Loading Tips", ioe);
			ioe.printStackTrace();
		}
	}


	private static class StartupHandler implements org.jdesktop.swingx.JXTipOfTheDay.ShowOnStartupChoice {

		private String propertiesVarName;



		public StartupHandler(String propertiesVarName) {
			super();
			this.propertiesVarName = propertiesVarName;
		}

		@Override
		public void setShowingOnStartup(boolean showOnStartup) {
			String s = "N";
			if (showOnStartup) {
				s = "Y";
			}

			Parameters.setProperty(propertiesVarName, s);
		}

		@Override
		public boolean isShowingOnStartup() {
			return true;
		}
	}
}
