package  net.sf.RecordEditor.xml.classes;


public class  EditorTask implements  IEditorTask {

	public static final String TASK_FILTER      = "Filter";
	public static final String TASK_SORT_TREE   = "SortTree";
	public static final String TASK_FIELD_TREE  = "FieldTree";
	public static final String TASK_SORT        = "Sort";
	public static final String TASK_RECORD_TREE = "RecordTree";
	public static final String TASK_VISIBLE_FIELDS = "VisibleFields";
	public static final String TASK_FIELD_SEQUENCE = "FieldSequence";

     public String type;
     public String layoutName = "";

    Layout filter;// = new Layout();
    SortTree sortTree;// = new SortTree();
    RecordTree recordTree;// = new RecordTree();
    FieldSequence fieldSequence;// = new FieldSequence();

    public String getType() {
    	return  type;
    }
    public String getLayoutName() {
    	return  layoutName;
    }

    public Layout getFilter() {
	   return filter;
	}
    public SortTree getSortTree() {
	   return sortTree;
	}
    public RecordTree getRecordTree() {
	   return recordTree;
	}
    public FieldSequence getFieldSequence() {
	   return fieldSequence;
	}

	public void setFieldSequence(FieldSequence fieldSequence) {
		this.fieldSequence = fieldSequence;
	}
	public EditorTask setFilter(Layout filterDetails) {
		type = TASK_FILTER;

		filter = filterDetails;
		layoutName = filterDetails.name;

		return this;
	}


	public EditorTask setSortTree(String id, String recordLayoutName, SortTree sortDetails) {
		type = id;

		layoutName = recordLayoutName;
		sortTree = sortDetails;

		return this;
	}

	/**
	 * set Record Tree
	 * @param recordDetails record Tree
	 * @return this
	 */
	public EditorTask setRecordTree(String recordLayoutName, RecordTree recordDetails) {
		type = TASK_RECORD_TREE;

		layoutName = recordLayoutName;
		recordTree = recordDetails;

		return this;
	}


}