package layoutWizard;

import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

import javax.swing.JTextField;

import org.junit.Test;

import net.sf.JRecord.Common.IFileStructureConstants;
import net.sf.RecordEditor.layoutWizard.ColumnSelector;
import net.sf.RecordEditor.utils.fileAnalysis.Details;
import net.sf.RecordEditor.utils.swing.BasePanel;
import xCommon.XCommonCode;

public class TstColumnSelector {



//	private static final byte[] DTAR020_DATA = getData("DTAR020.bin");
//	
//	
//	private static byte[] getData(String fname) {
//		return XCommonCode.readDataFile(fname);
//	}
//	

	@Test
	public void tstDTAR020a() throws Exception {
		Details details = getDTAR020details();
		JTextField msgFld = new JTextField();
		
        BasePanel pnl = new BasePanel();
		ColumnSelector cs = new ColumnSelector(msgFld);
        cs.addFields(pnl, 50);
		cs.readFile(details, details.standardRecord);
        cs.setValues(details, details.standardRecord, true);

        assertFalse(cs.textFileChk.isSelected());

        assertTrue(cs.lookComp3.isSelected());
        assertTrue(cs.lookCompBigEndian.isSelected());
        assertFalse(cs.lookCompLittleEndian.isSelected());
        assertTrue(cs.lookMainframeZoned.isSelected());
        assertFalse(cs.lookPcZoned.isSelected());
        
        assertTrue(cs.hexChk.getParent() != null);
        assertTrue(cs.lookComp3.getParent() != null);
        assertTrue(cs.lookCompBigEndian.getParent() != null);
        assertTrue(cs.lookCompLittleEndian.getParent() != null);
        assertTrue(cs.lookMainframeZoned.getParent() != null);
        assertTrue(cs.lookPcZoned.getParent() != null);

        assertTrue(cs.fileTbl.getParent() != null);
    }

	private Details getDTAR020details() {
		Details details = new Details();
		details.filename = XCommonCode.getFileName("DTAR020.bin");
	;	details.fileStructure = IFileStructureConstants.IO_FIXED_LENGTH;
		details.fontName = "CP037";
		details.recordLength = 27;
		details.normalCharPercent = 40;
		details.textPercent = 70;
		
		return details;
	}
}
