package xCommon;

import java.io.ByteArrayInputStream;
import java.io.IOException;

import net.sf.JRecord.Details.LayoutDetail;
import net.sf.JRecord.External.ExternalRecord;
import net.sf.JRecord.External.RecordEditorXmlLoader;

public class XStdSchemas implements IToLayout {
	
	public static IToLayout GETTEXT_PO = new XStdSchemas(
			"GetText_PO",
			"<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
			+ "<RECORD RECORDNAME=\"GetText_PO\" COPYBOOK=\"\" DELIMITER=\"&lt;Tab&gt;\" FILESTRUCTURE=\"101\" STYLE=\"0\" RECORDTYPE=\"Delimited\" LIST=\"Y\" QUOTE=\"\" RecSep=\"default\" SYSTEMNAME=\"System Layouts\">\n"
			+ "	<FIELDS>\n"
			+ "		<FIELD NAME=\"msgctxt\" POSITION=\"1\" TYPE=\"Char (Multi-Line)\"/>\n"
			+ "		<FIELD NAME=\"msgid\" POSITION=\"2\" TYPE=\"Char (Multi-Line)\"/>\n"
			+ "		<FIELD NAME=\"msgstr\" POSITION=\"3\" TYPE=\"Char (Multi-Line)\"/>\n"
			+ "		<FIELD NAME=\"comments\" POSITION=\"4\" TYPE=\"Char (Multi-Line)\"/>\n"
			+ "		<FIELD NAME=\"msgidPlural\" POSITION=\"5\" TYPE=\"Char (Multi-Line)\"/>\n"
			+ "		<FIELD NAME=\"msgstrPlural\" POSITION=\"6\" TYPE=\"Array Field\"/>\n"
			+ "		<FIELD NAME=\"extractedComments\" POSITION=\"7\" TYPE=\"Char (Multi-Line)\"/>\n"
			+ "		<FIELD NAME=\"reference\" POSITION=\"8\" TYPE=\"Char (Multi-Line)\"/>\n"
			+ "		<FIELD NAME=\"flags\" POSITION=\"9\" TYPE=\"Char (Multi-Line)\"/>\n"
			+ "		<FIELD NAME=\"previousMsgctx\" POSITION=\"10\" TYPE=\"Char (Multi-Line)\"/>\n"
			+ "		<FIELD NAME=\"previousMsgId\" POSITION=\"11\" TYPE=\"Char (Multi-Line)\"/>\n"
			+ "		<FIELD NAME=\"previousMsgidPlural\" POSITION=\"12\" TYPE=\"Char (Multi-Line)\"/>\n"
			+ "		<FIELD NAME=\"fuzzy\" POSITION=\"13\" TYPE=\"Checkbox Y/&lt;null&gt;\"/>\n"
			+ "		<FIELD NAME=\"obsolete\" POSITION=\"14\" TYPE=\"Checkbox Y/&lt;null&gt;\"/>\n"
			+ "	</FIELDS>\n"
			+ "</RECORD>\n");
	
	public static IToLayout TIP_DETAILS = new XStdSchemas(
			"TipDetails",
			"<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
			+ "<RECORD RECORDNAME=\"TipDetails\" COPYBOOK=\"\" DELIMITER=\"&lt;Tab&gt;\" FILESTRUCTURE=\"102\" STYLE=\"0\" RECORDTYPE=\"Delimited\" LIST=\"Y\" QUOTE=\"\" RecSep=\"default\" SYSTEMNAME=\"System Layouts\">\n"
			+ "	<FIELDS>\n"
			+ "		<FIELD NAME=\"name\" POSITION=\"1\" TYPE=\"Char\"/>\n"
			+ "		<FIELD NAME=\"description\" POSITION=\"2\" TYPE=\"Char (Multi-Line)\"/>\n"
			+ "	</FIELDS>\n"
			+ "</RECORD>");
	
	
	public static IToLayout DTAR1000 = new XStdSchemas(
			"DTAR1000",
			"<?xml version=\"1.0\" ?>\n"
					+ "<RECORD RECORDNAME=\"DTAR1000 VB\" COPYBOOK=\"DTAR1000\" DELIMITER=\"&lt;Tab&gt;\" DESCRIPTION=\"Stores File VB\" FONTNAME=\"CP037\" FILESTRUCTURE=\"Mainframe_VB\" STYLE=\"0\" RECORDTYPE=\"BinaryRecord\" LIST=\"Y\" QUOTE=\"\" RecSep=\"default\">\n"
					+ "	<FIELDS>\n"
					+ "		<FIELD NAME=\"STORE-NO\" POSITION=\"1\" LENGTH=\"2\" TYPE=\"Binary Integer Big Endian (Mainframe, AIX etc)\" COBOLNAME=\"DTAR1000-STORE-NO\"/>\n"
					+ "		<FIELD NAME=\"REGION-NO\" POSITION=\"3\" LENGTH=\"2\" TYPE=\"Binary Integer Big Endian (Mainframe, AIX etc)\" COBOLNAME=\"DTAR1000-REGION-NO\"/>\n"
					+ "		<FIELD NAME=\"STORE-NAME\" POSITION=\"5\" LENGTH=\"50\" TYPE=\"Char\" COBOLNAME=\"DTAR1000-STORE-NAME\"/>\n"
					+ "		<FIELD NAME=\"NEW-STORE\" POSITION=\"55\" LENGTH=\"1\" TYPE=\"Char\" COBOLNAME=\"DTAR1000-NEW-STORE\"/>\n"
					+ "		<FIELD NAME=\"ACTIVE-STORE\" POSITION=\"56\" LENGTH=\"1\" TYPE=\"Char\" COBOLNAME=\"DTAR1000-ACTIVE-STORE\"/>\n"
					+ "		<FIELD NAME=\"CLOSED-STORE\" POSITION=\"57\" LENGTH=\"1\" TYPE=\"Char\" COBOLNAME=\"DTAR1000-CLOSED-STORE\"/>\n"
					+ "		<FIELD NAME=\"DC-TYPE\" POSITION=\"58\" LENGTH=\"1\" TYPE=\"Char\" COBOLNAME=\"DTAR1000-DC-TYPE\"/>\n"
					+ "		<FIELD NAME=\"SRC-TYPE\" POSITION=\"59\" LENGTH=\"1\" TYPE=\"Char\" COBOLNAME=\"DTAR1000-SRC-TYPE\"/>\n"
					+ "		<FIELD NAME=\"HO-TYPE\" POSITION=\"60\" LENGTH=\"1\" TYPE=\"Char\" COBOLNAME=\"DTAR1000-HO-TYPE\"/>\n"
					+ "	</FIELDS>\n"
					+ "</RECORD>"
			);


	private final String copybookName, xmlSchema;

	public XStdSchemas(String copybookName, String xmlSchema) {
		super();
		this.xmlSchema = xmlSchema;
		this.copybookName = copybookName;
	}
	
	@Override
	public LayoutDetail toLayout() throws IOException {
		RecordEditorXmlLoader load = new RecordEditorXmlLoader();
		ByteArrayInputStream is = new ByteArrayInputStream(xmlSchema.getBytes());
		
		
		ExternalRecord xRec = load.loadCopyBook(is, copybookName);
		
		is.close();
		
		return xRec.asLayoutDetail();
	}

}
