package net.sf.RecordEditor.test.diff;

import java.io.IOException;

import org.junit.Test;

import net.sf.JRecord.Details.LayoutDetail;
import net.sf.RecordEditor.diff.result.ICompareSummary;
import net.sf.RecordEditor.diff.tbl.CmpTableModel;
import xCommon.XSchemas;

public class TstCompareSummary4 {


	private static String[] CHANGED_RECORDS = TstData4.CHANGED_RECORDS;
	
	private static String[] FULL_FILE = TstData4.FULL_FILE;
	
	
	@Test
	public void testCompareResult() throws IOException {
		CommonTstVisitorSummary tst = new CommonTstVisitorSummary("4");
		ICompareSummary summary = tst.getCompareSummary();

		tst.tstResult(summary.getResult(false),null, 35);

		tst.tstResult(summary.getResult(false),CHANGED_RECORDS, 999);
		//tst.tstResult(summary.getResult(true), ALL_RECORDS, 35);
		tst.tstResult(summary.getResult(true), FULL_FILE, FULL_FILE.length);
	}


	@Test
	public void testCmpTableModel() throws IOException {
		CommonTstVisitorSummary tst = new CommonTstVisitorSummary("4");
		LayoutDetail dtar020 = XSchemas.getDtar020();
		
		ICompareSummary summary = tst.getCompareSummary();
		
		CmpTableModel tbl = new CmpTableModel(dtar020, summary.getResult(false));
		
		tst.tstTable(tbl, CHANGED_RECORDS);
		
		tbl.setDisplayRows(summary.getResult(true));

//		tst.tstTable(tbl, ALL_RECORDS);
		tst.tstTable(tbl, FULL_FILE);
	}

}
