package net.sf.RecordEditor.test.diff;

import java.io.IOException;

import org.junit.Test;

import net.sf.JRecord.Details.LayoutDetail;
import net.sf.RecordEditor.diff.result.ICompareSummary;
import net.sf.RecordEditor.diff.tbl.CmpTableModel;
import xCommon.XSchemas;

public class TstCompareSummary5 {

	private static String[] CHANGED_RECORDS = TstData5.CHANGED_RECORDS;
	private static String[] FULL_FILE = TstData5.FULL_FILE;
	
	@Test
	public void testCompareResult() throws IOException {
		CommonTstVisitorSummary tst = new CommonTstVisitorSummary("5");
		ICompareSummary summary = getSummary(tst);

		//tst.tstResult(summary.getResult(false),null, 999);
		tst.tstResult(summary.getResult(true), null, 9999);

		tst.tstResult(summary.getResult(false),CHANGED_RECORDS, 999);
		tst.tstResult(summary.getResult(true), FULL_FILE, FULL_FILE.length);
	}


	/**
	 * @param tst
	 * @return
	 * @throws IOException
	 */
	private ICompareSummary getSummary(CommonTstVisitorSummary tst) throws IOException {
		return tst.getCompareSummary();
	}

	
	@Test
	public void testCompareResultRev() throws IOException {
		CommonTstVisitorSummary tst = new CommonTstVisitorSummary(false, "5");
		ICompareSummary summary = getSummary(tst);

		//tst.tstResult(summary.getResult(false),null, 999);
		//tst.tstResult(summary.getResult(true), null, 9999);

		tst.tstResult(summary.getResult(false),CHANGED_RECORDS, 999);
		tst.tstResult(summary.getResult(true), FULL_FILE, FULL_FILE.length);
	}

		
	@Test
	public void testCmpTableModel() throws IOException {
		
		CommonTstVisitorSummary tst = new CommonTstVisitorSummary(true, "5");
		LayoutDetail dtar020 = XSchemas.getDtar020();
		
		ICompareSummary summary = getSummary(tst);
		
		CmpTableModel tbl = new CmpTableModel(dtar020, summary.getResult(false));
		
		tst.tstTable(tbl, CHANGED_RECORDS);
		
		tbl.setDisplayRows(summary.getResult(true));

		tst.tstTable(tbl, FULL_FILE);

	}

	
	@Test
	public void testCmpTableModelRev() throws IOException {
		
		CommonTstVisitorSummary tst = new CommonTstVisitorSummary(false, "5");
		LayoutDetail dtar020 = XSchemas.getDtar020();
		
		ICompareSummary summary = getSummary(tst);
		
		CmpTableModel tbl = new CmpTableModel(dtar020, summary.getResult(false));
		
		tst.tstTable(tbl, CHANGED_RECORDS);
		
		tbl.setDisplayRows(summary.getResult(true));
	
		tst.tstTable(tbl, FULL_FILE);
	}

//	
//	@Test
//	public void xx() throws IOException {
//		
//		
//		for (int i = 0; i < OLD_FILE.length; i++) {
//			if (OLD_FILE[i].equals(FULL_FILE[i])) {
//				System.out.print('.');
//			} else if (upd(OLD_FILE[i]).equals(upd(FULL_FILE[i]))) {
//				System.out.print('.');
//			} else {
//				assertEquals(OLD_FILE[i], FULL_FILE[i]);
//			}
//		}
//	}
//	
//	String upd(String s) {
//		int idx = s.indexOf('\t');
//		if (idx > 0) {
//			return s.substring(idx);
//		}
//		return s;
//	}

	
}
