package net.sf.RecordEditor.test.diff;

import java.io.IOException;

import org.junit.Test;

import net.sf.JRecord.Details.LayoutDetail;
import net.sf.RecordEditor.diff.result.ICompareSummary;
import net.sf.RecordEditor.diff.tbl.CmpTableModel;
import net.sf.RecordEditor.test.diff.CommonTstVisitorSummary.TestType;
import xCommon.XSchemas;

public class TstCompareSummary6 {

	private static String[] CHANGED_RECORD6 = TstData6.CHANGED_RECORDS6;
	private static String[] FULL_FILE6 = TstData6.FULL_FILE6;
	private static String[] CHANGED_RECORD7 = TstData6.CHANGED_RECORDS7;
	private static String[] FULL_FILE7 = TstData6.FULL_FILE7;
	private static String[] CHANGED_RECORD8 = TstData6.CHANGED_RECORDS8;
	private static String[] FULL_FILE8 = TstData6.FULL_FILE8;
	
	@Test
	public void testCompareResult() throws IOException {
		CommonTstVisitorSummary tst = new CommonTstVisitorSummary("6");
		ICompareSummary summary = getSummary(tst);

		//tst.tstResult(summary.getResult(false),null, 999);
		//tst.tstResult(summary.getResult(true), null, 9999);

		tst.tstResult(summary.getResult(false),CHANGED_RECORD6, 999);
		tst.tstResult(summary.getResult(true), FULL_FILE6, FULL_FILE6.length);
	}


	/**
	 * @param tst
	 * @return
	 * @throws IOException
	 */
	private ICompareSummary getSummary(CommonTstVisitorSummary tst) throws IOException {
		return tst.getCompareSummary();
	}

	
	@Test
	public void testCompareResultRev() throws IOException {
		CommonTstVisitorSummary tst = new CommonTstVisitorSummary(false, "6");
		ICompareSummary summary = getSummary(tst);

		tst.tstResult(summary.getResult(false),CHANGED_RECORD6, 999);
		tst.tstResult(summary.getResult(true), FULL_FILE6, FULL_FILE6.length);
	}

		
	@Test
	public void testCmpTableModel() throws IOException {
		
		CommonTstVisitorSummary tst = new CommonTstVisitorSummary(true, "6");
		LayoutDetail dtar020 = XSchemas.getDtar020();
		
		ICompareSummary summary = getSummary(tst);
		
		CmpTableModel tbl = new CmpTableModel(dtar020, summary.getResult(false));
		
		tst.tstTable(tbl, CHANGED_RECORD6);
		
		tbl.setDisplayRows(summary.getResult(true));

		tst.tstTable(tbl, FULL_FILE6);

	}

	
	@Test
	public void testCmpTableModelRev() throws IOException {
		
		CommonTstVisitorSummary tst = new CommonTstVisitorSummary(false, "6");
		LayoutDetail dtar020 = XSchemas.getDtar020();
		
		ICompareSummary summary = getSummary(tst);
		
		CmpTableModel tbl = new CmpTableModel(dtar020, summary.getResult(false));
		
		tst.tstTable(tbl, CHANGED_RECORD6);
		
		tbl.setDisplayRows(summary.getResult(true));
	
		tst.tstTable(tbl, FULL_FILE6);
	}

	
	
	@Test
	public void testCompareResult7() throws IOException {
		CommonTstVisitorSummary tst = new CommonTstVisitorSummary("7");
		ICompareSummary summary = getSummary(tst);

		//tst.tstResult(summary.getResult(false),null, 999);
		//tst.tstResult(summary.getResult(true), null, 9999);

		tst.tstResult(summary.getResult(false),CHANGED_RECORD7, 999);
		tst.tstResult(summary.getResult(true), FULL_FILE7, FULL_FILE7.length);
	}
	
	
	@Test
	public void testCompareResultRev7() throws IOException {
		CommonTstVisitorSummary tst = new CommonTstVisitorSummary(false, "7");
		ICompareSummary summary = getSummary(tst);

		tst.tstResult(summary.getResult(false),CHANGED_RECORD7, 999);
		tst.tstResult(summary.getResult(true), FULL_FILE7, FULL_FILE7.length);
	}

		
	@Test
	public void testCmpTableModel7() throws IOException {
		
		CommonTstVisitorSummary tst = new CommonTstVisitorSummary(true, "7");
		LayoutDetail dtar020 = XSchemas.getDtar020();
		
		ICompareSummary summary = getSummary(tst);
		
		CmpTableModel tbl = new CmpTableModel(dtar020, summary.getResult(false));
		
		tst.tstTable(tbl, CHANGED_RECORD7);
		
		tbl.setDisplayRows(summary.getResult(true));

		tst.tstTable(tbl, FULL_FILE7);

	}

	
	@Test
	public void testCmpTableModelRev7() throws IOException {
		
		CommonTstVisitorSummary tst = new CommonTstVisitorSummary(false, "7");
		LayoutDetail dtar020 = XSchemas.getDtar020();
		
		ICompareSummary summary = getSummary(tst);
		
		CmpTableModel tbl = new CmpTableModel(dtar020, summary.getResult(false));
		
		tst.tstTable(tbl, CHANGED_RECORD7);
		
		tbl.setDisplayRows(summary.getResult(true));
	
		tst.tstTable(tbl, FULL_FILE7);
	}

	
	
	@Test
	public void testCompareResult8() throws IOException {
		CommonTstVisitorSummary tst = new CommonTstVisitorSummary(TestType.DTAR020_CmpZ3, true, "6");
		ICompareSummary summary = getSummary(tst);

		//tst.tstResult(summary.getResult(false),null, 999);
		//tst.tstResult(summary.getResult(true), null, 9999);

		tst.tstResult(summary.getResult(false),CHANGED_RECORD8, 999);
		tst.tstResult(summary.getResult(true), FULL_FILE8, FULL_FILE8.length);
	}

	
	@Test
	public void testCompareResultRev8() throws IOException {
		CommonTstVisitorSummary tst = new CommonTstVisitorSummary(TestType.DTAR020_CmpZ3, false, "6");
		ICompareSummary summary = getSummary(tst);

		tst.tstResult(summary.getResult(false),CHANGED_RECORD8, 999);
		tst.tstResult(summary.getResult(true), FULL_FILE8, FULL_FILE8.length);
	}

		
	@Test
	public void testCmpTableModel8() throws IOException {
		
		CommonTstVisitorSummary tst = new CommonTstVisitorSummary(TestType.DTAR020_CmpZ3, true, "6");
		LayoutDetail dtar020 = XSchemas.getDtar020();
		
		ICompareSummary summary = getSummary(tst);
		
		CmpTableModel tbl = new CmpTableModel(dtar020, summary.getResult(false));
		
		tst.tstTable(tbl, CHANGED_RECORD8);
		
		tbl.setDisplayRows(summary.getResult(true));

		tst.tstTable(tbl, FULL_FILE8);

	}

	
	@Test
	public void testCmpTableModelRev8() throws IOException {
		
		CommonTstVisitorSummary tst = new CommonTstVisitorSummary(TestType.DTAR020_CmpZ3, false, "6");
		LayoutDetail dtar020 = XSchemas.getDtar020();
		
		ICompareSummary summary = getSummary(tst);
		
		CmpTableModel tbl = new CmpTableModel(dtar020, summary.getResult(false));
		
		tst.tstTable(tbl, CHANGED_RECORD8);
		
		tbl.setDisplayRows(summary.getResult(true));
	
		tst.tstTable(tbl, FULL_FILE8);
	}


//	
//	@Test
//	public void xx() throws IOException {
//		
//		
//		for (int i = 0; i < OLD_FILE.length; i++) {
//			if (OLD_FILE[i].equals(FULL_FILE[i])) {
//				System.out.print('.');
//			} else if (upd(OLD_FILE[i]).equals(upd(FULL_FILE[i]))) {
//				System.out.print('.');
//			} else {
//				assertEquals(OLD_FILE[i], FULL_FILE[i]);
//			}
//		}
//	}
//	
//	String upd(String s) {
//		int idx = s.indexOf('\t');
//		if (idx > 0) {
//			return s.substring(idx);
//		}
//		return s;
//	}

	
}
