/**
 * 
 */
package ZOldnet.sf.RecordEditor.utils.swing.table;

import java.awt.Component;

import javax.swing.AbstractCellEditor;
import javax.swing.JComponent;
import javax.swing.JTable;
import javax.swing.table.TableCellEditor;

import net.sf.recordEditor.ui.xEnvironment.SwingUtils;


/**
 * @author Bruce Martin
 *
 */
@SuppressWarnings("serial")
public class ReStandardCellEditor extends AbstractCellEditor implements
		TableCellEditor {

	
	public static TableCellEditor getCellEditor(IGetSetObj componentDtls, boolean updateColors) {
		return new ReStandardCellEditor(componentDtls, updateColors);
	}
	
	private final IGetSetObj componentDtls;
	private final boolean updateColors;

	protected ReStandardCellEditor(IGetSetObj componentDtls, boolean updateColors) {
		super();
		this.componentDtls = componentDtls;
		this.updateColors = updateColors;
	}

	/* (non-Javadoc)
	 * @see javax.swing.CellEditor#getCellEditorValue()
	 */
	@Override
	public Object getCellEditorValue() {
		return componentDtls.getObject();
	}

	/* (non-Javadoc)
	 * @see javax.swing.table.TableCellEditor#getTableCellEditorComponent(javax.swing.JTable, java.lang.Object, boolean, int, int)
	 */
	@Override
	public Component getTableCellEditorComponent(JTable table, Object value,
			boolean isSelected, int row, int column) {
		componentDtls.setObject(value);

		JComponent component = componentDtls.getComponent();
		if (updateColors) {
			SwingUtils.values().setTableCellColors(component, table, row, isSelected);
		}
		return component;
	}

}
