package net.sf.recordEditor.ui.common;

import java.awt.BorderLayout;

import javax.swing.Action;
import javax.swing.Icon;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JTable;
import javax.swing.table.TableModel;

import net.sf.recordEditor.ui.def.component.IUiButton;
import net.sf.recordEditor.ui.def.component.IUiTable;
import net.sf.recordEditor.ui.styles.IStyle;
import net.sf.recordEditor.ui.styles.ITableStyle;
import net.sf.recordEditor.ui.styles.StyleManager;


/**
 * Some Common Components
 * 
 * @author Bruce Martin
 *
 */
public class StdComponents {

	public static class UiButton extends UiStdComponent<JButton> implements IUiButton {

		public UiButton(IStyle style, Action a) { super(style, new JButton(a)); }

		public UiButton(IStyle style, Icon a) { super(style, new JButton(a)); }

		public UiButton(IStyle style, String a) { super(style, new JButton(a)); }	
	}

	public static class UiPnlButton extends UiStdComponent2<JPanel, JButton> implements IUiButton {

		public UiPnlButton(IStyle style, Action a) { this(style, new JButton(a)); }

		public UiPnlButton(IStyle style, Icon a) { this(style, new JButton(a)); }

		public UiPnlButton(IStyle style, String a) { this(style, new JButton(a)); }	
		
		public UiPnlButton(IStyle style, JButton btn) {
			super(style, new JPanel(new BorderLayout(0, 0)), btn); 
			super.getUiContainer().add(btn);
		}	

	}
	
	public static class UiTable extends UiStdComponent<JTable> implements IUiTable  {

		public UiTable(ITableStyle style, TableModel dm) {
			this(style, new JTable(dm));
		}

		public UiTable(ITableStyle style, JTable table) {
			super(style == null ? StyleManager.EMPTY_STYLE : style, table);
			
			if (style != null) {
				style.applyTable(this);
			}
		}
	}
	
	
}
