package net.sf.recordEditor.ui.common;

import javax.swing.JComponent;
import javax.swing.JLabel;

import net.sf.recordEditor.ui.def.component.IUiComponent;
import net.sf.recordEditor.ui.styles.IStyle;

public class UiStdComponent<Component extends JComponent> implements IUiComponent {

	private final IStyle style;
	protected final Component component;
	protected final JComponent container;
	
	private JLabel fieldsLabel;
	
	public UiStdComponent(IStyle style, Component component) {
		this(style, component, component);
	}
	public UiStdComponent(IStyle style, JComponent container, Component component) {
		super();
		this.style = style;
		this.component = component;
		this.container = container;
		
		if (style != null) {
			style.register(this);
		}
	}

	@Override
	public JComponent getUiContainer() {
		return container;
	}

	@Override
	public Component getMainComponent() {
		return component;
	}

	@Override
	public IStyle getStyleId() {
		return style;
	}

	@Override
	public JLabel getFieldsLabel() {
		return fieldsLabel;
	}

	@Override
	public void setFieldsLabel(JLabel label) {
		this.fieldsLabel = label;
	}

}
