package net.sf.recordEditor.ui.common;

import java.awt.Component;

import javax.swing.JComponent;
import javax.swing.JLabel;

import net.sf.recordEditor.ui.def.component.IUiComponent;
import net.sf.recordEditor.ui.styles.IStyle;

public class UiStdComponent2<Container extends Component, Comp extends JComponent> implements IUiComponent {

	private final IStyle style;
	protected final Comp component;
	protected       Container container;
	
	private JLabel fieldsLabel;
	

	public UiStdComponent2(IStyle style, Container container, Comp component) {
		super();
		this.style = style;
		this.component = component;
		this.container = container;
		
		if (style != null) {
			style.register(this);
		}
	}

	@Override
	public Container getUiContainer() {
		return container;
	}

	@Override
	public Comp getMainComponent() {
		return component;
	}

	@Override
	public IStyle getStyleId() {
		return style;
	}

	@Override
	public JLabel getFieldsLabel() {
		return fieldsLabel;
	}

	@Override
	public void setFieldsLabel(JLabel label) {
		this.fieldsLabel = label;
	}
}
