package net.sf.recordEditor.ui.form;

import info.clearthought.layout.TableLayout;
import net.sf.recordEditor.ui.xEnvironment.SwingUtils;

public class FormHelper {
	public static final double NORMAL_HEIGHT = SwingUtils.values().NORMAL_FIELD_HEIGHT;
	public static final double BORDER = 10;
	  
    /** Indicates that the row/column should fill the available space */
    public static final double FILL = TableLayout.FILL;

    /**
     * Indicates that the row/column should be allocated just enough space to
     * accomidate the preferred size of all components contained completely
     * within this row/column.
     */
    public static final double PREFERRED = TableLayout.PREFERRED;

    /**
     * Indicates that the row/column should be allocated just enough space to
     * accomidate the minimum size of all components contained completely within
     * this row/column.
     */
    public static final double MINIMUM = TableLayout.MINIMUM;

	public static final double GAP    = SwingUtils.values().STANDARD_FONT_HEIGHT * 5 / 12;
	public static final double GAP0   = SwingUtils.values().STANDARD_FONT_HEIGHT;
	public static final double GAP1   = SwingUtils.values().STANDARD_FONT_HEIGHT * 5 / 3;
	public static final double GAP2   = SwingUtils.values().STANDARD_FONT_HEIGHT * 5 / 2;
	public static final double GAP3   = GAP1 * 2;
	public static final double GAP4   = GAP1 * 3;
	public static final double GAP5   = GAP1 * 4;

//	public enum CellSizing {
//	    	/** Indicates that the row/column should fill the available space */
//		FILL(TableLayout.FILL),
//		    /**
//		     * Indicates that the row/column should be allocated just enough space to
//		     * accomidate the preferred size of all components contained completely
//		     * within this row/column.
//		     */
//		PREFERRED(TableLayout.PREFERRED),
//		    /**
//		     * Indicates that the row/column should be allocated just enough space to
//		     * accomidate the minimum size of all components contained completely within
//		     * this row/column.
//		     */
//		MINIMUM(TableLayout.MINIMUM),
//		
//		;
//		final double sizeId;
//		
//		CellSizing(double sizeId) {
//			this.sizeId = sizeId;
//		}
//
//	}
	
	public static double[] formFieldWidths(double... cols) {
		int size = cols.length * 2 + 1;
		double[] fields = new double[size];
		
		for (int i = 0; i < cols.length; i++) {
			fields[i * 2] = 5;
			fields[i * 2 + 1] = cols[i];
		}
		
		fields[0] = BORDER;
		fields[size-1] = BORDER;
		return fields;
	}
}
