package net.sf.recordEditor.ui.standard.component;

import java.awt.FlowLayout;
import java.awt.LayoutManager;

import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;

import net.sf.recordEditor.ui.def.component.IUiComponent;
import net.sf.recordEditor.ui.styles.IStyle;

@SuppressWarnings("serial")
public abstract class BasicPanel extends JPanel implements IUiComponent{

	public final IStyle style;
	
	private JLabel fieldLabel;
	
	public BasicPanel(IStyle style, LayoutManager layout) {
		super(layout == null ? new FlowLayout() : layout, true);
		
		this.style = style;
	}

	@Override
	public final IStyle getStyleId() {
		return style;
	}

	@Override
	public final JComponent getUiContainer() {
		return this;
	}

	@Override
	public final JLabel getFieldsLabel() {
		return fieldLabel;
	}

	@Override
	public final void setFieldsLabel(JLabel label) {
		this.fieldLabel = label;
	}

}
