package net.sf.recordEditor.ui.xfiles;

import java.io.IOException;
import java.nio.file.Path;
import java.util.regex.Pattern;

/**
 * Regular Expression Based Path filter
 */
public class RegularExpressionPathFilter implements IFileChooserFilter {

	private final String description;
	public final String patternStr;
	private final Pattern pattern;
	
	public RegularExpressionPathFilter(String patternStr) {
		this("", patternStr);
	}
	
	public RegularExpressionPathFilter(String description, String patternStr) {
		this.description = description;
		this.patternStr = patternStr;
		this.pattern = Pattern.compile(patternStr);
	}

	@Override
	public boolean accept(Path entry) throws IOException {
		return entry != null && pattern.matcher(entry.getFileName().toString()).matches();
	}

	@Override
	public String description() {
		return description;
	}

}
