/*
 * Generated by XmplLineBuilder from Velocity template LineProcess.vm
 *
 */
package net.sf.RecordEditor.examples.genCode;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.zip.GZIPInputStream;

import net.sf.JRecord.Common.RecordException;
import net.sf.JRecord.Details.LayoutDetail;
import net.sf.JRecord.IO.AbstractLineReader;
import net.sf.JRecord.IO.LineIOProvider;
import net.sf.RecordEditor.utils.CopyBookDbReader;

/**
 * Generated by XmplLineBuilder from Velocity template LineProcess.vm
 *
 */
public class AmsPoDownloadProcess  {

    private int lineNumber;

    /**
     * process an input file
     *
     * @param fileName filename to process
     *
     * @throws IOException any IO error that occurs
     */
    public void process(String fileName)  throws IOException, RecordException {
        process(fileName, getGroup());
    }


    /**
     * process an input file
     *
     * @param fileName filename to process
     * @param group record layout
     *
     * @throws IOException any IO error that occurs
     */
    public void process(String fileName, LayoutDetail group)  throws IOException, RecordException {
        if (fileName.endsWith(".gz")) {
            FileInputStream rf = new FileInputStream(fileName);

            process(new GZIPInputStream(rf), group);

            rf.close();
        } else {
            process(new FileInputStream(fileName), group);
        }
    }

    /**
     * process an input stream
     *
     * @param file input stream process
     *
     * @throws IOException any IO error that occurs
     */
    public void process(InputStream file) throws IOException, RecordException {
        process(file, getGroup());
    }


    /**
     * get Record Layout
     *
     * @return Record Layout
     */
    private LayoutDetail getGroup() {
        return new CopyBookDbReader().getLayout("ams PO Download");
    }


    /**
     * process an input stream
     *
     * @param file input stream process
     * @param group record layout
     *
     * @throws IOException any IO error that occurs
     */
    public void process(InputStream file, LayoutDetail group) throws IOException, RecordException {
        int        preferedLayout;
        int         fileStructure = group.getFileStructure();
        LineIOProvider ioProvider = new LineIOProvider(new AmsPoDownloadProvider());
        AbstractLineReader      reader = ioProvider.getLineReader(fileStructure);
        AmsPoDownload           line;

        lineNumber = 0;
        reader.open(file, group);
        fileOpen();

        while ((line = (AmsPoDownload) reader.read()) != null) {
            preferedLayout = line.getPreferredLayoutIdx();
            lineNumber += 1;

            if (preferedLayout == AmsPoDownload.getAmsPoDownloadDetailIndex()) {
                processAmsPoDownloadDetail(line);
            } else if (preferedLayout == AmsPoDownload.getAmsPoDownloadHeaderIndex()) {
                processAmsPoDownloadHeader(line);
            } else if (preferedLayout == AmsPoDownload.getAmsPoDownloadAllocationIndex()) {
                processAmsPoDownloadAllocation(line);
            } else {
                unkownRecord(line);
            }
        }

        fileClosed();
        reader.close();
    }


    /**
     * Called after file is opened
     */
    public void fileOpen() { }


    /**
     * Called after file is opened
     */
    public void fileClosed() { }


    /**
     * Called after file is opened
     *
     * @param line Line to be processed
     */
    public void unkownRecord(AmsPoDownload line) { }



    /**
     * process "ams PO Download: Detail"
     * $rec.Details.Description
     *
     * @param line Line to be processed
     *
     * @throws IOException any IO error that occurs
     */
    public void processAmsPoDownloadDetail(AmsPoDownload line)
    throws IOException { }


    /**
     * process "ams PO Download: Header"
     * $rec.Details.Description
     *
     * @param line Line to be processed
     *
     * @throws IOException any IO error that occurs
     */
    public void processAmsPoDownloadHeader(AmsPoDownload line)
    throws IOException { }


    /**
     * process "ams PO Download: Allocation"
     * $rec.Details.Description
     *
     * @param line Line to be processed
     *
     * @throws IOException any IO error that occurs
     */
    public void processAmsPoDownloadAllocation(AmsPoDownload line)
    throws IOException { }


    /**
     * @return Returns the lineNumber.
     */
    public int getLineNumber() {
        return lineNumber;
    }
}
